# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.2.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""persalys module"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _persalys
else:
    import _persalys

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import openturns.base
import openturns.common
import openturns.typ
import openturns.statistics
import openturns.graph
import openturns.func
import openturns.geom
import openturns.iterative_statistics
import openturns.diff
import openturns.optim
import openturns.experiment
import openturns.solver
import openturns.algo
import openturns.uncertainty
import openturns.model_copula
import openturns.randomvector
import openturns.dist_bundle1
import openturns.dist_bundle2
import openturns.weightedexperiment
import openturns.classification
import openturns.orthogonalbasis
import openturns.metamodel
import openturns.transformation
import openturns.analytical
import openturns.simulation
import openturns.stattests
import openturns.model_process
import openturns.dist_bundle3
class Observer(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __swig_destroy__ = _persalys.delete_Observer

    def getType(self):
        return _persalys.Observer_getType(self)

    def update(self, source, message):
        return _persalys.Observer_update(self, source, message)

    def appendItem(self, *args):
        return _persalys.Observer_appendItem(self, *args)

    def __repr__(self):
        return _persalys.Observer___repr__(self)

# Register Observer in _persalys:
_persalys.Observer_swigregister(Observer)
class Observable(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.Observable_swiginit(self, _persalys.new_Observable(*args))
    __swig_destroy__ = _persalys.delete_Observable

# Register Observable in _persalys:
_persalys.Observable_swigregister(Observable)
class VariableCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_VariableCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.VariableCollection_clear(self)

    def __len__(self):
        return _persalys.VariableCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.VariableCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.VariableCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.VariableCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.VariableCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.VariableCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.VariableCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.VariableCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.VariableCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.VariableCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.VariableCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.VariableCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.VariableCollection_find(self, val)

    def __repr__(self):
        return _persalys.VariableCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.VariableCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.VariableCollection_swiginit(self, _persalys.new_VariableCollection(*args))

# Register VariableCollection in _persalys:
_persalys.VariableCollection_swigregister(VariableCollection)
class Variable(openturns.common.PersistentObject):
    r"""
    Create a variable base class.

    Represents a variable.

    Parameters
    ----------
    name : str
        Name
    description : str
        Description text (optional)

    Examples
    --------
    >>> import persalys
    >>> G = persalys.Variable('G', 'deviation')
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.Variable_getClassName(self)

    def __eq__(self, other):
        return _persalys.Variable___eq__(self, other)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.Variable_setName(self, name)

    def getValue(self):
        r"""
        Default value accessor.

        Returns
        -------
        value : float
            Default value
        """
        return _persalys.Variable_getValue(self)

    def setValue(self, value):
        r"""
        Default value accessor.

        Parameters
        ----------
        value : float
            Default value
        """
        return _persalys.Variable_setValue(self, value)

    def getDescription(self):
        r"""
        Description accessor.

        Returns
        -------
        description : :py:class:`openturns.Description`
            Text describing the variable
        """
        return _persalys.Variable_getDescription(self)

    def setDescription(self, description):
        r"""
        Description accessor.

        Parameters
        ----------
        description : str
            Text describing the variable
        """
        return _persalys.Variable_setDescription(self, description)

    def getUnit(self):
        return _persalys.Variable_getUnit(self)

    def setUnit(self, unit):
        return _persalys.Variable_setUnit(self, unit)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.Variable_getPythonScript(self)

    def __init__(self, *args):
        _persalys.Variable_swiginit(self, _persalys.new_Variable(*args))

    def __repr__(self, *args):
        return _persalys.Variable___repr__(self, *args)
    __swig_destroy__ = _persalys.delete_Variable

# Register Variable in _persalys:
_persalys.Variable_swigregister(Variable)
class InputCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_InputCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.InputCollection_clear(self)

    def __len__(self):
        return _persalys.InputCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.InputCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.InputCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.InputCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.InputCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.InputCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.InputCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.InputCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.InputCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.InputCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.InputCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.InputCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.InputCollection_find(self, val)

    def __repr__(self):
        return _persalys.InputCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.InputCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.InputCollection_swiginit(self, _persalys.new_InputCollection(*args))

# Register InputCollection in _persalys:
_persalys.InputCollection_swigregister(InputCollection)
class Input(Variable):
    r"""
    Create an input variable.

    Represents an input variable.

    Parameters
    ----------
    name : str
        Name
    value : float
        Default value
    distribution : :py:class:`~openturns.Distribution`
        Associated distribution
    description : str
        Description text (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> R = persalys.Input('R', ot.Normal(75000., 5000.))
    >>> S = persalys.Input('S', 10.5)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.Input_getClassName(self)

    def __eq__(self, other):
        return _persalys.Input___eq__(self, other)

    def getDistribution(self):
        r"""
        Distribution accessor.

        Returns
        -------
        distribution : :py:class:`openturns.Distribution`
            Distribution associated with the variable
        """
        return _persalys.Input_getDistribution(self)

    def setDistribution(self, distribution):
        r"""
        Distribution accessor.

        Parameters
        ----------
        distribution : :py:class:`openturns.Distribution`
            Distribution associated with the variable
        """
        return _persalys.Input_setDistribution(self, distribution)

    def getDistributionParametersType(self):
        r"""
        Distribution parameters type accessor.

        Returns
        -------
        parametersType : int
            Distribution parameters index
        """
        return _persalys.Input_getDistributionParametersType(self)

    def setDistributionParametersType(self, distributionParametersType):
        r"""
        Distribution parameters type accessor.

        Parameters
        ----------
        parametersType : int
            Distribution parameters index
        """
        return _persalys.Input_setDistributionParametersType(self, distributionParametersType)

    def getFiniteDifferenceStep(self):
        r"""
        Finite difference step accessor.

        Returns
        -------
        step : float
            Finite difference step used to define the gradient of the model's function
        """
        return _persalys.Input_getFiniteDifferenceStep(self)

    def setFiniteDifferenceStep(self, step):
        r"""
        Finite difference step accessor.

        Parameters
        ----------
        step : float
            Finite difference step used to define the gradient and the hessian of the model's function.
            By default the step is equal to 1e-7.
            The gradient function is defined with the first order non-centered finite difference
            scheme and the hessian function with the second order centered finite difference scheme.

        Notes
        -----

        First order non-centered finite difference scheme:

        .. math::

            \frac{\partial f_j}{\partial x_i} \approx \frac{f_j(x + \epsilon_i) - f_j(x)}
                                                           {\epsilon_i}

        Second order centered finite difference scheme:

        .. math::

          \frac{\partial^2 f_k}{\partial x_i \partial x_j} \approx
                                             \frac{
                                                f_k(x + \epsilon_i + \epsilon_j) -
                                                f_k(x + \epsilon_i - \epsilon_j) +
                                                f_k(x - \epsilon_i - \epsilon_j) -
                                                f_k(x - \epsilon_i + \epsilon_j)}
                                             {4 \epsilon_i \epsilon_j}
        """
        return _persalys.Input_setFiniteDifferenceStep(self, step)

    def isStochastic(self):
        r"""
        Whether the variable is stochastic.

        Returns
        -------
        isStochastic : bool
            Whether the variable is stochastic
        """
        return _persalys.Input_isStochastic(self)

    def setStochastic(self, stoch):
        r"""
        Whether the variable is stochastic.

        Parameters
        ----------
        isStochastic : bool
            Whether the variable is stochastic
        """
        return _persalys.Input_setStochastic(self, stoch)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.Input_getPythonScript(self)

    def __repr__(self):
        return _persalys.Input___repr__(self)

    def __init__(self, *args):
        _persalys.Input_swiginit(self, _persalys.new_Input(*args))
    __swig_destroy__ = _persalys.delete_Input

# Register Input in _persalys:
_persalys.Input_swigregister(Input)
class OutputCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_OutputCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.OutputCollection_clear(self)

    def __len__(self):
        return _persalys.OutputCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.OutputCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.OutputCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.OutputCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.OutputCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.OutputCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.OutputCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.OutputCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.OutputCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.OutputCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.OutputCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.OutputCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.OutputCollection_find(self, val)

    def __repr__(self):
        return _persalys.OutputCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.OutputCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.OutputCollection_swiginit(self, _persalys.new_OutputCollection(*args))

# Register OutputCollection in _persalys:
_persalys.OutputCollection_swigregister(OutputCollection)
class Output(Variable):
    r"""
    Create an output variable.

    Represents an output variable.

    Parameters
    ----------
    name : str
        Name
    description : str
        Description text (optional)

    Examples
    --------
    >>> import persalys
    >>> G = persalys.Output('G', 'deviation')
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.Output_getClassName(self)

    def __eq__(self, other):
        return _persalys.Output___eq__(self, other)

    def isSelected(self):
        r"""
        Whether the variable is selected.

        Returns
        -------
        isSelected : bool
            Whether the variable is selected
        """
        return _persalys.Output_isSelected(self)

    def setIsSelected(self, isSelected):
        r"""
        Whether the variable is selected.

        Parameters
        ----------
        isSelected : bool
            Whether the variable is selected
        """
        return _persalys.Output_setIsSelected(self, isSelected)

    def hasBeenComputed(self):
        r"""
        Whether the variable has been evaluated.

        Returns
        -------
        computed : bool
            Whether the variable has been evaluated
        """
        return _persalys.Output_hasBeenComputed(self)

    def setHasBeenComputed(self, hasBeenComputed):
        r"""
        Whether the variable has been evaluated.

        Parameters
        ----------
        computed : bool
            Whether the variable has been evaluated
        """
        return _persalys.Output_setHasBeenComputed(self, hasBeenComputed)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.Output_getPythonScript(self)

    def __repr__(self):
        return _persalys.Output___repr__(self)

    def __init__(self, *args):
        _persalys.Output_swiginit(self, _persalys.new_Output(*args))
    __swig_destroy__ = _persalys.delete_Output

# Register Output in _persalys:
_persalys.Output_swigregister(Output)
class DataSample(openturns.common.PersistentObject):
    r"""
    Class containing an input and an output sample.

    The base class containing an input and an output sample
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getInputSample(self):
        r"""
        Input sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Input sample
        """
        return _persalys.DataSample_getInputSample(self)

    def setInputSample(self, sample):
        r"""
        Input sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Input sample
        """
        return _persalys.DataSample_setInputSample(self, sample)

    def getOutputSample(self):
        r"""
        Output sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Output sample
        """
        return _persalys.DataSample_getOutputSample(self)

    def setOutputSample(self, sample):
        r"""
        Output sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Output sample
        """
        return _persalys.DataSample_setOutputSample(self, sample)

    def getListXMin(self):
        r"""
        List of input values.

        Returns
        -------
        list : SampleCollection
            List of input values
        """
        return _persalys.DataSample_getListXMin(self)

    def getListXMax(self):
        r"""
        List of input values.

        Returns
        -------
        list : SampleCollection
            List of input values
        """
        return _persalys.DataSample_getListXMax(self)

    def getSample(self):
        r"""
        Sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Input sample and output sample
        """
        return _persalys.DataSample_getSample(self)

    def isValid(self):
        r"""
        Whether the model is valid.

        Returns
        -------
        isValid : bool
           Whether the model is valid
        """
        return _persalys.DataSample_isValid(self)

    def __init__(self, *args):
        _persalys.DataSample_swiginit(self, _persalys.new_DataSample(*args))
    __swig_destroy__ = _persalys.delete_DataSample

# Register DataSample in _persalys:
_persalys.DataSample_swigregister(DataSample)
class DataImport(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_DataImport

    def getFileName(self):
        r"""
        File name accessor.

        Returns
        -------
        fileName : str
           Name of the file containing data
        """
        return _persalys.DataImport_getFileName(self)

    def setFileName(self, fileName):
        r"""
        File name accessor.

        Parameters
        ----------
        fileName : str
           Name of the file containing data
        """
        return _persalys.DataImport_setFileName(self, fileName)

    def getInputColumns(self):
        r"""
        Columns of the input variables accessor.

        Returns
        -------
        columns : :py:class:`openturns.Indices`
           Columns of the input variables
        """
        return _persalys.DataImport_getInputColumns(self)

    def getOutputColumns(self):
        r"""
        Columns of the output variables accessor.

        Returns
        -------
        columns : :py:class:`openturns.Indices`
           Columns of the output variables
        """
        return _persalys.DataImport_getOutputColumns(self)

    def getSampleFromFile(self):
        r"""
        Sample from the file accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
           Sample from the file
        """
        return _persalys.DataImport_getSampleFromFile(self)

    def __repr__(self):
        return _persalys.DataImport___repr__(self)

    def __init__(self, *args):
        _persalys.DataImport_swiginit(self, _persalys.new_DataImport(*args))

# Register DataImport in _persalys:
_persalys.DataImport_swigregister(DataImport)
class MeshModelImplementation(openturns.common.PersistentObject):
    r"""
    Create a mesh model base class.

    Notes
    -----
    Can only be used through its derived classes.
    See :class:`~persalys.GridMeshModel`, :class:`~persalys.ImportedMeshModel`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MeshModelImplementation_getClassName(self)

    def getMesh(self):
        r"""
        Mesh accessor.

        Returns
        -------
        mesh : :py:class:`openturns.Mesh`
            Mesh
        """
        return _persalys.MeshModelImplementation_getMesh(self)

    def getIndexParameters(self):
        r"""
        Index parameters accessor.

        Returns
        -------
        parameters : sequence of :class:`persalys.Variable`
            Index parameters
        """
        return _persalys.MeshModelImplementation_getIndexParameters(self)

    def setIndexParameters(self, parameters):
        r"""
        Index parameters accessor.

        Parameters
        ----------
        parameters : sequence of :class:`persalys.Variable`
            Index parameters
        """
        return _persalys.MeshModelImplementation_setIndexParameters(self, parameters)

    def getBounds(self):
        r"""
        Get bounds of the mesh nodes accessor.

        Returns
        -------
        bounds : :py:class:`openturns.Interval`
            Bounds of the mesh nodes along each direction
        """
        return _persalys.MeshModelImplementation_getBounds(self)

    def getNumberOfNodes(self):
        r"""
        Number of nodes accessor.

        Returns
        -------
        number : :py:class:`openturns.Indices`
            Number of nodes along each direction
        """
        return _persalys.MeshModelImplementation_getNumberOfNodes(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.MeshModelImplementation_getPythonScript(self)

    def __repr__(self):
        return _persalys.MeshModelImplementation___repr__(self)

    def __init__(self, *args):
        _persalys.MeshModelImplementation_swiginit(self, _persalys.new_MeshModelImplementation(*args))
    __swig_destroy__ = _persalys.delete_MeshModelImplementation

# Register MeshModelImplementation in _persalys:
_persalys.MeshModelImplementation_swigregister(MeshModelImplementation)
class MeshModelImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.MeshModelImplementationTypedInterfaceObject_swiginit(self, _persalys.new_MeshModelImplementationTypedInterfaceObject(*args))

    def getImplementation(self):
        r"""
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            A copy of the underlying implementation object.
        """
        return _persalys.MeshModelImplementationTypedInterfaceObject_getImplementation(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.MeshModelImplementationTypedInterfaceObject_setName(self, name)

    def getName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _persalys.MeshModelImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, other):
        return _persalys.MeshModelImplementationTypedInterfaceObject___eq__(self, other)

    def __ne__(self, other):
        return _persalys.MeshModelImplementationTypedInterfaceObject___ne__(self, other)
    __swig_destroy__ = _persalys.delete_MeshModelImplementationTypedInterfaceObject

# Register MeshModelImplementationTypedInterfaceObject in _persalys:
_persalys.MeshModelImplementationTypedInterfaceObject_swigregister(MeshModelImplementationTypedInterfaceObject)
class MeshModelCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_MeshModelCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.MeshModelCollection_clear(self)

    def __len__(self):
        return _persalys.MeshModelCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.MeshModelCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.MeshModelCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.MeshModelCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.MeshModelCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.MeshModelCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.MeshModelCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.MeshModelCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.MeshModelCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.MeshModelCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.MeshModelCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.MeshModelCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.MeshModelCollection_find(self, val)

    def __repr__(self):
        return _persalys.MeshModelCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.MeshModelCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.MeshModelCollection_swiginit(self, _persalys.new_MeshModelCollection(*args))

# Register MeshModelCollection in _persalys:
_persalys.MeshModelCollection_swigregister(MeshModelCollection)
class MeshModel(MeshModelImplementationTypedInterfaceObject):
    r"""
    Create a mesh model base class.

    Notes
    -----
    Can only be used through its derived classes.
    See :class:`~persalys.GridMeshModel`, :class:`~persalys.ImportedMeshModel`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    @staticmethod
    def GetClassName():
        return _persalys.MeshModel_GetClassName()

    def getClassName(self):
        return _persalys.MeshModel_getClassName(self)

    def getMesh(self):
        r"""
        Mesh accessor.

        Returns
        -------
        mesh : :py:class:`openturns.Mesh`
            Mesh
        """
        return _persalys.MeshModel_getMesh(self)

    def getIndexParameters(self):
        r"""
        Index parameters accessor.

        Returns
        -------
        parameters : sequence of :class:`persalys.Variable`
            Index parameters
        """
        return _persalys.MeshModel_getIndexParameters(self)

    def setIndexParameters(self, parameters):
        r"""
        Index parameters accessor.

        Parameters
        ----------
        parameters : sequence of :class:`persalys.Variable`
            Index parameters
        """
        return _persalys.MeshModel_setIndexParameters(self, parameters)

    def getBounds(self):
        r"""
        Get bounds of the mesh nodes accessor.

        Returns
        -------
        bounds : :py:class:`openturns.Interval`
            Bounds of the mesh nodes along each direction
        """
        return _persalys.MeshModel_getBounds(self)

    def getNumberOfNodes(self):
        r"""
        Number of nodes accessor.

        Returns
        -------
        number : :py:class:`openturns.Indices`
            Number of nodes along each direction
        """
        return _persalys.MeshModel_getNumberOfNodes(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.MeshModel_getPythonScript(self)

    def __init__(self, *args):
        _persalys.MeshModel_swiginit(self, _persalys.new_MeshModel(*args))
    __swig_destroy__ = _persalys.delete_MeshModel

# Register MeshModel in _persalys:
_persalys.MeshModel_swigregister(MeshModel)
class GridMeshModel(MeshModelImplementation):
    r"""
    Create a model to build regular meshes.

    Available constructors:
        GridMeshModel(*parameters, bounds, nbNodes*)

    Parameters
    ----------
    parameters : sequence of :class:`persalys.Variable`
        Sequence of index parameters (optional). By default
        the index parameter is named **t**
    bounds : :py:class:`openturns.Interval`
        Mesh bounds along each direction
    nbNodes : sequence of int
        Number of nodes along each direction

    Notes
    -----
    The sequences must have a dimension equal to the number of index parameters.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the mesh model:

    >>> meshModel = persalys.GridMeshModel([persalys.Variable('x', 'aDescription')], ot.Interval(0., 12.), [10])

    Create the model:

    >>> z0 = persalys.Input('z0', 100)
    >>> v0 = persalys.Input('v0', 55)
    >>> m = persalys.Input('m', 80)
    >>> c = persalys.Input('c', 15)
    >>> z = persalys.Output('z')
    >>> formula = ['max(0, z0 + (m * 9.81 / c) * x + (m / c) * (v0 - (m * 9.81 / c)) * (1 - exp(-x * c / m)))']
    >>> model = persalys.SymbolicFieldModel('model', meshModel, [z0, v0, m, c], [z], formula)

    >>> y = model.getPointToFieldFunction()([100, 55, 80, 15])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.GridMeshModel_getClassName(self)

    def setParameters(self, bounds, nbNodes):
        r"""
        Parameters accessor.

        Parameters
        ----------
        bounds : :py:class:`openturns.Interval`
            Mesh bounds along each direction
        nbNodes : sequence of int
            Number of nodes along each direction
        """
        return _persalys.GridMeshModel_setParameters(self, bounds, nbNodes)

    def getBounds(self):
        r"""
        Get bounds of the mesh nodes accessor.

        Returns
        -------
        bounds : :py:class:`openturns.Interval`
            Bounds of the mesh nodes along each direction
        """
        return _persalys.GridMeshModel_getBounds(self)

    def getNumberOfNodes(self):
        r"""
        Number of nodes accessor.

        Returns
        -------
        number : :py:class:`openturns.Indices`
            Number of nodes along each direction
        """
        return _persalys.GridMeshModel_getNumberOfNodes(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.GridMeshModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.GridMeshModel___repr__(self)

    def __init__(self, *args):
        _persalys.GridMeshModel_swiginit(self, _persalys.new_GridMeshModel(*args))
    __swig_destroy__ = _persalys.delete_GridMeshModel

# Register GridMeshModel in _persalys:
_persalys.GridMeshModel_swigregister(GridMeshModel)
class ImportedMeshModel(MeshModelImplementation, DataImport):
    r"""
    Create a model with imported meshes

    Available constructors:
        ImportedMeshModel(*parameters, fileName, columns*)

    Parameters
    ----------
    parameters : sequence of :class:`persalys.Variable`
        Sequence of index parameters (optional). By default
        the index parameter is named **t**
    fileName : str
        Name of a data file to load
    columns : sequence of int
        Indices of columns in files to consider. The sequence dimension
        must have a dimension equal to the number of index parameters

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the mesh model:

    >>> mesh = ot.IntervalMesher(ot.Indices(1, 20)).build(ot.Interval(0., 12.))
    >>> mesh.getVertices().exportToCSVFile('mesh.csv')

    >>> meshModel = persalys.ImportedMeshModel([persalys.Variable('x', 'aDescription')], 'mesh.csv', [0])

    Create the model:

    >>> z0 = persalys.Input('z0', 100)
    >>> v0 = persalys.Input('v0', 55)
    >>> m = persalys.Input('m', 80)
    >>> c = persalys.Input('c', 15)
    >>> z = persalys.Output('z')
    >>> formula = ['max(0, z0 + (m * 9.81 / c) * x + (m / c) * (v0 - (m * 9.81 / c)) * (1 - exp(-x * c / m)))']
    >>> model = persalys.SymbolicFieldModel('model', meshModel , [z0, v0, m, c], [z], formula)

    >>> y = model.getPointToFieldFunction()([100, 55, 80, 15])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.ImportedMeshModel_getClassName(self)

    def setParameterColumns(self, inputColumns):
        r"""
        Columns of the index parameters accessor.

        Parameters
        ----------
        columns : sequence of int
           Indices of columns in file of the index parameters
        """
        return _persalys.ImportedMeshModel_setParameterColumns(self, inputColumns)

    def getBounds(self):
        r"""
        Get bounds of the mesh nodes accessor.

        Returns
        -------
        bounds : :py:class:`openturns.Interval`
            Bounds of the mesh nodes along each direction
        """
        return _persalys.ImportedMeshModel_getBounds(self)

    def getNumberOfNodes(self):
        r"""
        Number of nodes accessor.

        Returns
        -------
        number : :py:class:`openturns.Indices`
            Number of nodes along each direction
        """
        return _persalys.ImportedMeshModel_getNumberOfNodes(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.ImportedMeshModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.ImportedMeshModel___repr__(self)

    def __init__(self, *args):
        _persalys.ImportedMeshModel_swiginit(self, _persalys.new_ImportedMeshModel(*args))
    __swig_destroy__ = _persalys.delete_ImportedMeshModel

# Register ImportedMeshModel in _persalys:
_persalys.ImportedMeshModel_swigregister(ImportedMeshModel)
class PhysicalModelImplementation(openturns.common.PersistentObject, Observable):
    r"""
    Physical model base class.

    Notes
    -----
    Can only be used through its derived classes.
    See :class:`~persalys.SymbolicPhysicalModel`, :class:`~persalys.PythonPhysicalModel`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.PhysicalModelImplementation_setName(self, name)

    def __eq__(self, other):
        return _persalys.PhysicalModelImplementation___eq__(self, other)

    def __ne__(self, other):
        return _persalys.PhysicalModelImplementation___ne__(self, other)

    def getInputDimension(self):
        r"""
        Number of input variables accessor.

        Returns
        -------
        dimension : int
            Number of input variables
        """
        return _persalys.PhysicalModelImplementation_getInputDimension(self)

    def getInputs(self):
        r"""
        Input variables accessor.

        Returns
        -------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.PhysicalModelImplementation_getInputs(self)

    def getInputByName(self, *args):
        r"""
        Input variable accessor.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        input : :class:`~persalys.Input`
            Input variable
        """
        return _persalys.PhysicalModelImplementation_getInputByName(self, *args)

    def setInputs(self, inputs):
        r"""
        Input variables accessor.

        Parameters
        ----------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.PhysicalModelImplementation_setInputs(self, inputs)

    def setInputName(self, inputName, newName):
        r"""
        Input variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        newName : str
            New name
        """
        return _persalys.PhysicalModelImplementation_setInputName(self, inputName, newName)

    def setInputDescription(self, inputName, description):
        r"""
        Input description accessor.

        Parameters
        ----------
        name : str
            Variable name
        description : str
            Description text
        """
        return _persalys.PhysicalModelImplementation_setInputDescription(self, inputName, description)

    def setInputValue(self, inputName, value):
        r"""
        Input variable value accessor.

        Parameters
        ----------
        name : str
            Variable name
        value : float
            New value
        """
        return _persalys.PhysicalModelImplementation_setInputValue(self, inputName, value)

    def setInputStochastic(self, inputName, stoch):
        r"""
        Whether the input variable is stochastic.

        Parameters
        ----------
        name : str
            Variable name
        isStochastic : bool
            Whether the input variable is stochastic
        """
        return _persalys.PhysicalModelImplementation_setInputStochastic(self, inputName, stoch)

    def setDistribution(self, inputName, distribution):
        r"""
        Input distribution accessor.

        Parameters
        ----------
        name : str
            Variable name
        distribution : :py:class:`openturns.Distribution`
            Variable distribution
        """
        return _persalys.PhysicalModelImplementation_setDistribution(self, inputName, distribution)

    def setDistributionParametersType(self, inputName, distributionParametersType):
        r"""
        Input distribution parameter type accessor.

        Parameters
        ----------
        name : str
            Variable name
        parametersType : int
            Distribution parameter type accessor
        """
        return _persalys.PhysicalModelImplementation_setDistributionParametersType(self, inputName, distributionParametersType)

    def setFiniteDifferenceStep(self, inputName, step):
        r"""
        Finite difference step accessor.

        Parameters
        ----------
        name : str
            Variable name
        step : float
            Finite difference step used to define the gradient of the model's function
        """
        return _persalys.PhysicalModelImplementation_setFiniteDifferenceStep(self, inputName, step)

    def addInput(self, input):
        r"""
        Add an input variable.

        Parameters
        ----------
        input : :class:`~persalys.Input`
            New variable
        """
        return _persalys.PhysicalModelImplementation_addInput(self, input)

    def removeInput(self, inputName):
        r"""
        Remove an input variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.PhysicalModelImplementation_removeInput(self, inputName)

    def clearInputs(self):
        r"""Remove all the input variables."""
        return _persalys.PhysicalModelImplementation_clearInputs(self)

    def getInputNames(self):
        r"""
        Input variable names accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Input variable names
        """
        return _persalys.PhysicalModelImplementation_getInputNames(self)

    def getStochasticInputNames(self):
        r"""
        Accessor to the names of the stochastic input variables.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Names of the stochastic input variables
        """
        return _persalys.PhysicalModelImplementation_getStochasticInputNames(self)

    def hasInputNamed(self, inputName):
        r"""
        Check if an input has the given name.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        has : bool
            Whether an input has the given name
        """
        return _persalys.PhysicalModelImplementation_hasInputNamed(self, inputName)

    def hasStochasticInputs(self):
        r"""
        Whether it contains stochastic variables.

        Returns
        -------
        has : bool
            Whether it contains stochastic variables
        """
        return _persalys.PhysicalModelImplementation_hasStochasticInputs(self)

    def getOutputDimension(self):
        r"""
        Number of output variables accessor.

        Returns
        -------
        dimension : int
            Number of output variables
        """
        return _persalys.PhysicalModelImplementation_getOutputDimension(self)

    def getOutputs(self):
        r"""
        Output variables accessor.

        Returns
        -------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.PhysicalModelImplementation_getOutputs(self)

    def getOutputByName(self, *args):
        r"""
        Output variable accessor.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        input : :class:`~persalys.Output`
            Output variable
        """
        return _persalys.PhysicalModelImplementation_getOutputByName(self, *args)

    def setOutputs(self, outputs):
        r"""
        Output variables accessor.

        Parameters
        ----------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.PhysicalModelImplementation_setOutputs(self, outputs)

    def setOutputName(self, outputName, newName):
        r"""
        Output variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        newName : str
            New name
        """
        return _persalys.PhysicalModelImplementation_setOutputName(self, outputName, newName)

    def setOutputDescription(self, outputName, description):
        r"""
        Output description accessor.

        Parameters
        ----------
        name : str
            Variable name
        description : str
            Description text
        """
        return _persalys.PhysicalModelImplementation_setOutputDescription(self, outputName, description)

    def setOutputValue(self, outputName, value):
        r"""
        Output variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        value : float
            New value
        """
        return _persalys.PhysicalModelImplementation_setOutputValue(self, outputName, value)

    def selectOutput(self, outputName, selected):
        r"""
        Select output.

        Parameters
        ----------
        name : str
            Output name
        isSelected : bool
            Whether it is selected
        """
        return _persalys.PhysicalModelImplementation_selectOutput(self, outputName, selected)

    def addOutput(self, output):
        r"""
        Add an output variable.

        Parameters
        ----------
        output : :class:`~persalys.Output`
            New variable
        """
        return _persalys.PhysicalModelImplementation_addOutput(self, output)

    def removeOutput(self, outputName):
        r"""
        Remove an output variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.PhysicalModelImplementation_removeOutput(self, outputName)

    def clearOutputs(self):
        r"""Remove all the output variables."""
        return _persalys.PhysicalModelImplementation_clearOutputs(self)

    def getOutputNames(self):
        r"""
        Output variable names accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Output variable names
        """
        return _persalys.PhysicalModelImplementation_getOutputNames(self)

    def hasOutputNamed(self, outputName):
        r"""
        Check if an output has the given name.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        has : bool
            Whether an output has the given name
        """
        return _persalys.PhysicalModelImplementation_hasOutputNamed(self, outputName)

    def getSelectedOutputsNames(self):
        r"""
        Accessor to the selected outputs names.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Selected outputs names
        """
        return _persalys.PhysicalModelImplementation_getSelectedOutputsNames(self)

    def getDistribution(self):
        r"""
        Distribution accessor.

        Parameters
        ----------
        Distribution : :py:class:`openturns.JointDistribution`
            The composed distribution (marginals and dependence)
        """
        return _persalys.PhysicalModelImplementation_getDistribution(self)

    def getInputRandomVector(self):
        r"""
        Input random vector accessor.

        Returns
        -------
        names : :py:class:`openturns.RandomVector`
            Input random vector
        """
        return _persalys.PhysicalModelImplementation_getInputRandomVector(self)

    def getOutputRandomVector(self, outputNames):
        r"""
        Output random vector accessor.

        Returns
        -------
        names : :py:class:`openturns.RandomVector`
            Output random vector
        """
        return _persalys.PhysicalModelImplementation_getOutputRandomVector(self, outputNames)

    def getFunction(self, *args):
        r"""
        Accessor to the underlying function.

        Parameters
        ----------
        outputNames : sequence of str
            Names of the outputs to be evaluated (optional)

        Returns
        -------
        function : :py:class:`openturns.Function`
            Function evaluating the outputs
        """
        return _persalys.PhysicalModelImplementation_getFunction(self, *args)

    def getRestrictedFunction(self, *args):
        r"""
        Accessor to the function restricted to its stochastic inputs.

        Parameters
        ----------
        outputNames : sequence of str
            Output variables (optional)

        Returns
        -------
        restricted : :py:class:`openturns.Function`
            Stochastic function
        """
        return _persalys.PhysicalModelImplementation_getRestrictedFunction(self, *args)

    def getPointToFieldFunction(self, *args):
        r"""
        Accessor to the underlying function.

        Parameters
        ----------
        outputNames : sequence of str
            Names of the outputs to be evaluated (optional)

        Returns
        -------
        function : :py:class:`openturns.PointToFieldFunction`
            Function evaluating the outputs along the mesh nodes
        """
        return _persalys.PhysicalModelImplementation_getPointToFieldFunction(self, *args)

    def getRestrictedPointToFieldFunction(self, outputNames):
        r"""
        Accessor to the field function restricted to its stochastic inputs.

        Parameters
        ----------
        outputNames : sequence of str
            Output variables (optional)

        Returns
        -------
        restricted : :py:class:`openturns.PointToFieldFunction`
            Stochastic field function (for model with mesh)
        """
        return _persalys.PhysicalModelImplementation_getRestrictedPointToFieldFunction(self, outputNames)

    def getCopula(self):
        r"""
        Copula accessor.

        Parameters
        ----------
        copula : :py:class:`openturns.Copula`
            The copula
        """
        return _persalys.PhysicalModelImplementation_getCopula(self)

    def setCopula(self, inputNames, copula):
        r"""
        Copula accessor.

        Parameters
        ----------
        copula : :py:class:`openturns.Copula`
            The copula
        """
        return _persalys.PhysicalModelImplementation_setCopula(self, inputNames, copula)

    def hasMesh(self):
        r"""
        Whether the model has a mesh.

        Returns
        -------
        hasMesh : bool
            Whether the model has a mesh
        """
        return _persalys.PhysicalModelImplementation_hasMesh(self)

    def getMeshModel(self):
        r"""
        Mesh model accessor.

        Returns
        -------
        mesh : :class:`~persalys.MeshModel`
            Mesh model
        """
        return _persalys.PhysicalModelImplementation_getMeshModel(self)

    def setMeshModel(self, meshModel):
        r"""
        Mesh model accessor.

        Parameters
        ----------
        mesh : :class:`~persalys.MeshModel`
            Mesh model
        """
        return _persalys.PhysicalModelImplementation_setMeshModel(self, meshModel)

    def getEvalTime(self):
        r"""
        Evaluation time accessor.

        Returns
        -------
        evalTime : float
            Evaluation time
        """
        return _persalys.PhysicalModelImplementation_getEvalTime(self)

    def setEvalTime(self, evalTime):
        r"""
        Evaluation time accessor.

        Parameters
        ----------
        evalTime : float
            Evaluation time
        """
        return _persalys.PhysicalModelImplementation_setEvalTime(self, evalTime)

    def isParallel(self):
        r"""
        Whether the evaluations of the model are parallelized.

        Returns
        -------
        isParallel : bool
            Whether the evaluations of the model are parallelized (available only for the Python model)
        """
        return _persalys.PhysicalModelImplementation_isParallel(self)

    def setParallel(self, flag):
        r"""
        Whether the evaluations of the model are parallelized.

        Parameters
        ----------
        isParallel : bool
            Whether the evaluations of the model are parallelized

        Notes
        -----
        This is only implemented for the Python model.
        Also, on Windows platforms, ProcessPoolExecutor startup time being much higher,
        you may want to evaluate enough points in batch rather than many small blocks.
        Refer to the *setBlockSize* method of the various algorithms.

        """
        return _persalys.PhysicalModelImplementation_setParallel(self, flag)

    def getProcessNumber(self):
        r"""
        Number of concurrent processes.

        Returns
        -------
        process_number : int
            Maximum number of processes
        """
        return _persalys.PhysicalModelImplementation_getProcessNumber(self)

    def setProcessNumber(self, processNumber):
        r"""
        Number of concurrent processes.

        Parameters
        ----------
        process_number : int
            Maximum number of processes
        """
        return _persalys.PhysicalModelImplementation_setProcessNumber(self, processNumber)

    def isValid(self):
        r"""
        Whether it is valid.

        Returns
        -------
        isValid : bool
            Whether it is valid
        """
        return _persalys.PhysicalModelImplementation_isValid(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.PhysicalModelImplementation_getPythonScript(self)

    def exportStandalonePythonScript(self, fileName):
        r"""
        Export the model into a Python script.

        In the case of metamodels the script only depends on OpenTURNS
        and is meant to be used out of Persalys.

        Parameters
        ----------
        fileName : str
            Path of the exported script
        """
        return _persalys.PhysicalModelImplementation_exportStandalonePythonScript(self, fileName)

    def __repr__(self):
        return _persalys.PhysicalModelImplementation___repr__(self)

    def __init__(self, *args):
        _persalys.PhysicalModelImplementation_swiginit(self, _persalys.new_PhysicalModelImplementation(*args))
    __swig_destroy__ = _persalys.delete_PhysicalModelImplementation

# Register PhysicalModelImplementation in _persalys:
_persalys.PhysicalModelImplementation_swigregister(PhysicalModelImplementation)
class SymbolicPhysicalModel(PhysicalModelImplementation):
    r"""
    Create a physical model defined by analytical formulas.

    Parameters
    ----------
    name : str
        Name
    inputs : sequence of :class:`~persalys.Input`
        Input variables (optional)
    outputs : sequence of :class:`~persalys.Output`
        Output variables (optional)
    formulas : sequence of str
        List of analytical formulas between the inputs and the outputs (optional).
        The function is defined by outputs = formulas(inputs).

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> model = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    >>> y = model.getFunction()([300.0,75000.0])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SymbolicPhysicalModel_getClassName(self)

    def addOutput(self, output):
        r"""
        Add an output variable.

        Parameters
        ----------
        output : :class:`~persalys.Output`
            New variable
        """
        return _persalys.SymbolicPhysicalModel_addOutput(self, output)

    def removeOutput(self, outputName):
        r"""
        Remove an output variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.SymbolicPhysicalModel_removeOutput(self, outputName)

    def setOutputs(self, outputs):
        r"""
        Output variables accessor.

        Parameters
        ----------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.SymbolicPhysicalModel_setOutputs(self, outputs)

    def setOutputName(self, outputName, newName):
        r"""
        Output variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        newName : str
            New name
        """
        return _persalys.SymbolicPhysicalModel_setOutputName(self, outputName, newName)

    def getFormulas(self):
        r"""
        Formulas accessor.

        Returns
        -------
        formulas : :py:class:`openturns.Description`
            Output formulas
        """
        return _persalys.SymbolicPhysicalModel_getFormulas(self)

    def setFormulas(self, formulas):
        r"""
        Formulas accessor.

        Parameters
        ----------
        formulas : sequence of str
            Output formulas
        """
        return _persalys.SymbolicPhysicalModel_setFormulas(self, formulas)

    def getFormula(self, outputName):
        r"""
        Output formula accessor.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        formula : str
            Formula text
        """
        return _persalys.SymbolicPhysicalModel_getFormula(self, outputName)

    def setFormula(self, outputName, formula):
        r"""
        Output formula accessor.

        Parameters
        ----------
        name : str
            Variable name
        formula : str
            Formula text
        """
        return _persalys.SymbolicPhysicalModel_setFormula(self, outputName, formula)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.SymbolicPhysicalModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.SymbolicPhysicalModel___repr__(self)

    def __init__(self, *args):
        _persalys.SymbolicPhysicalModel_swiginit(self, _persalys.new_SymbolicPhysicalModel(*args))
    __swig_destroy__ = _persalys.delete_SymbolicPhysicalModel

# Register SymbolicPhysicalModel in _persalys:
_persalys.SymbolicPhysicalModel_swigregister(SymbolicPhysicalModel)
class PythonPhysicalModel(PhysicalModelImplementation):
    r"""
    Create a physical model defined by Python code.

    Parameters
    ----------
    name : str
        Name
    inputs : sequence of :class:`~persalys.Input`
        Input variables (optional)
    outputs : sequence of :class:`~persalys.Output`
        Output variables (optional)
    code : str
        Code string (optional)

    Notes
    -----
    The code string must contain a function named '_exec' that takes float
    arguments and return a float or a sequence of floats.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> code = 'from math import pi\n\ndef _exec(R, F):\n    G = R-F/(pi*100.0)\n    return G\n'
    >>> model = persalys.PythonPhysicalModel('myPhysicalModel', [R, F], [G], code)
    >>> y = model.getFunction()([300.0,75000.0])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.PythonPhysicalModel_getClassName(self)

    def setCode(self, code):
        r"""
        Code accessor.

        Parameters
        ----------
        code : str
            Code text
        """
        return _persalys.PythonPhysicalModel_setCode(self, code)

    def getCode(self):
        r"""
        Code accessor.

        Returns
        -------
        code : str
            Code text
        """
        return _persalys.PythonPhysicalModel_getCode(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.PythonPhysicalModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.PythonPhysicalModel___repr__(self)

    def setInputs(self, inputs):
        r"""
        Input variables accessor.

        Parameters
        ----------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.PythonPhysicalModel_setInputs(self, inputs)

    def addInput(self, input):
        r"""
        Add an input variable.

        Parameters
        ----------
        input : :class:`~persalys.Input`
            New variable
        """
        return _persalys.PythonPhysicalModel_addInput(self, input)

    def removeInput(self, inputName):
        r"""
        Remove an input variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.PythonPhysicalModel_removeInput(self, inputName)

    def setOutputs(self, outputs):
        r"""
        Output variables accessor.

        Parameters
        ----------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.PythonPhysicalModel_setOutputs(self, outputs)

    def addOutput(self, output):
        r"""
        Add an output variable.

        Parameters
        ----------
        output : :class:`~persalys.Output`
            New variable
        """
        return _persalys.PythonPhysicalModel_addOutput(self, output)

    def removeOutput(self, outputName):
        r"""
        Remove an output variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.PythonPhysicalModel_removeOutput(self, outputName)

    def setParallel(self, flag):
        r"""
        Whether the evaluations of the model are parallelized.

        Parameters
        ----------
        isParallel : bool
            Whether the evaluations of the model are parallelized

        Notes
        -----
        This is only implemented for the Python model.
        Also, on Windows platforms, ProcessPoolExecutor startup time being much higher,
        you may want to evaluate enough points in batch rather than many small blocks.
        Refer to the *setBlockSize* method of the various algorithms.

        """
        return _persalys.PythonPhysicalModel_setParallel(self, flag)

    def setEvalTime(self, evalTime):
        r"""
        Evaluation time accessor.

        Parameters
        ----------
        evalTime : float
            Evaluation time
        """
        return _persalys.PythonPhysicalModel_setEvalTime(self, evalTime)

    def getEvalTime(self):
        r"""
        Evaluation time accessor.

        Returns
        -------
        evalTime : float
            Evaluation time
        """
        return _persalys.PythonPhysicalModel_getEvalTime(self)

    def __init__(self, *args):
        _persalys.PythonPhysicalModel_swiginit(self, _persalys.new_PythonPhysicalModel(*args))
    __swig_destroy__ = _persalys.delete_PythonPhysicalModel

# Register PythonPhysicalModel in _persalys:
_persalys.PythonPhysicalModel_swigregister(PythonPhysicalModel)
class MetaModel(PhysicalModelImplementation):
    r"""
    Metamodel.

    Parameters
    ----------
    name : str
        Name
    function : :py:class:`openturns.Function`
        Function (optional)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MetaModel_getClassName(self)

    def setFunction(self, function):
        r"""
        Metamodel function accessor.

        Parameters
        ----------
        function : :py:class:`openturns.Function`
            Metamodel function
        """
        return _persalys.MetaModel_setFunction(self, function)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.MetaModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.MetaModel___repr__(self)

    def __init__(self, *args):
        _persalys.MetaModel_swiginit(self, _persalys.new_MetaModel(*args))
    __swig_destroy__ = _persalys.delete_MetaModel

# Register MetaModel in _persalys:
_persalys.MetaModel_swigregister(MetaModel)
class PhysicalModelImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.PhysicalModelImplementationTypedInterfaceObject_swiginit(self, _persalys.new_PhysicalModelImplementationTypedInterfaceObject(*args))

    def getImplementation(self):
        r"""
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            A copy of the underlying implementation object.
        """
        return _persalys.PhysicalModelImplementationTypedInterfaceObject_getImplementation(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.PhysicalModelImplementationTypedInterfaceObject_setName(self, name)

    def getName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _persalys.PhysicalModelImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, other):
        return _persalys.PhysicalModelImplementationTypedInterfaceObject___eq__(self, other)

    def __ne__(self, other):
        return _persalys.PhysicalModelImplementationTypedInterfaceObject___ne__(self, other)
    __swig_destroy__ = _persalys.delete_PhysicalModelImplementationTypedInterfaceObject

# Register PhysicalModelImplementationTypedInterfaceObject in _persalys:
_persalys.PhysicalModelImplementationTypedInterfaceObject_swigregister(PhysicalModelImplementationTypedInterfaceObject)
class PhysicalModelCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_PhysicalModelCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.PhysicalModelCollection_clear(self)

    def __len__(self):
        return _persalys.PhysicalModelCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.PhysicalModelCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.PhysicalModelCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.PhysicalModelCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.PhysicalModelCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.PhysicalModelCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.PhysicalModelCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.PhysicalModelCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.PhysicalModelCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.PhysicalModelCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.PhysicalModelCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.PhysicalModelCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.PhysicalModelCollection_find(self, val)

    def __repr__(self):
        return _persalys.PhysicalModelCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.PhysicalModelCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.PhysicalModelCollection_swiginit(self, _persalys.new_PhysicalModelCollection(*args))

# Register PhysicalModelCollection in _persalys:
_persalys.PhysicalModelCollection_swigregister(PhysicalModelCollection)
class PhysicalModel(PhysicalModelImplementationTypedInterfaceObject):
    r"""
    Physical model base class.

    Notes
    -----
    Can only be used through its derived classes.
    See :class:`~persalys.SymbolicPhysicalModel`, :class:`~persalys.PythonPhysicalModel`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    @staticmethod
    def GetClassName():
        return _persalys.PhysicalModel_GetClassName()

    def getClassName(self):
        return _persalys.PhysicalModel_getClassName(self)

    def __eq__(self, other):
        return _persalys.PhysicalModel___eq__(self, other)

    def __ne__(self, other):
        return _persalys.PhysicalModel___ne__(self, other)

    def getInputDimension(self):
        r"""
        Number of input variables accessor.

        Returns
        -------
        dimension : int
            Number of input variables
        """
        return _persalys.PhysicalModel_getInputDimension(self)

    def getInputs(self):
        r"""
        Input variables accessor.

        Returns
        -------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.PhysicalModel_getInputs(self)

    def getInputByName(self, *args):
        r"""
        Input variable accessor.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        input : :class:`~persalys.Input`
            Input variable
        """
        return _persalys.PhysicalModel_getInputByName(self, *args)

    def setInputs(self, inputs):
        r"""
        Input variables accessor.

        Parameters
        ----------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.PhysicalModel_setInputs(self, inputs)

    def setInputName(self, inputName, newName):
        r"""
        Input variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        newName : str
            New name
        """
        return _persalys.PhysicalModel_setInputName(self, inputName, newName)

    def setInputDescription(self, inputName, description):
        r"""
        Input description accessor.

        Parameters
        ----------
        name : str
            Variable name
        description : str
            Description text
        """
        return _persalys.PhysicalModel_setInputDescription(self, inputName, description)

    def setInputValue(self, inputName, value):
        r"""
        Input variable value accessor.

        Parameters
        ----------
        name : str
            Variable name
        value : float
            New value
        """
        return _persalys.PhysicalModel_setInputValue(self, inputName, value)

    def setInputStochastic(self, inputName, stoch):
        r"""
        Whether the input variable is stochastic.

        Parameters
        ----------
        name : str
            Variable name
        isStochastic : bool
            Whether the input variable is stochastic
        """
        return _persalys.PhysicalModel_setInputStochastic(self, inputName, stoch)

    def setDistribution(self, inputName, distribution):
        r"""
        Input distribution accessor.

        Parameters
        ----------
        name : str
            Variable name
        distribution : :py:class:`openturns.Distribution`
            Variable distribution
        """
        return _persalys.PhysicalModel_setDistribution(self, inputName, distribution)

    def setDistributionParametersType(self, inputName, distributionParametersType):
        r"""
        Input distribution parameter type accessor.

        Parameters
        ----------
        name : str
            Variable name
        parametersType : int
            Distribution parameter type accessor
        """
        return _persalys.PhysicalModel_setDistributionParametersType(self, inputName, distributionParametersType)

    def setFiniteDifferenceStep(self, inputName, step):
        r"""
        Finite difference step accessor.

        Parameters
        ----------
        name : str
            Variable name
        step : float
            Finite difference step used to define the gradient of the model's function
        """
        return _persalys.PhysicalModel_setFiniteDifferenceStep(self, inputName, step)

    def addInput(self, input):
        r"""
        Add an input variable.

        Parameters
        ----------
        input : :class:`~persalys.Input`
            New variable
        """
        return _persalys.PhysicalModel_addInput(self, input)

    def removeInput(self, inputName):
        r"""
        Remove an input variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.PhysicalModel_removeInput(self, inputName)

    def getInputNames(self):
        r"""
        Input variable names accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Input variable names
        """
        return _persalys.PhysicalModel_getInputNames(self)

    def getStochasticInputNames(self):
        r"""
        Accessor to the names of the stochastic input variables.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Names of the stochastic input variables
        """
        return _persalys.PhysicalModel_getStochasticInputNames(self)

    def hasInputNamed(self, inputName):
        r"""
        Check if an input has the given name.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        has : bool
            Whether an input has the given name
        """
        return _persalys.PhysicalModel_hasInputNamed(self, inputName)

    def hasStochasticInputs(self):
        r"""
        Whether it contains stochastic variables.

        Returns
        -------
        has : bool
            Whether it contains stochastic variables
        """
        return _persalys.PhysicalModel_hasStochasticInputs(self)

    def getOutputDimension(self):
        r"""
        Number of output variables accessor.

        Returns
        -------
        dimension : int
            Number of output variables
        """
        return _persalys.PhysicalModel_getOutputDimension(self)

    def getOutputs(self):
        r"""
        Output variables accessor.

        Returns
        -------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.PhysicalModel_getOutputs(self)

    def getOutputByName(self, *args):
        r"""
        Output variable accessor.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        input : :class:`~persalys.Output`
            Output variable
        """
        return _persalys.PhysicalModel_getOutputByName(self, *args)

    def setOutputs(self, outputs):
        r"""
        Output variables accessor.

        Parameters
        ----------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.PhysicalModel_setOutputs(self, outputs)

    def setOutputName(self, outputName, newName):
        r"""
        Output variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        newName : str
            New name
        """
        return _persalys.PhysicalModel_setOutputName(self, outputName, newName)

    def setOutputDescription(self, outputName, description):
        r"""
        Output description accessor.

        Parameters
        ----------
        name : str
            Variable name
        description : str
            Description text
        """
        return _persalys.PhysicalModel_setOutputDescription(self, outputName, description)

    def setOutputValue(self, outputName, value):
        r"""
        Output variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        value : float
            New value
        """
        return _persalys.PhysicalModel_setOutputValue(self, outputName, value)

    def selectOutput(self, outputName, selected):
        r"""
        Select output.

        Parameters
        ----------
        name : str
            Output name
        isSelected : bool
            Whether it is selected
        """
        return _persalys.PhysicalModel_selectOutput(self, outputName, selected)

    def addOutput(self, output):
        r"""
        Add an output variable.

        Parameters
        ----------
        output : :class:`~persalys.Output`
            New variable
        """
        return _persalys.PhysicalModel_addOutput(self, output)

    def removeOutput(self, outputName):
        r"""
        Remove an output variable.

        Parameters
        ----------
        name : str
            Variable name
        """
        return _persalys.PhysicalModel_removeOutput(self, outputName)

    def getOutputNames(self):
        r"""
        Output variable names accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Output variable names
        """
        return _persalys.PhysicalModel_getOutputNames(self)

    def hasOutputNamed(self, outputName):
        r"""
        Check if an output has the given name.

        Parameters
        ----------
        name : str
            Variable name

        Returns
        -------
        has : bool
            Whether an output has the given name
        """
        return _persalys.PhysicalModel_hasOutputNamed(self, outputName)

    def getSelectedOutputsNames(self):
        r"""
        Accessor to the selected outputs names.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Selected outputs names
        """
        return _persalys.PhysicalModel_getSelectedOutputsNames(self)

    def getDistribution(self):
        r"""
        Distribution accessor.

        Parameters
        ----------
        Distribution : :py:class:`openturns.JointDistribution`
            The composed distribution (marginals and dependence)
        """
        return _persalys.PhysicalModel_getDistribution(self)

    def getInputRandomVector(self):
        r"""
        Input random vector accessor.

        Returns
        -------
        names : :py:class:`openturns.RandomVector`
            Input random vector
        """
        return _persalys.PhysicalModel_getInputRandomVector(self)

    def getOutputRandomVector(self, outputNames):
        r"""
        Output random vector accessor.

        Returns
        -------
        names : :py:class:`openturns.RandomVector`
            Output random vector
        """
        return _persalys.PhysicalModel_getOutputRandomVector(self, outputNames)

    def getFunction(self, *args):
        r"""
        Accessor to the underlying function.

        Parameters
        ----------
        outputNames : sequence of str
            Names of the outputs to be evaluated (optional)

        Returns
        -------
        function : :py:class:`openturns.Function`
            Function evaluating the outputs
        """
        return _persalys.PhysicalModel_getFunction(self, *args)

    def getRestrictedFunction(self, *args):
        r"""
        Accessor to the function restricted to its stochastic inputs.

        Parameters
        ----------
        outputNames : sequence of str
            Output variables (optional)

        Returns
        -------
        restricted : :py:class:`openturns.Function`
            Stochastic function
        """
        return _persalys.PhysicalModel_getRestrictedFunction(self, *args)

    def getPointToFieldFunction(self, *args):
        r"""
        Accessor to the underlying function.

        Parameters
        ----------
        outputNames : sequence of str
            Names of the outputs to be evaluated (optional)

        Returns
        -------
        function : :py:class:`openturns.PointToFieldFunction`
            Function evaluating the outputs along the mesh nodes
        """
        return _persalys.PhysicalModel_getPointToFieldFunction(self, *args)

    def getRestrictedPointToFieldFunction(self, outputNames):
        r"""
        Accessor to the field function restricted to its stochastic inputs.

        Parameters
        ----------
        outputNames : sequence of str
            Output variables (optional)

        Returns
        -------
        restricted : :py:class:`openturns.PointToFieldFunction`
            Stochastic field function (for model with mesh)
        """
        return _persalys.PhysicalModel_getRestrictedPointToFieldFunction(self, outputNames)

    def getCopula(self):
        r"""
        Copula accessor.

        Parameters
        ----------
        copula : :py:class:`openturns.Copula`
            The copula
        """
        return _persalys.PhysicalModel_getCopula(self)

    def setCopula(self, inputNames, copula):
        r"""
        Copula accessor.

        Parameters
        ----------
        copula : :py:class:`openturns.Copula`
            The copula
        """
        return _persalys.PhysicalModel_setCopula(self, inputNames, copula)

    def setEvalTime(self, evalTime):
        r"""
        Evaluation time accessor.

        Parameters
        ----------
        evalTime : float
            Evaluation time
        """
        return _persalys.PhysicalModel_setEvalTime(self, evalTime)

    def getEvalTime(self):
        r"""
        Evaluation time accessor.

        Returns
        -------
        evalTime : float
            Evaluation time
        """
        return _persalys.PhysicalModel_getEvalTime(self)

    def hasMesh(self):
        r"""
        Whether the model has a mesh.

        Returns
        -------
        hasMesh : bool
            Whether the model has a mesh
        """
        return _persalys.PhysicalModel_hasMesh(self)

    def getMeshModel(self):
        r"""
        Mesh model accessor.

        Returns
        -------
        mesh : :class:`~persalys.MeshModel`
            Mesh model
        """
        return _persalys.PhysicalModel_getMeshModel(self)

    def setMeshModel(self, meshModel):
        r"""
        Mesh model accessor.

        Parameters
        ----------
        mesh : :class:`~persalys.MeshModel`
            Mesh model
        """
        return _persalys.PhysicalModel_setMeshModel(self, meshModel)

    def isParallel(self):
        r"""
        Whether the evaluations of the model are parallelized.

        Returns
        -------
        isParallel : bool
            Whether the evaluations of the model are parallelized (available only for the Python model)
        """
        return _persalys.PhysicalModel_isParallel(self)

    def setParallel(self, flag):
        r"""
        Whether the evaluations of the model are parallelized.

        Parameters
        ----------
        isParallel : bool
            Whether the evaluations of the model are parallelized

        Notes
        -----
        This is only implemented for the Python model.
        Also, on Windows platforms, ProcessPoolExecutor startup time being much higher,
        you may want to evaluate enough points in batch rather than many small blocks.
        Refer to the *setBlockSize* method of the various algorithms.

        """
        return _persalys.PhysicalModel_setParallel(self, flag)

    def getProcessNumber(self):
        r"""
        Number of concurrent processes.

        Returns
        -------
        process_number : int
            Maximum number of processes
        """
        return _persalys.PhysicalModel_getProcessNumber(self)

    def setProcessNumber(self, processNumber):
        r"""
        Number of concurrent processes.

        Parameters
        ----------
        process_number : int
            Maximum number of processes
        """
        return _persalys.PhysicalModel_setProcessNumber(self, processNumber)

    def isValid(self):
        r"""
        Whether it is valid.

        Returns
        -------
        isValid : bool
            Whether it is valid
        """
        return _persalys.PhysicalModel_isValid(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.PhysicalModel_getPythonScript(self)

    def exportStandalonePythonScript(self, fileName):
        r"""
        Export the model into a Python script.

        In the case of metamodels the script only depends on OpenTURNS
        and is meant to be used out of Persalys.

        Parameters
        ----------
        fileName : str
            Path of the exported script
        """
        return _persalys.PhysicalModel_exportStandalonePythonScript(self, fileName)

    def __init__(self, *args):
        _persalys.PhysicalModel_swiginit(self, _persalys.new_PhysicalModel(*args))

    def __repr__(self):
        return _persalys.PhysicalModel___repr__(self)
    __swig_destroy__ = _persalys.delete_PhysicalModel

# Register PhysicalModel in _persalys:
_persalys.PhysicalModel_swigregister(PhysicalModel)
class FMUInfo(openturns.common.PersistentObject):
    r"""
    Retrieve information from a FMU file.

    Parameters
    ----------
    fmuFile : str
        FMU file name
    fmuType : str, default='auto'
        FMU type, either auto, ME or CS
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FMUInfo_getClassName(self)

    def __repr__(self):
        return _persalys.FMUInfo___repr__(self)

    def getFileName(self):
        r"""
        File name accessor.

        Returns
        -------
        fn : str
            FMU file name
        """
        return _persalys.FMUInfo_getFileName(self)

    def getAuthor(self):
        r"""
        Author accessor.

        Returns
        -------
        author : str
            Author name
        """
        return _persalys.FMUInfo_getAuthor(self)

    def getCopyright(self):
        r"""
        Copyright accessor.

        Returns
        -------
        copyright : str
            Copyright text
        """
        return _persalys.FMUInfo_getCopyright(self)

    def getTool(self):
        r"""
        Tool identifier accessor.

        Returns
        -------
        tool : str
            Generation tool identifier string
        """
        return _persalys.FMUInfo_getTool(self)

    def getDateTime(self):
        r"""
        Date/Time accessor.

        Returns
        -------
        dateTime : str
            Date and time
        """
        return _persalys.FMUInfo_getDateTime(self)

    def getGUID(self):
        r"""
        GUID accessor.

        Returns
        -------
        guid : str
            Globally Unique Identifier string
        """
        return _persalys.FMUInfo_getGUID(self)

    def getIdentifier(self):
        r"""
        Model identifier accessor.

        Returns
        -------
        identifier : str
            Model identifier string
        """
        return _persalys.FMUInfo_getIdentifier(self)

    def getPlatform(self):
        r"""
        Platform accessor.

        Returns
        -------
        platform : str
            Platform string
        """
        return _persalys.FMUInfo_getPlatform(self)

    def getVersion(self):
        r"""
        Model version accessor.

        Returns
        -------
        version : str
            Model version string
        """
        return _persalys.FMUInfo_getVersion(self)

    def getFMIVersion(self):
        r"""
        FMI version accessor.

        Returns
        -------
        fmiVersion : str
            FMI specification version string
        """
        return _persalys.FMUInfo_getFMIVersion(self)

    def getModelType(self):
        r"""
        Model type accessor.

        Returns
        -------
        model_type : str
            Model type string: either `Model Exchange` or `Co-Simulation`
        """
        return _persalys.FMUInfo_getModelType(self)

    def getVariableNames(self):
        r"""
        Variable names accessor.

        Returns
        -------
        description : :py:class:`openturns.Description`
            Variable names
        """
        return _persalys.FMUInfo_getVariableNames(self)

    def getCausality(self):
        r"""
        Causality accessor.

        Returns
        -------
        causality : :py:class:`openturns.Indices`
            Causality values
        """
        return _persalys.FMUInfo_getCausality(self)

    def getVariability(self):
        r"""
        Variability accessor.

        Returns
        -------
        variability : :py:class:`openturns.Indices`
            Variability values
        """
        return _persalys.FMUInfo_getVariability(self)

    def getStartKeys(self):
        r"""
        Variables with values: names accessor.

        Returns
        -------
        startKeys : :py:class:`openturns.Description`
            Variables names
        """
        return _persalys.FMUInfo_getStartKeys(self)

    def getStartValues(self):
        r"""
        Variables with values: values accessor.

        Returns
        -------
        startValues : :py:class:`openturns.NumericalPoint`
            Default values
        """
        return _persalys.FMUInfo_getStartValues(self)

    def __init__(self, *args):
        _persalys.FMUInfo_swiginit(self, _persalys.new_FMUInfo(*args))
    __swig_destroy__ = _persalys.delete_FMUInfo

# Register FMUInfo in _persalys:
_persalys.FMUInfo_swigregister(FMUInfo)
class FMIPhysicalModel(PythonPhysicalModel):
    r"""
    Physical model defined by a FMI scheme.

    Parameters
    ----------
    name : str
        Model name
    inputs : sequence of :class:`~persalys.Input`
        Input variables (optional)
    outputs : sequence of :class:`~persalys.Output`
        Output variables (optional)
    fmuFile : str
        FMU file name
    fmuType : str, default='auto'
        FMU type, either one of auto, ME or CS

    Notes
    -----
    When only the file name is provided, only variables marked with *Input* FMI
    causality are set as model input variables, and only variables marked with
    *Output* FMI causality are set as model output variables.

    The implementation is based on `OTFMI <https://github.com/openturns/otfmi>`_.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FMIPhysicalModel_getClassName(self)

    def getFMUFileName(self):
        r"""
        FMU file name accessor.

        Returns
        -------
        fileName : str
            FMU file name containing the FMI scheme
        """
        return _persalys.FMIPhysicalModel_getFMUFileName(self)

    def setFMUFileName(self, fileName):
        r"""
        FMU file name accessor.

        Parameters
        ----------
        fileName : str
            FMU file name containing the FMI scheme
        """
        return _persalys.FMIPhysicalModel_setFMUFileName(self, fileName)

    def getFMUType(self):
        return _persalys.FMIPhysicalModel_getFMUType(self)

    def setFMUType(self, fmuType):
        return _persalys.FMIPhysicalModel_setFMUType(self, fmuType)

    def getFMUInfo(self):
        r"""
        FMU infos accessor.

        Returns
        -------
        fmuInfo : :class:`~persalys.FMUInfo`
            FMU infos
        """
        return _persalys.FMIPhysicalModel_getFMUInfo(self)

    def getFunction(self):
        r"""
        Accessor to the underlying function.

        Parameters
        ----------
        outputNames : sequence of str
            Names of the outputs to be evaluated (optional)

        Returns
        -------
        function : :py:class:`openturns.Function`
            Function evaluating the outputs
        """
        return _persalys.FMIPhysicalModel_getFunction(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.FMIPhysicalModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.FMIPhysicalModel___repr__(self)

    def reassignVariables(self, inputNames, outputNames):
        return _persalys.FMIPhysicalModel_reassignVariables(self, inputNames, outputNames)

    def __init__(self, *args):
        _persalys.FMIPhysicalModel_swiginit(self, _persalys.new_FMIPhysicalModel(*args))
    __swig_destroy__ = _persalys.delete_FMIPhysicalModel

# Register FMIPhysicalModel in _persalys:
_persalys.FMIPhysicalModel_swigregister(FMIPhysicalModel)
class SymbolicFieldModel(SymbolicPhysicalModel):
    r"""
    Create a physical model defined by analytical formulas and a mesh.

    Parameters
    ----------
    name : str
        Name
    mesh : :class:`~persalys.MeshModel`
        Mesh
    inputs : sequence of :class:`~persalys.Input`
        Input variables (optional)
    outputs : sequence of :class:`~persalys.Output`
        Output variables (optional)
    formulas : sequence of str
        List of analytical formulas between the inputs and the outputs (optional).
        The function is defined by outputs = formulas(inputs).


    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the mesh model:

    >>> meshModel = persalys.GridMeshModel([persalys.Variable('x', 'aDescription')], ot.Interval(0., 12.), [10])

    Create the model:

    >>> z0 = persalys.Input('z0', 100)
    >>> v0 = persalys.Input('v0', 55)
    >>> m = persalys.Input('m', 80)
    >>> c = persalys.Input('c', 15)
    >>> z = persalys.Output('z')
    >>> formula = ['max(0, z0 + (m * 9.81 / c) * x + (m / c) * (v0 - (m * 9.81 / c)) * (1 - exp(-x * c / m)))']
    >>> model = persalys.SymbolicFieldModel('model', meshModel, [z0, v0, m, c], [z], formula)

    >>> y = model.getPointToFieldFunction()([100, 55, 80, 15])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SymbolicFieldModel_getClassName(self)

    def addInput(self, input):
        r"""
        Add an input variable.

        Parameters
        ----------
        input : :class:`~persalys.Input`
            New variable
        """
        return _persalys.SymbolicFieldModel_addInput(self, input)

    def setInputName(self, inputName, newName):
        r"""
        Input variable name accessor.

        Parameters
        ----------
        name : str
            Variable name
        newName : str
            New name
        """
        return _persalys.SymbolicFieldModel_setInputName(self, inputName, newName)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.SymbolicFieldModel_getPythonScript(self)

    def __init__(self, *args):
        _persalys.SymbolicFieldModel_swiginit(self, _persalys.new_SymbolicFieldModel(*args))
    __swig_destroy__ = _persalys.delete_SymbolicFieldModel

# Register SymbolicFieldModel in _persalys:
_persalys.SymbolicFieldModel_swigregister(SymbolicFieldModel)
class PythonFieldModel(PythonPhysicalModel):
    r"""
    Create a physical model defined by Python code and a mesh.

    Parameters
    ----------
    name : str
        Name
    inputs : sequence of :class:`~persalys.Input`
        Input variables (optional)
    outputs : sequence of :class:`~persalys.Output`
        Output variables (optional)
    code : str
        Code string (optional)

    Notes
    -----
    The code string must contain a function named '_exec' that takes float
    arguments and return sequences of floats. The mesh is set as a global
    variable of type :py:class:`openturns.Mesh` named 'mesh'.
    The code can use this variable and retrieve the mesh vertices as follows:
    :math:`aVar = getMesh().getVertices()`

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the mesh model:

    >>> meshModel = persalys.GridMeshModel([persalys.Variable('x', 'aDescription')], ot.Interval(0., 12.), [10])

    Create the model:

    >>> z0 = persalys.Input('z0', 100)
    >>> v0 = persalys.Input('v0', 55)
    >>> m = persalys.Input('m', 80)
    >>> c = persalys.Input('c', 15)
    >>> z = persalys.Output('z')
    >>> code = 'from math import exp\n\ndef _exec(z0,v0,m,c):\n    g = 9.81\n    zmin = 0.\n    tau = m / c\n    vinf = -m * g / c\n\n    # mesh nodes\n    t = getMesh().getVertices()\n\n    z = [max(z0 + vinf * t_i[0] + tau * (v0 - vinf) * (1 - exp(-t_i[0] / tau)), zmin) for t_i in t]\n    return z'
    >>> model = persalys.PythonFieldModel('aModel', meshModel, [z0, v0, m, c], [z], code)

    >>> y = model.getPointToFieldFunction()([100, 55, 80, 15])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.PythonFieldModel_getClassName(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.PythonFieldModel_getPythonScript(self)

    def __init__(self, *args):
        _persalys.PythonFieldModel_swiginit(self, _persalys.new_PythonFieldModel(*args))
    __swig_destroy__ = _persalys.delete_PythonFieldModel

# Register PythonFieldModel in _persalys:
_persalys.PythonFieldModel_swigregister(PythonFieldModel)
class LimitStateImplementation(openturns.common.PersistentObject, Observable):
    r"""
    Create a limit state.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    outputName : str
        Interest variable name
    operator : :py:class:`~openturns.ComparisonOperator`
        Comparison operator against threshold (optional)
    threshold : float
        Threshold value (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> physicalModel = persalys.SymbolicPhysicalModel('model1', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', physicalModel, 'G', ot.Less(), 0.)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.LimitStateImplementation_getClassName(self)

    def __eq__(self, other):
        return _persalys.LimitStateImplementation___eq__(self, other)

    def __ne__(self, other):
        return _persalys.LimitStateImplementation___ne__(self, other)

    def getPhysicalModel(self):
        r"""
        Physical model for limit state accessor.

        Returns
        -------
        model : :class:`~persalys.PhysicalModel`
            Physical model
        """
        return _persalys.LimitStateImplementation_getPhysicalModel(self)

    def getOutputName(self):
        r"""
        Accessor to the name of output variable of interest in limit state.

        Returns
        -------
        outputName : str
            Interest variable name
        """
        return _persalys.LimitStateImplementation_getOutputName(self)

    def setOutputName(self, outputName):
        r"""
        Accessor to the name of output variable of interest in limit state.

        Parameters
        ----------
        outputName : str
            Interest variable name
        """
        return _persalys.LimitStateImplementation_setOutputName(self, outputName)

    def getOperator(self):
        r"""
        Comparison operator accessor.

        Returns
        -------
        operator : :py:class:`openturns.ComparisonOperator`
            Comparison operator
        """
        return _persalys.LimitStateImplementation_getOperator(self)

    def setOperator(self, comparisonOperator):
        r"""
        Comparison operator accessor.

        Parameters
        ----------
        operator : :py:class:`openturns.ComparisonOperator`
            Comparison operator
        """
        return _persalys.LimitStateImplementation_setOperator(self, comparisonOperator)

    def getThreshold(self):
        r"""
        Threshold value for limit state accessor.

        Returns
        -------
        threshold : float
            Threshold value
        """
        return _persalys.LimitStateImplementation_getThreshold(self)

    def setThreshold(self, threshold):
        r"""
        Threshold value for limit state accessor.

        Parameters
        ----------
        threshold : float
            Threshold value
        """
        return _persalys.LimitStateImplementation_setThreshold(self, threshold)

    def isValid(self):
        r"""
        Whether limit state is valid.

        Returns
        -------
        isValid : bool
            Whether it is valid
        """
        return _persalys.LimitStateImplementation_isValid(self)

    def getPythonScript(self):
        r"""
        Python script for limit state accessor.

        Returns
        -------
        script : str
            Python script to rebuild the limit state
        """
        return _persalys.LimitStateImplementation_getPythonScript(self)

    def __repr__(self):
        return _persalys.LimitStateImplementation___repr__(self)

    def __str__(self, offset):
        return _persalys.LimitStateImplementation___str__(self, offset)

    def __init__(self, *args):
        _persalys.LimitStateImplementation_swiginit(self, _persalys.new_LimitStateImplementation(*args))
    __swig_destroy__ = _persalys.delete_LimitStateImplementation

# Register LimitStateImplementation in _persalys:
_persalys.LimitStateImplementation_swigregister(LimitStateImplementation)
class LimitStateImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.LimitStateImplementationTypedInterfaceObject_swiginit(self, _persalys.new_LimitStateImplementationTypedInterfaceObject(*args))

    def getImplementation(self):
        r"""
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            A copy of the underlying implementation object.
        """
        return _persalys.LimitStateImplementationTypedInterfaceObject_getImplementation(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.LimitStateImplementationTypedInterfaceObject_setName(self, name)

    def getName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _persalys.LimitStateImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, other):
        return _persalys.LimitStateImplementationTypedInterfaceObject___eq__(self, other)

    def __ne__(self, other):
        return _persalys.LimitStateImplementationTypedInterfaceObject___ne__(self, other)
    __swig_destroy__ = _persalys.delete_LimitStateImplementationTypedInterfaceObject

# Register LimitStateImplementationTypedInterfaceObject in _persalys:
_persalys.LimitStateImplementationTypedInterfaceObject_swigregister(LimitStateImplementationTypedInterfaceObject)
class LimitStateCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_LimitStateCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.LimitStateCollection_clear(self)

    def __len__(self):
        return _persalys.LimitStateCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.LimitStateCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.LimitStateCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.LimitStateCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.LimitStateCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.LimitStateCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.LimitStateCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.LimitStateCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.LimitStateCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.LimitStateCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.LimitStateCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.LimitStateCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.LimitStateCollection_find(self, val)

    def __repr__(self):
        return _persalys.LimitStateCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.LimitStateCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.LimitStateCollection_swiginit(self, _persalys.new_LimitStateCollection(*args))

# Register LimitStateCollection in _persalys:
_persalys.LimitStateCollection_swigregister(LimitStateCollection)
class LimitState(LimitStateImplementationTypedInterfaceObject):
    r"""
    Create a limit state.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    outputName : str
        Interest variable name
    operator : :py:class:`~openturns.ComparisonOperator`
        Comparison operator against threshold (optional)
    threshold : float
        Threshold value (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> physicalModel = persalys.SymbolicPhysicalModel('model1', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', physicalModel, 'G', ot.Less(), 0.)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    @staticmethod
    def GetClassName():
        return _persalys.LimitState_GetClassName()

    def getClassName(self):
        return _persalys.LimitState_getClassName(self)

    def __eq__(self, other):
        return _persalys.LimitState___eq__(self, other)

    def __ne__(self, other):
        return _persalys.LimitState___ne__(self, other)

    def getPhysicalModel(self):
        r"""
        Physical model for limit state accessor.

        Returns
        -------
        model : :class:`~persalys.PhysicalModel`
            Physical model
        """
        return _persalys.LimitState_getPhysicalModel(self)

    def getOutputName(self):
        r"""
        Accessor to the name of output variable of interest in limit state.

        Returns
        -------
        outputName : str
            Interest variable name
        """
        return _persalys.LimitState_getOutputName(self)

    def setOutputName(self, outputName):
        r"""
        Accessor to the name of output variable of interest in limit state.

        Parameters
        ----------
        outputName : str
            Interest variable name
        """
        return _persalys.LimitState_setOutputName(self, outputName)

    def getOperator(self):
        r"""
        Comparison operator accessor.

        Returns
        -------
        operator : :py:class:`openturns.ComparisonOperator`
            Comparison operator
        """
        return _persalys.LimitState_getOperator(self)

    def setOperator(self, comparisonOperator):
        r"""
        Comparison operator accessor.

        Parameters
        ----------
        operator : :py:class:`openturns.ComparisonOperator`
            Comparison operator
        """
        return _persalys.LimitState_setOperator(self, comparisonOperator)

    def getThreshold(self):
        r"""
        Threshold value for limit state accessor.

        Returns
        -------
        threshold : float
            Threshold value
        """
        return _persalys.LimitState_getThreshold(self)

    def setThreshold(self, threshold):
        r"""
        Threshold value for limit state accessor.

        Parameters
        ----------
        threshold : float
            Threshold value
        """
        return _persalys.LimitState_setThreshold(self, threshold)

    def isValid(self):
        r"""
        Whether limit state is valid.

        Returns
        -------
        isValid : bool
            Whether it is valid
        """
        return _persalys.LimitState_isValid(self)

    def getPythonScript(self):
        r"""
        Python script for limit state accessor.

        Returns
        -------
        script : str
            Python script to rebuild the limit state
        """
        return _persalys.LimitState_getPythonScript(self)

    def __init__(self, *args):
        _persalys.LimitState_swiginit(self, _persalys.new_LimitState(*args))

    def __repr__(self):
        return _persalys.LimitState___repr__(self)
    __swig_destroy__ = _persalys.delete_LimitState

# Register LimitState in _persalys:
_persalys.LimitState_swigregister(LimitState)
class AnalysisResult(openturns.common.PersistentObject):
    r"""Class containing results of the analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.AnalysisResult_getClassName(self)

    def getElapsedTime(self):
        r"""
        Elapsed time in seconds to perform the analysis.

        Returns
        -------
        time : double
            Elapsed time in seconds to perform the analysis
        """
        return _persalys.AnalysisResult_getElapsedTime(self)

    def __repr__(self):
        return _persalys.AnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.AnalysisResult_swiginit(self, _persalys.new_AnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_AnalysisResult

# Register AnalysisResult in _persalys:
_persalys.AnalysisResult_swigregister(AnalysisResult)
class AnalysisImplementation(openturns.common.PersistentObject, Observable):
    r"""Analysis base class."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.AnalysisImplementation_setName(self, name)

    def getParentObserver(self):
        return _persalys.AnalysisImplementation_getParentObserver(self)

    def __eq__(self, other):
        return _persalys.AnalysisImplementation___eq__(self, other)

    def __ne__(self, other):
        return _persalys.AnalysisImplementation___ne__(self, other)

    def run(self):
        r"""Launch the analysis."""
        return _persalys.AnalysisImplementation_run(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.AnalysisImplementation_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.AnalysisImplementation_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.AnalysisImplementation_canBeLaunched(self, errorMessage)

    def isReliabilityAnalysis(self):
        r"""
        Whether the analysis involves reliability.

        Returns
        -------
        isReliabilityAnalysis : bool
            Whether the analysis involves a reliability analysis
        """
        return _persalys.AnalysisImplementation_isReliabilityAnalysis(self)

    def isRunning(self):
        r"""
        Whether the analysis is running.

        Returns
        -------
        isRunning : bool
            Whether the analysis is running
        """
        return _persalys.AnalysisImplementation_isRunning(self)

    def getInterestVariables(self):
        r"""
        Get the variables to analyse.

        Returns
        -------
        variablesNames : sequence of str
            Names of the variables to analyse
        """
        return _persalys.AnalysisImplementation_getInterestVariables(self)

    def setInterestVariables(self, variablesNames):
        r"""
        Set the variables to analyse.

        Parameters
        ----------
        variablesNames : sequence of str
            Names of the variables to analyse
        """
        return _persalys.AnalysisImplementation_setInterestVariables(self, variablesNames)

    def getErrorMessage(self):
        r"""
        Error message accessor.

        Returns
        -------
        message : str
            Error message if the analysis failed
        """
        return _persalys.AnalysisImplementation_getErrorMessage(self)

    def getWarningMessage(self):
        r"""
        Warning message accessor.

        Returns
        -------
        message : str
            Warning message which can appear during the analysis computation
        """
        return _persalys.AnalysisImplementation_getWarningMessage(self)

    def getElapsedTime(self):
        return _persalys.AnalysisImplementation_getElapsedTime(self)

    def __init__(self, *args):
        _persalys.AnalysisImplementation_swiginit(self, _persalys.new_AnalysisImplementation(*args))

    def __repr__(self):
        return _persalys.AnalysisImplementation___repr__(self)
    __swig_destroy__ = _persalys.delete_AnalysisImplementation

# Register AnalysisImplementation in _persalys:
_persalys.AnalysisImplementation_swigregister(AnalysisImplementation)
class PhysicalModelAnalysis(AnalysisImplementation):
    r"""Analysis using a physical model"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getParentObserver(self):
        return _persalys.PhysicalModelAnalysis_getParentObserver(self)

    def getPhysicalModel(self):
        r"""
        Physical model accessor.

        Returns
        -------
        model : :class:`~persalys.PhysicalModel`
            Physical model
        """
        return _persalys.PhysicalModelAnalysis_getPhysicalModel(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.PhysicalModelAnalysis_canBeLaunched(self, errorMessage)

    def run(self):
        r"""Launch the analysis."""
        return _persalys.PhysicalModelAnalysis_run(self)

    def __init__(self, *args):
        _persalys.PhysicalModelAnalysis_swiginit(self, _persalys.new_PhysicalModelAnalysis(*args))

    def __repr__(self, *args):
        return _persalys.PhysicalModelAnalysis___repr__(self, *args)
    __swig_destroy__ = _persalys.delete_PhysicalModelAnalysis

# Register PhysicalModelAnalysis in _persalys:
_persalys.PhysicalModelAnalysis_swigregister(PhysicalModelAnalysis)
class AnalysisImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.AnalysisImplementationTypedInterfaceObject_swiginit(self, _persalys.new_AnalysisImplementationTypedInterfaceObject(*args))

    def getImplementation(self):
        r"""
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            A copy of the underlying implementation object.
        """
        return _persalys.AnalysisImplementationTypedInterfaceObject_getImplementation(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.AnalysisImplementationTypedInterfaceObject_setName(self, name)

    def getName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _persalys.AnalysisImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, other):
        return _persalys.AnalysisImplementationTypedInterfaceObject___eq__(self, other)

    def __ne__(self, other):
        return _persalys.AnalysisImplementationTypedInterfaceObject___ne__(self, other)
    __swig_destroy__ = _persalys.delete_AnalysisImplementationTypedInterfaceObject

# Register AnalysisImplementationTypedInterfaceObject in _persalys:
_persalys.AnalysisImplementationTypedInterfaceObject_swigregister(AnalysisImplementationTypedInterfaceObject)
class AnalysisCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_AnalysisCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.AnalysisCollection_clear(self)

    def __len__(self):
        return _persalys.AnalysisCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.AnalysisCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.AnalysisCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.AnalysisCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.AnalysisCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.AnalysisCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.AnalysisCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.AnalysisCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.AnalysisCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.AnalysisCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.AnalysisCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.AnalysisCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.AnalysisCollection_find(self, val)

    def __repr__(self):
        return _persalys.AnalysisCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.AnalysisCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.AnalysisCollection_swiginit(self, _persalys.new_AnalysisCollection(*args))

# Register AnalysisCollection in _persalys:
_persalys.AnalysisCollection_swigregister(AnalysisCollection)
class Analysis(AnalysisImplementationTypedInterfaceObject):
    r"""Analysis base class."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    @staticmethod
    def GetClassName():
        return _persalys.Analysis_GetClassName()

    def getClassName(self):
        return _persalys.Analysis_getClassName(self)

    def __eq__(self, other):
        return _persalys.Analysis___eq__(self, other)

    def __ne__(self, other):
        return _persalys.Analysis___ne__(self, other)

    def getParentObserver(self):
        return _persalys.Analysis_getParentObserver(self)

    def isReliabilityAnalysis(self):
        r"""
        Whether the analysis involves reliability.

        Returns
        -------
        isReliabilityAnalysis : bool
            Whether the analysis involves a reliability analysis
        """
        return _persalys.Analysis_isReliabilityAnalysis(self)

    def isRunning(self):
        r"""
        Whether the analysis is running.

        Returns
        -------
        isRunning : bool
            Whether the analysis is running
        """
        return _persalys.Analysis_isRunning(self)

    def getErrorMessage(self):
        r"""
        Error message accessor.

        Returns
        -------
        message : str
            Error message if the analysis failed
        """
        return _persalys.Analysis_getErrorMessage(self)

    def getWarningMessage(self):
        r"""
        Warning message accessor.

        Returns
        -------
        message : str
            Warning message which can appear during the analysis computation
        """
        return _persalys.Analysis_getWarningMessage(self)

    def run(self):
        r"""Launch the analysis."""
        return _persalys.Analysis_run(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.Analysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.Analysis_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.Analysis_canBeLaunched(self, errorMessage)

    def setImplementationAsPersistentObject(self, obj):
        return _persalys.Analysis_setImplementationAsPersistentObject(self, obj)

    def __init__(self, *args):
        _persalys.Analysis_swiginit(self, _persalys.new_Analysis(*args))

    def __repr__(self):
        return _persalys.Analysis___repr__(self)
    __swig_destroy__ = _persalys.delete_Analysis

# Register Analysis in _persalys:
_persalys.Analysis_swigregister(Analysis)
class WithStopCriteriaAnalysis(object):
    r"""
    Class to define stop criteria.

    The base class for analysis involving stop criteria.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_WithStopCriteriaAnalysis

    def getMaximumCalls(self):
        r"""
        Maximum calls accessor.

        Returns
        -------
        maxCalls : positive int
            The maximum calls of the function.
        """
        return _persalys.WithStopCriteriaAnalysis_getMaximumCalls(self)

    def setMaximumCalls(self, maxi):
        r"""
        Maximum calls accessor.

        Parameters
        ----------
        maxCalls : positive int
            The maximum calls of the function.
        """
        return _persalys.WithStopCriteriaAnalysis_setMaximumCalls(self, maxi)

    def getMaximumCoefficientOfVariation(self):
        r"""
        Maximum coefficient of variation accessor.

        Returns
        -------
        maxCoef : double
            The maximum coefficient of variation. It is set by default to 0.01.
        """
        return _persalys.WithStopCriteriaAnalysis_getMaximumCoefficientOfVariation(self)

    def setMaximumCoefficientOfVariation(self, coef):
        r"""
        Maximum coefficient of variation accessor.

        Parameters
        ----------
        maxCoef : double
            The maximum coefficient of variation. It is set by default to 0.01.
        """
        return _persalys.WithStopCriteriaAnalysis_setMaximumCoefficientOfVariation(self, coef)

    def getMaximumElapsedTime(self):
        r"""
        Maximum elapsed time accessor.

        Returns
        -------
        maxTime : positive int
            The maximum elapsed time in seconds. It is set by default to 60 seconds.
        """
        return _persalys.WithStopCriteriaAnalysis_getMaximumElapsedTime(self)

    def setMaximumElapsedTime(self, seconds):
        r"""
        Maximum elapsed time accessor.

        Parameters
        ----------
        maxTime : positive int
            The maximum elapsed time in seconds. It is set by default to 60 seconds.
        """
        return _persalys.WithStopCriteriaAnalysis_setMaximumElapsedTime(self, seconds)

    def __repr__(self):
        return _persalys.WithStopCriteriaAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.WithStopCriteriaAnalysis_swiginit(self, _persalys.new_WithStopCriteriaAnalysis(*args))

# Register WithStopCriteriaAnalysis in _persalys:
_persalys.WithStopCriteriaAnalysis_swigregister(WithStopCriteriaAnalysis)
class DesignOfExperimentImplementation(DataSample, Observable):
    r"""
    Design of experiments base class.

    Available constructors:
        DesignOfExperiment(*name, physicalModel*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model

    Notes
    -----
    DesignOfExperiment is the base class of :class:`~persalys.DataModel`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.DesignOfExperimentImplementation_getClassName(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.DesignOfExperimentImplementation_setName(self, name)

    def __eq__(self, other):
        return _persalys.DesignOfExperimentImplementation___eq__(self, other)

    def __ne__(self, other):
        return _persalys.DesignOfExperimentImplementation___ne__(self, other)

    def hasPhysicalModel(self):
        r"""
        Whether it contains a physical model.

        Returns
        -------
        hasPhysicalModel : bool
            Whether it contains a physical model
        """
        return _persalys.DesignOfExperimentImplementation_hasPhysicalModel(self)

    def getPhysicalModel(self):
        r"""
        Physical model accessor.

        Returns
        -------
        model : :class:`~persalys.PhysicalModel`
            Physical model
        """
        return _persalys.DesignOfExperimentImplementation_getPhysicalModel(self)

    def initialize(self):
        r"""Empty the input and output samples."""
        return _persalys.DesignOfExperimentImplementation_initialize(self)

    def setInputSample(self, sample):
        r"""
        Input sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Input sample
        """
        return _persalys.DesignOfExperimentImplementation_setInputSample(self, sample)

    def setOutputSample(self, sample):
        r"""
        Output sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Output sample
        """
        return _persalys.DesignOfExperimentImplementation_setOutputSample(self, sample)

    def getEffectiveInputIndices(self):
        r"""
        Effective indices accessor.

        Indices of non-const variables in the design.

        Returns
        -------
        indices : :py:class:`openturns.Indices`
            Input sample and output sample
        """
        return _persalys.DesignOfExperimentImplementation_getEffectiveInputIndices(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to rebuild the design of experiments
        """
        return _persalys.DesignOfExperimentImplementation_getPythonScript(self)

    def __init__(self, *args):
        _persalys.DesignOfExperimentImplementation_swiginit(self, _persalys.new_DesignOfExperimentImplementation(*args))

    def __repr__(self):
        return _persalys.DesignOfExperimentImplementation___repr__(self)
    __swig_destroy__ = _persalys.delete_DesignOfExperimentImplementation

# Register DesignOfExperimentImplementation in _persalys:
_persalys.DesignOfExperimentImplementation_swigregister(DesignOfExperimentImplementation)
class DesignOfExperimentImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.DesignOfExperimentImplementationTypedInterfaceObject_swiginit(self, _persalys.new_DesignOfExperimentImplementationTypedInterfaceObject(*args))

    def getImplementation(self):
        r"""
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            A copy of the underlying implementation object.
        """
        return _persalys.DesignOfExperimentImplementationTypedInterfaceObject_getImplementation(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.DesignOfExperimentImplementationTypedInterfaceObject_setName(self, name)

    def getName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _persalys.DesignOfExperimentImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, other):
        return _persalys.DesignOfExperimentImplementationTypedInterfaceObject___eq__(self, other)

    def __ne__(self, other):
        return _persalys.DesignOfExperimentImplementationTypedInterfaceObject___ne__(self, other)
    __swig_destroy__ = _persalys.delete_DesignOfExperimentImplementationTypedInterfaceObject

# Register DesignOfExperimentImplementationTypedInterfaceObject in _persalys:
_persalys.DesignOfExperimentImplementationTypedInterfaceObject_swigregister(DesignOfExperimentImplementationTypedInterfaceObject)
class DesignOfExperimentCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_DesignOfExperimentCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.DesignOfExperimentCollection_clear(self)

    def __len__(self):
        return _persalys.DesignOfExperimentCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.DesignOfExperimentCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.DesignOfExperimentCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.DesignOfExperimentCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.DesignOfExperimentCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.DesignOfExperimentCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.DesignOfExperimentCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.DesignOfExperimentCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.DesignOfExperimentCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.DesignOfExperimentCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.DesignOfExperimentCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.DesignOfExperimentCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.DesignOfExperimentCollection_find(self, val)

    def __repr__(self):
        return _persalys.DesignOfExperimentCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.DesignOfExperimentCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.DesignOfExperimentCollection_swiginit(self, _persalys.new_DesignOfExperimentCollection(*args))

# Register DesignOfExperimentCollection in _persalys:
_persalys.DesignOfExperimentCollection_swigregister(DesignOfExperimentCollection)
class DesignOfExperiment(DesignOfExperimentImplementationTypedInterfaceObject):
    r"""
    Design of experiments base class.

    Available constructors:
        DesignOfExperiment(*name, physicalModel*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model

    Notes
    -----
    DesignOfExperiment is the base class of :class:`~persalys.DataModel`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    @staticmethod
    def GetClassName():
        return _persalys.DesignOfExperiment_GetClassName()

    def getClassName(self):
        return _persalys.DesignOfExperiment_getClassName(self)

    def __eq__(self, other):
        return _persalys.DesignOfExperiment___eq__(self, other)

    def __ne__(self, other):
        return _persalys.DesignOfExperiment___ne__(self, other)

    def hasPhysicalModel(self):
        r"""
        Whether it contains a physical model.

        Returns
        -------
        hasPhysicalModel : bool
            Whether it contains a physical model
        """
        return _persalys.DesignOfExperiment_hasPhysicalModel(self)

    def getPhysicalModel(self):
        r"""
        Physical model accessor.

        Returns
        -------
        model : :class:`~persalys.PhysicalModel`
            Physical model
        """
        return _persalys.DesignOfExperiment_getPhysicalModel(self)

    def getInputSample(self):
        r"""
        Input sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Input sample
        """
        return _persalys.DesignOfExperiment_getInputSample(self)

    def getOutputSample(self):
        r"""
        Output sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Output sample
        """
        return _persalys.DesignOfExperiment_getOutputSample(self)

    def getSample(self):
        r"""
        Sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Input sample and output sample
        """
        return _persalys.DesignOfExperiment_getSample(self)

    def setInputSample(self, sample):
        r"""
        Input sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Input sample
        """
        return _persalys.DesignOfExperiment_setInputSample(self, sample)

    def setOutputSample(self, sample):
        r"""
        Output sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Output sample
        """
        return _persalys.DesignOfExperiment_setOutputSample(self, sample)

    def isValid(self):
        return _persalys.DesignOfExperiment_isValid(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to rebuild the design of experiments
        """
        return _persalys.DesignOfExperiment_getPythonScript(self)

    def getEffectiveInputIndices(self):
        r"""
        Effective indices accessor.

        Indices of non-const variables in the design.

        Returns
        -------
        indices : :py:class:`openturns.Indices`
            Input sample and output sample
        """
        return _persalys.DesignOfExperiment_getEffectiveInputIndices(self)

    def __init__(self, *args):
        _persalys.DesignOfExperiment_swiginit(self, _persalys.new_DesignOfExperiment(*args))

    def __repr__(self):
        return _persalys.DesignOfExperiment___repr__(self)
    __swig_destroy__ = _persalys.delete_DesignOfExperiment

# Register DesignOfExperiment in _persalys:
_persalys.DesignOfExperiment_swigregister(DesignOfExperiment)
class DataModel(DesignOfExperimentImplementation, DataImport):
    r"""
    Create a data model from an imported dataset.

    The interface allows the user to load data samples and analyse them. They are considered as data models.

        DataModel(*name, fileName, inputColumns, outputColumns, inputNames, outputNames*)

        DataModel(*name, inputSample, outputSample*)

    Parameters
    ----------
    name : str
        Name
    fileName : str
        Name of a data file (.txt ot .csv) to load
    inputColumns : sequence of int
        Indices of columns of the input variables in file to consider
    outputColumns : sequence of int
        Indices of columns of the output variables in file to consider (optional)
    inputNames : sequence of str
        Names of the input variables (optional)
    outputNames : sequence of str
        Names of the output variables (optional)
    inputSample : :py:class:`openturns.Sample`
        Input sample
    outputSample : :py:class:`openturns.Sample`
        Output sample (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys
    >>> ot.RandomGenerator.SetSeed(0)
    >>> fileName = 'sample.csv'
    >>> sample = ot.Normal(3).getSample(30)
    >>> sample.exportToCSVFile(fileName)
    >>> model = persalys.DataModel('dataModel', fileName, [0, 2], [1], ['var1', 'var2'], ['var3'])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.DataModel_getClassName(self)

    def getInputNames(self):
        r"""
        Names of the input variables accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
           Names of the input variables
        """
        return _persalys.DataModel_getInputNames(self)

    def getOutputNames(self):
        r"""
        Names of the output variables accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
           Names of the output variables
        """
        return _persalys.DataModel_getOutputNames(self)

    def setColumns(self, *args):
        r"""
        Columns and names of variables accessor.

        Parameters
        ----------
        inputColumns : sequence of int
            Columns of input variables
        inNames : sequence of str
           Names of input variables
        outputColumns : sequence of int, optional
            Columns of output variables
        outNames : sequence of str
           Names of output variables
        """
        return _persalys.DataModel_setColumns(self, *args)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to rebuild the design of experiments
        """
        return _persalys.DataModel_getPythonScript(self)

    def __repr__(self):
        return _persalys.DataModel___repr__(self)

    def setSample(self, sample):
        return _persalys.DataModel_setSample(self, sample)

    def __init__(self, *args):
        _persalys.DataModel_swiginit(self, _persalys.new_DataModel(*args))
    __swig_destroy__ = _persalys.delete_DataModel

# Register DataModel in _persalys:
_persalys.DataModel_swigregister(DataModel)
class Observations(DataModel):
    r"""
    Create observations for variables of a model.

    Available constructors:
        Observations(*name, physicalModel, fileName, inputColumns, outputColumns, inputNames, outputNames*)

        Observations(*name, inputSample, outputSample*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    fileName : str
        Name of a data file (.txt ot .csv) to load
    inputColumns : sequence of int
        Indices of columns of the input variables in file to consider
    outputColumns : sequence of int
        Indices of columns of the output variables in file to consider (optional)
    inputNames : sequence of str
        Names of the input variables (optional)
    outputNames : sequence of str
        Names of the output variables (optional)
    inputSample : :py:class:`openturns.Sample`
        Input sample (its description must be a list of input variable names)
    outputSample : :py:class:`openturns.Sample`
        Output sample (its description must be a list of output variable names)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys
    >>> ot.RandomGenerator.SetSeed(0)

    Create the model:

    >>> X0 = persalys.Input('X0')
    >>> X1 = persalys.Input('X1')
    >>> X2 = persalys.Input('X2')
    >>> X3 = persalys.Input('X3')
    >>> Y0 = persalys.Output('Y0')
    >>> Y1 = persalys.Output('Y1')
    >>> model = persalys.SymbolicPhysicalModel('aModelPhys', [X0, X1, X2, X3], [Y0, Y1], ['sin(X0)+8*X1', 'X2 + X3'])

    Create the observations:

    >>> filename = 'data.csv'
    >>> ot.Normal(8).getSample(10).exportToCSVFile(filename)
    >>> aObs = persalys.Observations('anObs', model, filename, [2, 7], [3], ['X0', 'X2'], ['Y1'])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.Observations_getClassName(self)

    def setColumns(self, inputColumns, inputNames, outputColumns, outputNames):
        r"""
        Columns and names of variables accessor.

        Parameters
        ----------
        inputColumns : sequence of int
            Columns of input variables
        inNames : sequence of str
           Names of input variables
        outputColumns : sequence of int, optional
            Columns of output variables
        outNames : sequence of str
           Names of output variables
        """
        return _persalys.Observations_setColumns(self, inputColumns, inputNames, outputColumns, outputNames)

    def __repr__(self):
        return _persalys.Observations___repr__(self)

    def __init__(self, *args):
        _persalys.Observations_swiginit(self, _persalys.new_Observations(*args))
    __swig_destroy__ = _persalys.delete_Observations

# Register Observations in _persalys:
_persalys.Observations_swigregister(Observations)
class EvaluationResult(AnalysisResult):
    r"""Class containing results of the simulation analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.EvaluationResult_getClassName(self)

    def getDesignOfExperiment(self):
        r"""
        Design of experiments accessor.

        Returns
        -------
        design : :class:`~persalys.DesignOfExperiment`
            Design of experiments containing the analysed points
        """
        return _persalys.EvaluationResult_getDesignOfExperiment(self)

    def __repr__(self):
        return _persalys.EvaluationResult___repr__(self)

    def __init__(self, *args):
        _persalys.EvaluationResult_swiginit(self, _persalys.new_EvaluationResult(*args))
    __swig_destroy__ = _persalys.delete_EvaluationResult

# Register EvaluationResult in _persalys:
_persalys.EvaluationResult_swigregister(EvaluationResult)
class DataAnalysisResult(EvaluationResult):
    r"""Get the results of a data analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.DataAnalysisResult_getClassName(self)

    def getMin(self):
        r"""
        Minimum accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Minimum
        """
        return _persalys.DataAnalysisResult_getMin(self)

    def getMax(self):
        r"""
        Maximum accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Maximum
        """
        return _persalys.DataAnalysisResult_getMax(self)

    def getMean(self):
        r"""
        Mean accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Mean
        """
        return _persalys.DataAnalysisResult_getMean(self)

    def getCoefficientOfVariation(self):
        r"""
        Coefficient of variation accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Coefficient of variation
        """
        return _persalys.DataAnalysisResult_getCoefficientOfVariation(self)

    def getMedian(self):
        r"""
        Median accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Median
        """
        return _persalys.DataAnalysisResult_getMedian(self)

    def getStandardDeviation(self):
        r"""
        Standard deviation accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Standard deviation
        """
        return _persalys.DataAnalysisResult_getStandardDeviation(self)

    def getVariance(self):
        r"""
        Variance accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Variance
        """
        return _persalys.DataAnalysisResult_getVariance(self)

    def getSkewness(self):
        r"""
        Skewness accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Skewness
        """
        return _persalys.DataAnalysisResult_getSkewness(self)

    def getKurtosis(self):
        r"""
        Kurtosis accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Kurtosis
        """
        return _persalys.DataAnalysisResult_getKurtosis(self)

    def getFirstQuartile(self):
        r"""
        First quartile accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            First quartile
        """
        return _persalys.DataAnalysisResult_getFirstQuartile(self)

    def getThirdQuartile(self):
        r"""
        Third quartile accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Third quartile
        """
        return _persalys.DataAnalysisResult_getThirdQuartile(self)

    def getMeanConfidenceInterval(self):
        r"""
        Confidence interval mean accessor.

        Parameters
        ----------
        level : float
            Confidence level

        Returns
        -------
        result : :py:class:`openturns.Interval`
            Confidence interval mean
        """
        return _persalys.DataAnalysisResult_getMeanConfidenceInterval(self)

    def getStdConfidenceInterval(self):
        r"""
        Confidence interval standard deviation accessor.

        Parameters
        ----------
        level : float
            Confidence level

        Returns
        -------
        result : :py:class:`openturns.Interval`
            Confidence interval standard deviation
        """
        return _persalys.DataAnalysisResult_getStdConfidenceInterval(self)

    def getOutliers(self):
        r"""
        Outliers accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Point`
            Outliers
        """
        return _persalys.DataAnalysisResult_getOutliers(self)

    def getPDF(self):
        r"""
        PDF accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Sample`
            PDF
        """
        return _persalys.DataAnalysisResult_getPDF(self)

    def getCDF(self):
        r"""
        CDF accessor.

        Returns
        -------
        result : sequence of :py:class:`openturns.Sample`
            CDF
        """
        return _persalys.DataAnalysisResult_getCDF(self)

    def getSurvivalFunction(self):
        return _persalys.DataAnalysisResult_getSurvivalFunction(self)

    def __repr__(self):
        return _persalys.DataAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.DataAnalysisResult_swiginit(self, _persalys.new_DataAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_DataAnalysisResult

# Register DataAnalysisResult in _persalys:
_persalys.DataAnalysisResult_swigregister(DataAnalysisResult)
class DesignOfExperimentAnalysis(AnalysisImplementation):
    r"""Analysis using a design of experiments"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getParentObserver(self):
        return _persalys.DesignOfExperimentAnalysis_getParentObserver(self)

    def getDesignOfExperiment(self):
        r"""
        Design of experiments accessor.

        Returns
        -------
        model : :class:`~persalys.DesignOfExperiment`
            Design of experiments
        """
        return _persalys.DesignOfExperimentAnalysis_getDesignOfExperiment(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.DesignOfExperimentAnalysis_canBeLaunched(self, errorMessage)

    def run(self):
        r"""Launch the analysis."""
        return _persalys.DesignOfExperimentAnalysis_run(self)

    def __init__(self, *args):
        _persalys.DesignOfExperimentAnalysis_swiginit(self, _persalys.new_DesignOfExperimentAnalysis(*args))

    def __repr__(self, *args):
        return _persalys.DesignOfExperimentAnalysis___repr__(self, *args)
    __swig_destroy__ = _persalys.delete_DesignOfExperimentAnalysis

# Register DesignOfExperimentAnalysis in _persalys:
_persalys.DesignOfExperimentAnalysis_swigregister(DesignOfExperimentAnalysis)
class SimulationAnalysis(PhysicalModelAnalysis):
    r"""Simulation reliability analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getFailedInputSample(self):
        r"""
        Failed input sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Sample with the failed input values
        """
        return _persalys.SimulationAnalysis_getFailedInputSample(self)

    def getErrorDescription(self):
        return _persalys.SimulationAnalysis_getErrorDescription(self)

    def getBlockSize(self):
        r"""
        Block size accessor.

        Returns
        -------
        blockSize : positive int
            Number of terms analysed together.
            It is set by default to 1.
        """
        return _persalys.SimulationAnalysis_getBlockSize(self)

    def setBlockSize(self, size):
        r"""
        Block size accessor.

        Parameters
        ----------
        blockSize : positive int
            Number of terms analysed together.
            It is set by default to 1.
        """
        return _persalys.SimulationAnalysis_setBlockSize(self, size)

    def getSeed(self):
        r"""
        Seed accessor.

        Returns
        -------
        seed : int
            Seed value
        """
        return _persalys.SimulationAnalysis_getSeed(self)

    def setSeed(self, seed):
        r"""
        Seed accessor.

        Parameters
        ----------
        seed : int
            Seed value
        """
        return _persalys.SimulationAnalysis_setSeed(self, seed)

    def __init__(self, other):
        _persalys.SimulationAnalysis_swiginit(self, _persalys.new_SimulationAnalysis(other))

    def __repr__(self):
        return _persalys.SimulationAnalysis___repr__(self)
    __swig_destroy__ = _persalys.delete_SimulationAnalysis

# Register SimulationAnalysis in _persalys:
_persalys.SimulationAnalysis_swigregister(SimulationAnalysis)
class DesignOfExperimentEvaluation(SimulationAnalysis):
    r"""
    Create the base class of design of experiments.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.DesignOfExperimentEvaluation_getClassName(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.DesignOfExperimentEvaluation_setName(self, name)

    def getOriginalInputSample(self):
        r"""
        Input sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Input sample.
        """
        return _persalys.DesignOfExperimentEvaluation_getOriginalInputSample(self)

    def getNotEvaluatedInputSample(self):
        r"""
        Not evaluated input sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Points of the design of experiments which were not evaluated
        """
        return _persalys.DesignOfExperimentEvaluation_getNotEvaluatedInputSample(self)

    def getResult(self):
        return _persalys.DesignOfExperimentEvaluation_getResult(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.DesignOfExperimentEvaluation_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.DesignOfExperimentEvaluation_canBeLaunched(self, errorMessage)

    @staticmethod
    def StopRequested(state):
        return _persalys.DesignOfExperimentEvaluation_StopRequested(state)

    def __init__(self, *args):
        _persalys.DesignOfExperimentEvaluation_swiginit(self, _persalys.new_DesignOfExperimentEvaluation(*args))
    __swig_destroy__ = _persalys.delete_DesignOfExperimentEvaluation

# Register DesignOfExperimentEvaluation in _persalys:
_persalys.DesignOfExperimentEvaluation_swigregister(DesignOfExperimentEvaluation)
class FixedDesignOfExperiment(DesignOfExperimentEvaluation):
    r"""
    Create a fixed design of experiments.

    Available constructors:
        FixedDesignOfExperiment(*name, physicalModel*)

        FixedDesignOfExperiment(*name, physicalModel, sample*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    sample : :py:class:`openturns.Sample`
        Input sample. The sample must have a dimension equal to the number of
        inputs in the physical model (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the design of experiments:

    >>> myDOE = persalys.FixedDesignOfExperiment('myDOE', myPhysicalModel)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FixedDesignOfExperiment_getClassName(self)

    def setOriginalInputSample(self, sample):
        r"""
        Input sample accessor.

        Parameters
        ----------
        sample : :py:class:`openturns.Sample`
            Input sample. The sample must have a dimension equal to the number of
            inputs in the physical model
        """
        return _persalys.FixedDesignOfExperiment_setOriginalInputSample(self, sample)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.FixedDesignOfExperiment_getPythonScript(self)

    def __repr__(self):
        return _persalys.FixedDesignOfExperiment___repr__(self)

    def __init__(self, *args):
        _persalys.FixedDesignOfExperiment_swiginit(self, _persalys.new_FixedDesignOfExperiment(*args))
    __swig_destroy__ = _persalys.delete_FixedDesignOfExperiment

# Register FixedDesignOfExperiment in _persalys:
_persalys.FixedDesignOfExperiment_swigregister(FixedDesignOfExperiment)
class GridDesignOfExperiment(DesignOfExperimentEvaluation):
    r"""
    Create a grid design of experiments.

    Available constructors:
        GridDesignOfExperiment(*name, physicalModel*)

        GridDesignOfExperiment(*name, physicalModel, bounds, nbValues, values*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    bounds : :py:class:`openturns.Interval`
        Bounds
    nbValues : sequence of int
        Number of values along each direction
    values : sequence of float
        Values of the constant variables (optional)

    Notes
    -----
    The sequences must have a dimension equal to the number of inputs in the
    physical model.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the design of experiments:

    >>> myDOE = persalys.GridDesignOfExperiment('myDOE', myPhysicalModel)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.GridDesignOfExperiment_getClassName(self)
    FromBoundsAndLevels = _persalys.GridDesignOfExperiment_FromBoundsAndLevels
    FromBoundsAndDeltas = _persalys.GridDesignOfExperiment_FromBoundsAndDeltas

    def getValues(self):
        r"""
        Values accessor.

        Returns
        -------
        values : :py:class:`openturns.Point`
           Inputs values used in the case where there is at least a constant variable.
        """
        return _persalys.GridDesignOfExperiment_getValues(self)

    def setValues(self, values):
        r"""
        Values accessor.

        Parameters
        ----------
        values : :py:class:`openturns.Point`
           Inputs values used in the case where there is at least a constant variable.
        """
        return _persalys.GridDesignOfExperiment_setValues(self, values)

    @staticmethod
    def GetDefaultBounds(model):
        return _persalys.GridDesignOfExperiment_GetDefaultBounds(model)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.GridDesignOfExperiment_getPythonScript(self)

    def __repr__(self):
        return _persalys.GridDesignOfExperiment___repr__(self)

    def __init__(self, *args):
        _persalys.GridDesignOfExperiment_swiginit(self, _persalys.new_GridDesignOfExperiment(*args))
    __swig_destroy__ = _persalys.delete_GridDesignOfExperiment

# Register GridDesignOfExperiment in _persalys:
_persalys.GridDesignOfExperiment_swigregister(GridDesignOfExperiment)
class ImportedDesignOfExperiment(DesignOfExperimentEvaluation, DataImport):
    r"""
    Create a design of experiments, using an imported design.

    Available constructors:
        ImportedDesignOfExperiment(*name, physicalModel, fileName, columns*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    fileName : str
        Name of a data file to load
    columns : sequence of int
        Indices of columns in files to consider

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys
    >>> ot.RandomGenerator.SetSeed(0)

    Create the model:

    >>> X0 = persalys.Input('X0')
    >>> X1 = persalys.Input('X1')
    >>> Y0 = persalys.Output('Y0')
    >>> model = persalys.SymbolicPhysicalModel('aModelPhys', [X0, X1], [Y0], ['sin(X0)+8*X1'])

    Create the design of experiments:

    >>> filename = 'normal.csv'
    >>> ot.Normal(3).getSample(10).exportToCSVFile(filename)
    >>> aDesign = persalys.ImportedDesignOfExperiment('aDesign', model, filename, [0, 2])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.ImportedDesignOfExperiment_getClassName(self)

    def setColumns(self, *args):
        r"""
        Columns and names of variables accessor.

        Parameters
        ----------
        inputColumns : sequence of int
            Columns of input variables
        inNames : sequence of str
           Names of input variables
        outputColumns : sequence of int, optional
            Columns of output variables
        outNames : sequence of str
           Names of output variables
        """
        return _persalys.ImportedDesignOfExperiment_setColumns(self, *args)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.ImportedDesignOfExperiment_getPythonScript(self)

    def __repr__(self):
        return _persalys.ImportedDesignOfExperiment___repr__(self)

    def __init__(self, *args):
        _persalys.ImportedDesignOfExperiment_swiginit(self, _persalys.new_ImportedDesignOfExperiment(*args))
    __swig_destroy__ = _persalys.delete_ImportedDesignOfExperiment

# Register ImportedDesignOfExperiment in _persalys:
_persalys.ImportedDesignOfExperiment_swigregister(ImportedDesignOfExperiment)
class ProbabilisticDesignOfExperiment(DesignOfExperimentEvaluation):
    r"""
    Create a probabilistic design of experiments.

    Available constructors:
        ProbabilisticDesignOfExperiment(*name, physicalModel*)

        ProbabilisticDesignOfExperiment(*name, physicalModel, size, designName*)

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model with at least a stochastic input variable.
    size : positive int
        Number of points in the design.
    designName : str
        Name of the design. Use :func:`GetDesignNames()` to list available names.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the design of experiments:

    >>> myDOE = persalys.ProbabilisticDesignOfExperiment('myDOE', myPhysicalModel, 10, 'MONTE_CARLO')
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.ProbabilisticDesignOfExperiment_getClassName(self)

    def setSeed(self, seed):
        r"""
        Initialize the random generator seed.

        Parameters
        ----------
        seed : int
            Seed value.
        """
        return _persalys.ProbabilisticDesignOfExperiment_setSeed(self, seed)

    def getDesignName(self):
        r"""
        Accessor to the design name.

        Returns
        -------
        designName : str
            The design name.
        """
        return _persalys.ProbabilisticDesignOfExperiment_getDesignName(self)

    def setDesignName(self, name):
        r"""
        Accessor to the design name.

        Parameters
        ----------
        designName : str
            The design name. Use :func:`GetDesignNames()` to list available names.
        """
        return _persalys.ProbabilisticDesignOfExperiment_setDesignName(self, name)

    def getSpaceFilling(self):
        return _persalys.ProbabilisticDesignOfExperiment_getSpaceFilling(self)

    def setSpaceFilling(self, name):
        return _persalys.ProbabilisticDesignOfExperiment_setSpaceFilling(self, name)

    @staticmethod
    def GetDesignNames():
        r"""
        Accessor to the list of designs provided by ProbabilisticDesignOfExperiment.

        Returns
        -------
        names : :py:class:`openturns.Description`
            List of design names provided by ProbabilisticDesignOfExperiment.

        Examples
        --------
        >>> import persalys
        >>> print(persalys.ProbabilisticDesignOfExperiment.GetDesignNames())
        [LHS,SALHS,MCLHS,MONTE_CARLO,QUASI_MONTE_CARLO]

        """
        return _persalys.ProbabilisticDesignOfExperiment_GetDesignNames()

    @staticmethod
    def GetSpaceFillings():
        return _persalys.ProbabilisticDesignOfExperiment_GetSpaceFillings()

    def getSize(self):
        r"""
        Accessor to the size of the generated sample.

        Returns
        -------
        size : positive int
            Number of points in the design.
        """
        return _persalys.ProbabilisticDesignOfExperiment_getSize(self)

    def setSize(self, size):
        r"""
        Accessor to the size of the generated sample.

        Parameters
        ----------
        size : positive int
            Number of points in the design.
        """
        return _persalys.ProbabilisticDesignOfExperiment_setSize(self, size)

    def getMCLHSSize(self):
        return _persalys.ProbabilisticDesignOfExperiment_getMCLHSSize(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.ProbabilisticDesignOfExperiment_getPythonScript(self)

    def __repr__(self):
        return _persalys.ProbabilisticDesignOfExperiment___repr__(self)

    def __init__(self, *args):
        _persalys.ProbabilisticDesignOfExperiment_swiginit(self, _persalys.new_ProbabilisticDesignOfExperiment(*args))
    __swig_destroy__ = _persalys.delete_ProbabilisticDesignOfExperiment

# Register ProbabilisticDesignOfExperiment in _persalys:
_persalys.ProbabilisticDesignOfExperiment_swigregister(ProbabilisticDesignOfExperiment)
class ModelEvaluation(GridDesignOfExperiment):
    r"""
    Generate a simple evaluation of a model.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    values : :py:class:`openturns.Point`
        Input values (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the Model evaluation:

    >>> analysis = persalys.ModelEvaluation('anAnalysis', myPhysicalModel)
    >>> analysis.run()

    Get the result:

    >>> outputValues = analysis.getResult().getDesignOfExperiment().getOutputSample()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.ModelEvaluation_getClassName(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.ModelEvaluation_getPythonScript(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.ModelEvaluation_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.ModelEvaluation___repr__(self)

    def __init__(self, *args):
        _persalys.ModelEvaluation_swiginit(self, _persalys.new_ModelEvaluation(*args))
    __swig_destroy__ = _persalys.delete_ModelEvaluation

# Register ModelEvaluation in _persalys:
_persalys.ModelEvaluation_swigregister(ModelEvaluation)
class FieldModelEvaluation(ModelEvaluation):
    r"""
    Generate the evaluation of a model with mesh.

    Parameters
    ----------
    name : str
        Name
    model : :class:`~persalys.PhysicalModel`
        Model containing a mesh
    values : sequence of float
        Input values (optional)

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> meshModel = persalys.GridMeshModel(ot.Interval(0., 12.), [5])

    >>> z0 = persalys.Input('z0', 100, '')
    >>> v0 = persalys.Input('v0', 55, '')
    >>> m = persalys.Input('m', 80, '')
    >>> c = persalys.Input('c', 15, '')
    >>> z = persalys.Output('z', '')
    >>> formula = ['max(0, z0 + (m * 9.81 / c) * t + (m / c) * (v0 - (m * 9.81 / c)) * (1 - exp(-t * c / m)))']

    >>> model = persalys.SymbolicFieldModel('aModel', meshModel, [z0, v0, m, c], [z], formula)

    Create the analysis:

    >>> analysis = persalys.FieldModelEvaluation('analysis', model)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FieldModelEvaluation_getClassName(self)

    def getProcessSample(self):
        return _persalys.FieldModelEvaluation_getProcessSample(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.FieldModelEvaluation_hasValidResult(self)

    def __init__(self, *args):
        _persalys.FieldModelEvaluation_swiginit(self, _persalys.new_FieldModelEvaluation(*args))
    __swig_destroy__ = _persalys.delete_FieldModelEvaluation

# Register FieldModelEvaluation in _persalys:
_persalys.FieldModelEvaluation_swigregister(FieldModelEvaluation)
class DataAnalysis(DesignOfExperimentAnalysis):
    r"""
    Create a data analysis of a design of experiments.

    Parameters
    ----------
    name : str
        Name
    design : :class:`~persalys.DesignOfExperiment`
        Design of experiments

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys
    >>> ot.RandomGenerator.SetSeed(0)

    Create the model:

    >>> filename = 'data.csv'
    >>> sample = ot.Normal(3).getSample(100)
    >>> sample.exportToCSVFile(filename)
    >>> model = persalys.DataModel('myDataModel', 'data.csv', [0, 1, 2])

    Create the Data analysis:

    >>> analysis = persalys.DataAnalysis('analysis', model)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> mean = result.getMean()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.DataAnalysis_getClassName(self)

    def isConfidenceIntervalRequired(self):
        r"""
        Whether a confidence interval is required.

        Returns
        -------
        value : bool
            Whether a confidence interval is required.
        """
        return _persalys.DataAnalysis_isConfidenceIntervalRequired(self)

    def setIsConfidenceIntervalRequired(self, isRequired):
        r"""
        Whether a confidence interval is required.

        Parameters
        ----------
        value : bool
            Whether a confidence interval is required
        """
        return _persalys.DataAnalysis_setIsConfidenceIntervalRequired(self, isRequired)

    def getLevelConfidenceInterval(self):
        r"""
        Confidence interval level accessor.

        Returns
        -------
        value : float
            Confidence interval level.
        """
        return _persalys.DataAnalysis_getLevelConfidenceInterval(self)

    def setLevelConfidenceInterval(self, level):
        r"""
        Confidence interval level accessor.

        Parameters
        ----------
        value : float
            Confidence interval level
        """
        return _persalys.DataAnalysis_setLevelConfidenceInterval(self, level)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.DataAnalysisResult`
            Result.
        """
        return _persalys.DataAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.DataAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.DataAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.DataAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.DataAnalysis_swiginit(self, _persalys.new_DataAnalysis(*args))
    __swig_destroy__ = _persalys.delete_DataAnalysis

# Register DataAnalysis in _persalys:
_persalys.DataAnalysis_swigregister(DataAnalysis)
class TaylorExpansionMomentsResult(AnalysisResult):
    r"""Get the results of Taylor expansions for moments estimation."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.TaylorExpansionMomentsResult_getClassName(self)

    def getOutputNames(self):
        r"""
        Output variable names accessor.

        Returns
        -------
        listXMax : :py:class:`openturns.Description`
            Output variable names
        """
        return _persalys.TaylorExpansionMomentsResult_getOutputNames(self)

    def getMeanFirstOrder(self):
        r"""
        First order mean accessor.

        Returns
        -------
        mean : :py:class:`openturns.Point`
            First order mean
        """
        return _persalys.TaylorExpansionMomentsResult_getMeanFirstOrder(self)

    def getMeanSecondOrder(self):
        r"""
        Second order mean accessor.

        Returns
        -------
        mean : :py:class:`openturns.Point`
            Second order mean
        """
        return _persalys.TaylorExpansionMomentsResult_getMeanSecondOrder(self)

    def getStandardDeviation(self):
        r"""
        Standard deviation accessor.

        Returns
        -------
        mean : :py:class:`openturns.Point`
            Standard deviation
        """
        return _persalys.TaylorExpansionMomentsResult_getStandardDeviation(self)

    def getVariance(self):
        r"""
        Variance accessor.

        Returns
        -------
        mean : :py:class:`openturns.Point`
            Variance
        """
        return _persalys.TaylorExpansionMomentsResult_getVariance(self)

    def __repr__(self):
        return _persalys.TaylorExpansionMomentsResult___repr__(self)

    def __init__(self, *args):
        _persalys.TaylorExpansionMomentsResult_swiginit(self, _persalys.new_TaylorExpansionMomentsResult(*args))
    __swig_destroy__ = _persalys.delete_TaylorExpansionMomentsResult

# Register TaylorExpansionMomentsResult in _persalys:
_persalys.TaylorExpansionMomentsResult_swigregister(TaylorExpansionMomentsResult)
class MonteCarloAnalysis(SimulationAnalysis, WithStopCriteriaAnalysis):
    r"""
    Perform a Monte Carlo central tendency analysis.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the Monte Carlo analysis:

    >>> analysis = persalys.MonteCarloAnalysis('anAnalysis', myPhysicalModel)
    >>> analysis.setMaximumCalls(500)
    >>> analysis.setBlockSize(500)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> mean = result.getMean()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MonteCarloAnalysis_getClassName(self)

    def getMaximumConfidenceIntervalLength(self):
        return _persalys.MonteCarloAnalysis_getMaximumConfidenceIntervalLength(self)

    def setMaximumConfidenceIntervalLength(self, length):
        return _persalys.MonteCarloAnalysis_setMaximumConfidenceIntervalLength(self, length)

    def isConfidenceIntervalRequired(self):
        r"""
        Confidence interval flag accessor.

        Returns
        -------
        flag : bool
            Confidence interval flag
        """
        return _persalys.MonteCarloAnalysis_isConfidenceIntervalRequired(self)

    def setIsConfidenceIntervalRequired(self, isConfidenceIntervalRequired):
        r"""
        Confidence interval flag accessor.

        Parameters
        ----------
        flag : bool
            Confidence interval flag
        """
        return _persalys.MonteCarloAnalysis_setIsConfidenceIntervalRequired(self, isConfidenceIntervalRequired)

    def getLevelConfidenceInterval(self):
        r"""
        Confidence interval level accessor.

        Returns
        -------
        level : float
            Confidence interval level. It is set by default to 0.95.
        """
        return _persalys.MonteCarloAnalysis_getLevelConfidenceInterval(self)

    def setLevelConfidenceInterval(self, levelConfidenceInterval):
        r"""
        Confidence interval level accessor.

        Parameters
        ----------
        level : float
            Confidence interval level. It is set by default to 0.95.
        """
        return _persalys.MonteCarloAnalysis_setLevelConfidenceInterval(self, levelConfidenceInterval)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.DataAnalysisResult`
            Result
        """
        return _persalys.MonteCarloAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.MonteCarloAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.MonteCarloAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.MonteCarloAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.MonteCarloAnalysis_swiginit(self, _persalys.new_MonteCarloAnalysis(*args))
    __swig_destroy__ = _persalys.delete_MonteCarloAnalysis

# Register MonteCarloAnalysis in _persalys:
_persalys.MonteCarloAnalysis_swigregister(MonteCarloAnalysis)
class KarhunenLoeveResultCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_KarhunenLoeveResultCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.KarhunenLoeveResultCollection_clear(self)

    def __len__(self):
        return _persalys.KarhunenLoeveResultCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.KarhunenLoeveResultCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.KarhunenLoeveResultCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.KarhunenLoeveResultCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.KarhunenLoeveResultCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.KarhunenLoeveResultCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.KarhunenLoeveResultCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.KarhunenLoeveResultCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.KarhunenLoeveResultCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.KarhunenLoeveResultCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.KarhunenLoeveResultCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.KarhunenLoeveResultCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.KarhunenLoeveResultCollection_find(self, val)

    def __repr__(self):
        return _persalys.KarhunenLoeveResultCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.KarhunenLoeveResultCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.KarhunenLoeveResultCollection_swiginit(self, _persalys.new_KarhunenLoeveResultCollection(*args))

# Register KarhunenLoeveResultCollection in _persalys:
_persalys.KarhunenLoeveResultCollection_swigregister(KarhunenLoeveResultCollection)
class FieldMonteCarloResult(EvaluationResult):
    r"""Get the results of a Monte Carlo analysis with mesh."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FieldMonteCarloResult_getClassName(self)

    def getProcessSample(self):
        r"""
        Output values accessor.

        Returns
        -------
        sample : :py:class:`openturns.ProcessSample`
            Output values
        """
        return _persalys.FieldMonteCarloResult_getProcessSample(self)

    def getMeanSample(self):
        r"""
        Mean trajectory accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Mean trajectory for each output
        """
        return _persalys.FieldMonteCarloResult_getMeanSample(self)

    def getLowerQuantileSample(self):
        r"""
        Lower quantile accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Lower quantile trajectory for each output at *level* defined in
            :meth:`persalys.FieldMonteCarloAnalysis.getQuantileLevel`
        """
        return _persalys.FieldMonteCarloResult_getLowerQuantileSample(self)

    def getUpperQuantileSample(self):
        r"""
        Upper quantile accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Upper quantile trajectory for each output at *1-level* defined in
            :meth:`persalys.FieldMonteCarloAnalysis.getQuantileLevel`
        """
        return _persalys.FieldMonteCarloResult_getUpperQuantileSample(self)

    def getXiSamples(self):
        r"""
        :math:`X_i` distribution values accessor.

        Returns
        -------
        samples : sequence of :py:class:`openturns.Sample`
            Distribution values of the :math:`X_i` variables of the Karhunen Loeve decomposition
        """
        return _persalys.FieldMonteCarloResult_getXiSamples(self)

    def getCorrelationFunction(self):
        r"""
        Correlation function accessor.

        Returns
        -------
        functions : sequence of :py:class:`openturns.Function`
            Correlation function for each output
        """
        return _persalys.FieldMonteCarloResult_getCorrelationFunction(self)

    def getKarhunenLoeveResults(self):
        return _persalys.FieldMonteCarloResult_getKarhunenLoeveResults(self)

    def __repr__(self):
        return _persalys.FieldMonteCarloResult___repr__(self)

    def __init__(self, *args):
        _persalys.FieldMonteCarloResult_swiginit(self, _persalys.new_FieldMonteCarloResult(*args))
    __swig_destroy__ = _persalys.delete_FieldMonteCarloResult

# Register FieldMonteCarloResult in _persalys:
_persalys.FieldMonteCarloResult_swigregister(FieldMonteCarloResult)
class CovFunctionEvaluation(openturns.func.EvaluationImplementation):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CovFunctionEvaluation_getClassName(self)

    def __init__(self, *args):
        _persalys.CovFunctionEvaluation_swiginit(self, _persalys.new_CovFunctionEvaluation(*args))

    def getInputDimension(self):
        r"""
        Accessor to the number of the inputs.

        Returns
        -------
        number_inputs : int
            Number of inputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.SymbolicFunction(['x1', 'x2'],
        ...                         ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getInputDimension())
        2
        """
        return _persalys.CovFunctionEvaluation_getInputDimension(self)

    def getOutputDimension(self):
        r"""
        Accessor to the number of the outputs.

        Returns
        -------
        number_outputs : int
            Number of outputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.SymbolicFunction(['x1', 'x2'],
        ...                         ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getOutputDimension())
        1
        """
        return _persalys.CovFunctionEvaluation_getOutputDimension(self)

    def __call__(self, inP):
        return _persalys.CovFunctionEvaluation___call__(self, inP)
    __swig_destroy__ = _persalys.delete_CovFunctionEvaluation

# Register CovFunctionEvaluation in _persalys:
_persalys.CovFunctionEvaluation_swigregister(CovFunctionEvaluation)
class FieldMonteCarloAnalysis(SimulationAnalysis, WithStopCriteriaAnalysis):
    r"""
    Run a Monte Carlo analysis for models with mesh.

    Parameters
    ----------
    name : str
        Name
    model : :class:`~persalys.PhysicalModel`
        Model containing a mesh

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> meshModel = persalys.GridMeshModel(ot.Interval(0., 12.), [5])

    >>> z0 = persalys.Input('z0', 100, ot.Uniform(100, 150))
    >>> v0 = persalys.Input('v0', 55, ot.Normal(55, 10))
    >>> m = persalys.Input('m', 80, ot.Normal(80, 8))
    >>> c = persalys.Input('c', 15, ot.Uniform(0, 30))
    >>> z = persalys.Output('z', '')
    >>> formula = ['max(0, z0 + (m * 9.81 / c) * t + (m / c) * (v0 - (m * 9.81 / c)) * (1 - exp(-t * c / m)))']

    >>> model = persalys.SymbolicFieldModel('aModel', meshModel, [z0, v0, m, c], [z], formula)

    Create the analysis:

    >>> analysis = persalys.FieldMonteCarloAnalysis('analysis', model)
    >>> analysis.setMaximumCalls(30)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FieldMonteCarloAnalysis_getClassName(self)

    def getKarhunenLoeveThreshold(self):
        r"""
        Accessor to the limit ratio on eigenvalues.

        Returns
        -------
        threshold : float, positive
            The threshold s defined in :py:meth:`openturns.KarhunenLoeveAlgorithm.setThreshold`
        """
        return _persalys.FieldMonteCarloAnalysis_getKarhunenLoeveThreshold(self)

    def setKarhunenLoeveThreshold(self, threshold):
        r"""
        Accessor to the limit ratio on eigenvalues.

        Parameters
        ----------
        threshold : float, positive
            The threshold s defined in :py:meth:`openturns.KarhunenLoeveAlgorithm.getThreshold`
        """
        return _persalys.FieldMonteCarloAnalysis_setKarhunenLoeveThreshold(self, threshold)

    def getQuantileLevel(self):
        r"""
        Probability level accessor.

        Returns
        -------
        level : float
            Probability level
        """
        return _persalys.FieldMonteCarloAnalysis_getQuantileLevel(self)

    def setQuantileLevel(self, proba):
        r"""
        Probability level accessor.

        Parameters
        ----------
        level : float, :math:`0 < p < 1`
            Probability level
        """
        return _persalys.FieldMonteCarloAnalysis_setQuantileLevel(self, proba)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`persalys.FieldMonteCarloResult`
            Result
        """
        return _persalys.FieldMonteCarloAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.FieldMonteCarloAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.FieldMonteCarloAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.FieldMonteCarloAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.FieldMonteCarloAnalysis_swiginit(self, _persalys.new_FieldMonteCarloAnalysis(*args))
    __swig_destroy__ = _persalys.delete_FieldMonteCarloAnalysis

# Register FieldMonteCarloAnalysis in _persalys:
_persalys.FieldMonteCarloAnalysis_swigregister(FieldMonteCarloAnalysis)
class TaylorExpansionMomentsAnalysis(PhysicalModelAnalysis):
    r"""
    Get the Taylor expansions for moments estimation.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the Taylor expansion analysis:

    >>> analysis = persalys.TaylorExpansionMomentsAnalysis('anAnalysis', myPhysicalModel)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> mean = result.getMeanFirstOrder()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.TaylorExpansionMomentsAnalysis_getClassName(self)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.TaylorExpansionMomentsResult`
            Result
        """
        return _persalys.TaylorExpansionMomentsAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.TaylorExpansionMomentsAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.TaylorExpansionMomentsAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.TaylorExpansionMomentsAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.TaylorExpansionMomentsAnalysis_swiginit(self, _persalys.new_TaylorExpansionMomentsAnalysis(*args))
    __swig_destroy__ = _persalys.delete_TaylorExpansionMomentsAnalysis

# Register TaylorExpansionMomentsAnalysis in _persalys:
_persalys.TaylorExpansionMomentsAnalysis_swigregister(TaylorExpansionMomentsAnalysis)
class SobolResult(EvaluationResult):
    r"""Get the results of a Sobol sensitivity analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SobolResult_getClassName(self)

    def getOutputNames(self):
        r"""
        Output variables names accessor.

        Returns
        -------
        sample : :py:class:`openturns.Description`
            Output variables names
        """
        return _persalys.SobolResult_getOutputNames(self)

    def getInputNames(self):
        r"""
        Input variables names accessor.

        Returns
        -------
        sample : :py:class:`openturns.Description`
            Input variables names
        """
        return _persalys.SobolResult_getInputNames(self)

    def getFirstOrderIndices(self):
        r"""
        First order indices accessor.

        Returns
        -------
        indices : :py:class:`openturns.Sample`
            First order indices
        """
        return _persalys.SobolResult_getFirstOrderIndices(self)

    def getTotalIndices(self):
        r"""
        Total indices accessor.

        Returns
        -------
        indices : :py:class:`openturns.Sample`
            Total indices
        """
        return _persalys.SobolResult_getTotalIndices(self)

    def getFirstOrderIndicesInterval(self):
        r"""
        First order indices interval accessor.

        Returns
        -------
        interval : sequence of :py:class:`openturns.Interval`
            First order indices interval
        """
        return _persalys.SobolResult_getFirstOrderIndicesInterval(self)

    def getTotalIndicesInterval(self):
        r"""
        Total indices interval accessor.

        Returns
        -------
        interval : sequence of :py:class:`openturns.Interval`
            Total indices interval
        """
        return _persalys.SobolResult_getTotalIndicesInterval(self)

    def getAggregatedFirstOrderIndices(self):
        return _persalys.SobolResult_getAggregatedFirstOrderIndices(self)

    def getAggregatedTotalIndices(self):
        return _persalys.SobolResult_getAggregatedTotalIndices(self)

    def getAggregatedFirstOrderIndicesInterval(self):
        return _persalys.SobolResult_getAggregatedFirstOrderIndicesInterval(self)

    def getAggregatedTotalIndicesInterval(self):
        return _persalys.SobolResult_getAggregatedTotalIndicesInterval(self)

    def getCallsNumber(self):
        r"""
        Number of calls accessor.

        Returns
        -------
        calls : int
            Number of function calls
        """
        return _persalys.SobolResult_getCallsNumber(self)

    def getConfidenceIntervalLength(self):
        r"""
        Confidence interval length accessor.

        Returns
        -------
        length : float
            Maximum confidence interval length of all components and both indices
        """
        return _persalys.SobolResult_getConfidenceIntervalLength(self)

    def __repr__(self):
        return _persalys.SobolResult___repr__(self)

    def __init__(self, *args):
        _persalys.SobolResult_swiginit(self, _persalys.new_SobolResult(*args))
    __swig_destroy__ = _persalys.delete_SobolResult

# Register SobolResult in _persalys:
_persalys.SobolResult_swigregister(SobolResult)
class SobolAnalysis(SimulationAnalysis, WithStopCriteriaAnalysis):
    r"""
    Run a Sobol sensitivity analysis.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the Sobol analysis:

    >>> analysis = persalys.SobolAnalysis('anAnalysis', myPhysicalModel)
    >>> analysis.setMaximumCalls(500)
    >>> analysis.setReplicationSize(125)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> indices = result.getFirstOrderIndices()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SobolAnalysis_getClassName(self)

    def getMaximumConfidenceIntervalLength(self):
        return _persalys.SobolAnalysis_getMaximumConfidenceIntervalLength(self)

    def setMaximumConfidenceIntervalLength(self, length):
        return _persalys.SobolAnalysis_setMaximumConfidenceIntervalLength(self, length)

    def getReplicationSize(self):
        r"""
        Replication size accessor.

        Returns
        -------
        size : int
            Replication size
        """
        return _persalys.SobolAnalysis_getReplicationSize(self)

    def setReplicationSize(self, size):
        r"""
        Replication size accessor.

        Parameters
        ----------
        size : int > 1
            Replication size
        """
        return _persalys.SobolAnalysis_setReplicationSize(self, size)

    def getConfidenceLevel(self):
        r"""
        Confidence level accessor.

        Returns
        -------
        level : float
            Confidence level
        """
        return _persalys.SobolAnalysis_getConfidenceLevel(self)

    def setConfidenceLevel(self, level):
        r"""
        Confidence level accessor.

        Parameters
        ----------
        level : float in ]0,1[
            Confidence level
        """
        return _persalys.SobolAnalysis_setConfidenceLevel(self, level)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.SobolResult`
            Result
        """
        return _persalys.SobolAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.SobolAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.SobolAnalysis_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.SobolAnalysis_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.SobolAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.SobolAnalysis_swiginit(self, _persalys.new_SobolAnalysis(*args))
    __swig_destroy__ = _persalys.delete_SobolAnalysis

# Register SobolAnalysis in _persalys:
_persalys.SobolAnalysis_swigregister(SobolAnalysis)
class SRCResult(EvaluationResult):
    r"""Get the results of a SRC sensitivity analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SRCResult_getClassName(self)

    def getOutputNames(self):
        r"""
        Output variable names accessor.

        Returns
        -------
        sample : :py:class:`openturns.Description`
            Output variable names
        """
        return _persalys.SRCResult_getOutputNames(self)

    def getInputNames(self):
        r"""
        Input variable names accessor.

        Returns
        -------
        sample : :py:class:`openturns.Description`
            Input variable names
        """
        return _persalys.SRCResult_getInputNames(self)

    def getIndices(self):
        r"""
        SRC indices accessor.

        Returns
        -------
        indices : :py:class:`openturns.Point`
            SRC indices
        """
        return _persalys.SRCResult_getIndices(self)

    def getSignedIndices(self):
        return _persalys.SRCResult_getSignedIndices(self)

    def getIndicesInterval(self):
        return _persalys.SRCResult_getIndicesInterval(self)

    def getSignedIndicesInterval(self):
        return _persalys.SRCResult_getSignedIndicesInterval(self)

    def getCallsNumber(self):
        return _persalys.SRCResult_getCallsNumber(self)

    def getR2(self):
        return _persalys.SRCResult_getR2(self)

    def __repr__(self):
        return _persalys.SRCResult___repr__(self)

    def __init__(self, *args):
        _persalys.SRCResult_swiginit(self, _persalys.new_SRCResult(*args))
    __swig_destroy__ = _persalys.delete_SRCResult

# Register SRCResult in _persalys:
_persalys.SRCResult_swigregister(SRCResult)
class SRCAnalysis(SimulationAnalysis):
    r"""
    Run a SRC sensitivity analysis.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    simulationsNumber : int
        Simulations number (optional). By default it is 10000.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the SRC analysis:

    >>> analysis = persalys.SRCAnalysis('anAnalysis', myPhysicalModel, 1000)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> indices = result.getIndices()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SRCAnalysis_getClassName(self)

    def getSimulationsNumber(self):
        r"""
        Simulations number accessor.

        Returns
        -------
        number : int
            Number of simulations
        """
        return _persalys.SRCAnalysis_getSimulationsNumber(self)

    def setSimulationsNumber(self, number):
        r"""
        Simulations number accessor.

        Parameters
        ----------
        number : int
            Number of simulations. By default it is 10000.
        """
        return _persalys.SRCAnalysis_setSimulationsNumber(self, number)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.SRCResult`
            Result
        """
        return _persalys.SRCAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.SRCAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.SRCAnalysis_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.SRCAnalysis_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.SRCAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.SRCAnalysis_swiginit(self, _persalys.new_SRCAnalysis(*args))
    __swig_destroy__ = _persalys.delete_SRCAnalysis

# Register SRCAnalysis in _persalys:
_persalys.SRCAnalysis_swigregister(SRCAnalysis)
class MorrisResult(EvaluationResult):
    r"""
    Get the result of a Morris analysis.

    Notes
    -----
    Structure created by the method run() of
    :class:`~persalys.MorrisAnalysis`, and obtained thanks to the method
    getResult().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MorrisResult_getClassName(self)

    def getInputsSelection(self, marginal):
        r"""
        Input selection accessor.

        Parameters
        ----------
        marginal : int
            Output marginal of interest

        Returns
        -------
        selection : :py:class:`openturns.Indices`
            Whether the inputs are selected
        """
        return _persalys.MorrisResult_getInputsSelection(self, marginal)

    def setInputsSelection(self, marginal, values):
        r"""
        Input selection accessor.

        Parameters
        ----------
        marginal : positive int
            Output marginal of interest
        selection : :py:class:`openturns.Indices`
            Whether the inputs are selected
        """
        return _persalys.MorrisResult_setInputsSelection(self, marginal, values)

    def getNoEffectBoundary(self, marginal):
        r"""
        No effect boundary accessor.

        Parameters
        ----------
        marginal : int
            Output marginal of interest

        Returns
        -------
        boundary : float
            No effect boundary
        """
        return _persalys.MorrisResult_getNoEffectBoundary(self, marginal)

    def setNoEffectBoundary(self, marginal, value):
        r"""
        No effect boundary accessor.

        Parameters
        ----------
        marginal : positive int
            Output marginal of interest
        boundary : float
            No effect boundary
        """
        return _persalys.MorrisResult_setNoEffectBoundary(self, marginal, value)

    def getMeanAbsoluteElementaryEffects(self, outputMarginal):
        return _persalys.MorrisResult_getMeanAbsoluteElementaryEffects(self, outputMarginal)

    def getMeanElementaryEffects(self, outputMarginal):
        return _persalys.MorrisResult_getMeanElementaryEffects(self, outputMarginal)

    def getStandardDeviationElementaryEffects(self, outputMarginal):
        return _persalys.MorrisResult_getStandardDeviationElementaryEffects(self, outputMarginal)

    def __repr__(self):
        return _persalys.MorrisResult___repr__(self)

    def __init__(self, *args):
        _persalys.MorrisResult_swiginit(self, _persalys.new_MorrisResult(*args))
    __swig_destroy__ = _persalys.delete_MorrisResult

# Register MorrisResult in _persalys:
_persalys.MorrisResult_swigregister(MorrisResult)
class MorrisAnalysis(SimulationAnalysis):
    r"""
    Perform a Morris analysis.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the Morris analysis:

    >>> analysis = persalys.MorrisAnalysis('anAnalysis', myPhysicalModel)
    >>> analysis.setBounds(ot.Interval([100, 60000], [350, 80000]))
    >>> analysis.setLevel(5)
    >>> analysis.run() # doctest: +SKIP

    Get the result:

    >>> result = analysis.getResult() # doctest: +SKIP
    >>> meanAbsEE = result.getMeanAbsoluteElementaryEffects(0) # doctest: +SKIP
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MorrisAnalysis_getClassName(self)

    def getTrajectoriesNumber(self):
        r"""
        Number of trajectories accessor.

        Returns
        -------
        number : int
            Number of trajectories. It is set by default to 10.
        """
        return _persalys.MorrisAnalysis_getTrajectoriesNumber(self)

    def setTrajectoriesNumber(self, number):
        r"""
        Number of trajectories accessor.

        Parameters
        ----------
        number : positive int
            Number of trajectories
        """
        return _persalys.MorrisAnalysis_setTrajectoriesNumber(self, number)

    def getBounds(self):
        r"""
        Bounds of the domain accessor.

        Returns
        -------
        bounds : :py:class:`openturns.Interval`
            Bounds of the domain
        """
        return _persalys.MorrisAnalysis_getBounds(self)

    def setBounds(self, bounds):
        r"""
        Bounds of the domain accessor.

        Parameters
        ----------
        bounds : :py:class:`openturns.Interval`
            Bounds of the domain
        """
        return _persalys.MorrisAnalysis_setBounds(self, bounds)

    def getLevel(self):
        r"""
        Level accessor.

        Returns
        -------
        number : int
            Number of levels for a regular grid. It is set by default to 4.
        """
        return _persalys.MorrisAnalysis_getLevel(self)

    def setLevel(self, value):
        r"""
        Level accessor.

        Parameters
        ----------
        number : positive int
            Number of levels for a regular grid
        """
        return _persalys.MorrisAnalysis_setLevel(self, value)

    def getResult(self):
        r"""
        Morris result accessor.

        Returns
        -------
        result : :class:`~persalys.MorrisResult`
            Result
        """
        return _persalys.MorrisAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.MorrisAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.MorrisAnalysis_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.MorrisAnalysis_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.MorrisAnalysis___repr__(self)

    def setBlockSize(self, blockSize):
        r"""
        Block size accessor.

        Parameters
        ----------
        blockSize : positive int
            Number of terms analysed together.
            It is set by default to 1.
        """
        return _persalys.MorrisAnalysis_setBlockSize(self, blockSize)

    def getBlockSize(self):
        r"""
        Block size accessor.

        Returns
        -------
        blockSize : positive int
            Number of terms analysed together.
            It is set by default to 1.
        """
        return _persalys.MorrisAnalysis_getBlockSize(self)

    def __init__(self, *args):
        _persalys.MorrisAnalysis_swiginit(self, _persalys.new_MorrisAnalysis(*args))
    __swig_destroy__ = _persalys.delete_MorrisAnalysis

# Register MorrisAnalysis in _persalys:
_persalys.MorrisAnalysis_swigregister(MorrisAnalysis)
class ReliabilityAnalysis(PhysicalModelAnalysis):
    r"""
    Reliability analysis base class.

    The base class for analysis involving a :class:`~persalys.LimitState`.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getParentObserver(self):
        return _persalys.ReliabilityAnalysis_getParentObserver(self)

    def getLimitState(self):
        r"""
        Limit-state accessor.

        Returns
        -------
        limitState : :class:`~persalys.LimitState`
            The Limit-state.
        """
        return _persalys.ReliabilityAnalysis_getLimitState(self)

    def setInterestVariables(self, outputsNames):
        r"""
        Set the variables to analyse.

        Parameters
        ----------
        variablesNames : sequence of str
            Names of the variables to analyse
        """
        return _persalys.ReliabilityAnalysis_setInterestVariables(self, outputsNames)

    def run(self):
        r"""Launch the analysis."""
        return _persalys.ReliabilityAnalysis_run(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.ReliabilityAnalysis_canBeLaunched(self, errorMessage)

    def __init__(self, *args):
        _persalys.ReliabilityAnalysis_swiginit(self, _persalys.new_ReliabilityAnalysis(*args))

    def __repr__(self, *args):
        return _persalys.ReliabilityAnalysis___repr__(self, *args)
    __swig_destroy__ = _persalys.delete_ReliabilityAnalysis

# Register ReliabilityAnalysis in _persalys:
_persalys.ReliabilityAnalysis_swigregister(ReliabilityAnalysis)
class SimulationReliabilityResult(EvaluationResult):
    r"""Get simulation results from a reliability analysis using Monte Carlo or Importance Sampling method."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SimulationReliabilityResult_getClassName(self)

    def getSimulationResult(self):
        r"""
        Simulation result accessor.

        Returns
        -------
        sample : :py:class:`openturns.SimulationResult`
            Simulation result
        """
        return _persalys.SimulationReliabilityResult_getSimulationResult(self)

    def getConvergenceSample(self):
        r"""
        Convergence sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Convergence sample
        """
        return _persalys.SimulationReliabilityResult_getConvergenceSample(self)

    def getConvergenceSampleLowerBound(self):
        r"""
        Convergence sample lower bound accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Convergence sample lower bound
        """
        return _persalys.SimulationReliabilityResult_getConvergenceSampleLowerBound(self)

    def getConvergenceSampleUpperBound(self):
        r"""
        Convergence sample upper bound accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Convergence sample upper bound
        """
        return _persalys.SimulationReliabilityResult_getConvergenceSampleUpperBound(self)

    def __repr__(self):
        return _persalys.SimulationReliabilityResult___repr__(self)

    def __init__(self, *args):
        _persalys.SimulationReliabilityResult_swiginit(self, _persalys.new_SimulationReliabilityResult(*args))
    __swig_destroy__ = _persalys.delete_SimulationReliabilityResult

# Register SimulationReliabilityResult in _persalys:
_persalys.SimulationReliabilityResult_swigregister(SimulationReliabilityResult)
class SimulationReliabilityAnalysis(ReliabilityAnalysis, WithStopCriteriaAnalysis):
    r"""
    Reliability analysis using simulation method.

    Parameters
    ----------
    name : str
        Name
    limitState : :class:`~persalys.LimitState`
        Limit state
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getSeed(self):
        r"""
        Seed accessor.

        Returns
        -------
        seed : int
            Seed
        """
        return _persalys.SimulationReliabilityAnalysis_getSeed(self)

    def setSeed(self, seed):
        r"""
        Seed accessor.

        Parameters
        ----------
        seed : int
            Seed
        """
        return _persalys.SimulationReliabilityAnalysis_setSeed(self, seed)

    def getBlockSize(self):
        r"""
        Block size accessor.

        Returns
        -------
        size : int
            Number of terms in the probability simulation estimator grouped together.
            It is set by default to 1.
        """
        return _persalys.SimulationReliabilityAnalysis_getBlockSize(self)

    def setBlockSize(self, size):
        r"""
        Block size accessor.

        Parameters
        ----------
        size : int
            Number of terms in the probability simulation estimator grouped together.
            It is set by default to 1.
        """
        return _persalys.SimulationReliabilityAnalysis_setBlockSize(self, size)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.SimulationReliabilityResult`
            Result
        """
        return _persalys.SimulationReliabilityAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.SimulationReliabilityAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.SimulationReliabilityAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.SimulationReliabilityAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.SimulationReliabilityAnalysis_swiginit(self, _persalys.new_SimulationReliabilityAnalysis(*args))
    __swig_destroy__ = _persalys.delete_SimulationReliabilityAnalysis

# Register SimulationReliabilityAnalysis in _persalys:
_persalys.SimulationReliabilityAnalysis_swigregister(SimulationReliabilityAnalysis)
class MonteCarloReliabilityAnalysis(SimulationReliabilityAnalysis):
    r"""
    Run a reliability analysis using the Monte Carlo method.

    Parameters
    ----------
    name : str
        Name
    limitState : :class:`~persalys.LimitState`
        Limit state

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', myPhysicalModel, 'G', ot.Less(), 0.)

    Process a reliability analysis using the Monte Carlo method:

    >>> analysis = persalys.MonteCarloReliabilityAnalysis('myAnalysis', limitState)
    >>> analysis.setMaximumCalls(1000)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> pf = result.getSimulationResult().getProbabilityEstimate()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MonteCarloReliabilityAnalysis_getClassName(self)

    def __init__(self, *args):
        _persalys.MonteCarloReliabilityAnalysis_swiginit(self, _persalys.new_MonteCarloReliabilityAnalysis(*args))
    __swig_destroy__ = _persalys.delete_MonteCarloReliabilityAnalysis

# Register MonteCarloReliabilityAnalysis in _persalys:
_persalys.MonteCarloReliabilityAnalysis_swigregister(MonteCarloReliabilityAnalysis)
class ImportanceSamplingAnalysis(SimulationReliabilityAnalysis):
    r"""
    Run importance sampling for reliability analysis.

    Parameters
    ----------
    name : str
        Name
    limitState : :class:`~persalys.LimitState`
        Limit state

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', myPhysicalModel, 'G', ot.Less(), 0.)

    Process the reliability analysis:

    >>> analysis = persalys.ImportanceSamplingAnalysis('myAnalysis', limitState)
    >>> analysis.setStandardSpaceDesignPoint([-1.59388,0.998942])
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> pf = result.getSimulationResult().getProbabilityEstimate()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.ImportanceSamplingAnalysis_getClassName(self)

    def getStandardSpaceDesignPoint(self):
        r"""
        Accessor to standard space design point.

        Returns
        -------
        point : :py:class:`openturns.Point`
            Standard space design point. It is the mean of the Normal distribution used to sample.
        """
        return _persalys.ImportanceSamplingAnalysis_getStandardSpaceDesignPoint(self)

    def setStandardSpaceDesignPoint(self, point):
        r"""
        Accessor to standard space design point.

        Parameters
        ----------
        point : sequence of float
            Standard space design point. It is the mean of the Normal distribution used to sample
        """
        return _persalys.ImportanceSamplingAnalysis_setStandardSpaceDesignPoint(self, point)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.ImportanceSamplingAnalysis_getPythonScript(self)

    def __repr__(self):
        return _persalys.ImportanceSamplingAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.ImportanceSamplingAnalysis_swiginit(self, _persalys.new_ImportanceSamplingAnalysis(*args))
    __swig_destroy__ = _persalys.delete_ImportanceSamplingAnalysis

# Register ImportanceSamplingAnalysis in _persalys:
_persalys.ImportanceSamplingAnalysis_swigregister(ImportanceSamplingAnalysis)
class ApproximationAnalysis(object):
    r"""
    Class to define reliability analysis using approximation method.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_ApproximationAnalysis

    def getOptimizationAlgorithm(self):
        r"""
        Accessor to the optimization algorithm used to find the design point.

        Returns
        -------
        algorithm : :py:class:`openturns.OptimizationAlgorithm`
            Optimization algorithm used to research the design point. Cobyla is
            the default used algorithm.
        """
        return _persalys.ApproximationAnalysis_getOptimizationAlgorithm(self)

    def setOptimizationAlgorithm(self, solver):
        r"""
        Accessor to the optimization algorithm used to find the design point.

        Parameters
        ----------
        algorithm : :py:class:`openturns.OptimizationAlgorithm`
            Optimization algorithm used to research the design point. Cobyla is
            the default used algorithm.
        """
        return _persalys.ApproximationAnalysis_setOptimizationAlgorithm(self, solver)

    def getPhysicalStartingPoint(self):
        r"""
        Physical starting point accessor.

        Returns
        -------
        point : :py:class:`openturns.Point`
            Physical starting point. By default it set to the mean of the composed
            distribution of the physical model
        """
        return _persalys.ApproximationAnalysis_getPhysicalStartingPoint(self)

    def setPhysicalStartingPoint(self, point):
        r"""
        Physical starting point accessor.

        Parameters
        ----------
        point : sequence of float
            Physical starting point. By default it set to the mean of the composed
            distribution of the physical model
        """
        return _persalys.ApproximationAnalysis_setPhysicalStartingPoint(self, point)

    def __repr__(self):
        return _persalys.ApproximationAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.ApproximationAnalysis_swiginit(self, _persalys.new_ApproximationAnalysis(*args))

# Register ApproximationAnalysis in _persalys:
_persalys.ApproximationAnalysis_swigregister(ApproximationAnalysis)
class FORMAnalysisResult(AnalysisResult):
    r"""Class containing results of the FORM analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FORMAnalysisResult_getClassName(self)

    def getFORMResult(self):
        r"""
        FORM result accessor.

        Returns
        -------
        formResu : :py:class:`openturns.FORMResult`
            FORM result
        """
        return _persalys.FORMAnalysisResult_getFORMResult(self)

    def __repr__(self):
        return _persalys.FORMAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.FORMAnalysisResult_swiginit(self, _persalys.new_FORMAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_FORMAnalysisResult

# Register FORMAnalysisResult in _persalys:
_persalys.FORMAnalysisResult_swigregister(FORMAnalysisResult)
class FORMAnalysis(ReliabilityAnalysis, ApproximationAnalysis):
    r"""
    Process a reliability analysis using the FORM method.

    Parameters
    ----------
    name : str
        Name
    limitState : :class:`~persalys.LimitState`
        Limit state

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', myPhysicalModel, 'G', ot.Less(), 0.)

    Process a reliability analysis using the FORM method:

    >>> analysis = persalys.FORMAnalysis('myAnalysis', limitState)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult().getFORMResult()
    >>> pf = result.getEventProbability()
    >>> designPoint = result.getStandardSpaceDesignPoint()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FORMAnalysis_getClassName(self)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.FORMAnalysisResult`
            Result
        """
        return _persalys.FORMAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.FORMAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.FORMAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.FORMAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.FORMAnalysis_swiginit(self, _persalys.new_FORMAnalysis(*args))
    __swig_destroy__ = _persalys.delete_FORMAnalysis

# Register FORMAnalysis in _persalys:
_persalys.FORMAnalysis_swigregister(FORMAnalysis)
class SORMAnalysisResult(AnalysisResult):
    r"""Class containing results of the SORM analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SORMAnalysisResult_getClassName(self)

    def getSORMResult(self):
        r"""
        SORM result accessor.

        Returns
        -------
        sormResu : :py:class:`openturns.SORMResult`
            SORM result
        """
        return _persalys.SORMAnalysisResult_getSORMResult(self)

    def __repr__(self):
        return _persalys.SORMAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.SORMAnalysisResult_swiginit(self, _persalys.new_SORMAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_SORMAnalysisResult

# Register SORMAnalysisResult in _persalys:
_persalys.SORMAnalysisResult_swigregister(SORMAnalysisResult)
class SORMAnalysis(ReliabilityAnalysis, ApproximationAnalysis):
    r"""
    Run a reliability analysis using the SORM method.

    Parameters
    ----------
    name : str
        Name
    limitState : :class:`~persalys.LimitState`
        Limit state

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', myPhysicalModel, 'G', ot.Less(), 0.)

    Process a reliability analysis using the SORM method:

    >>> analysis = persalys.SORMAnalysis('myAnalysis', limitState)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult().getSORMResult()
    >>> pf = result.getEventProbabilityBreitung()
    >>> designPoint = result.getStandardSpaceDesignPoint()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.SORMAnalysis_getClassName(self)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.SORMAnalysisResult`
            Result
        """
        return _persalys.SORMAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.SORMAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.SORMAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.SORMAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.SORMAnalysis_swiginit(self, _persalys.new_SORMAnalysis(*args))
    __swig_destroy__ = _persalys.delete_SORMAnalysis

# Register SORMAnalysis in _persalys:
_persalys.SORMAnalysis_swigregister(SORMAnalysis)
class FORMImportanceSamplingAnalysis(ImportanceSamplingAnalysis, ApproximationAnalysis):
    r"""
    Run a FORM analysis followed by an importance sampling for reliability analysis.

    Parameters
    ----------
    name : str
        Name
    limitState : :class:`~persalys.LimitState`
        Limit state

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the limit state:

    >>> limitState = persalys.LimitState('ls1', myPhysicalModel, 'G', ot.Less(), 0.)

    Process the reliability analysis:

    >>> analysis = persalys.FORMImportanceSamplingAnalysis('myAnalysis', limitState)
    >>> analysis.setMaximumCalls(1000)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> pf = result.getSimulationResult().getProbabilityEstimate()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FORMImportanceSamplingAnalysis_getClassName(self)

    def getFORMResult(self):
        r"""
        FORM result accessor.

        Returns
        -------
        result : :py:class:`openturns.FORMResult`
            Result of the FORM analysis
        """
        return _persalys.FORMImportanceSamplingAnalysis_getFORMResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.FORMImportanceSamplingAnalysis_getPythonScript(self)

    def __repr__(self):
        return _persalys.FORMImportanceSamplingAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.FORMImportanceSamplingAnalysis_swiginit(self, _persalys.new_FORMImportanceSamplingAnalysis(*args))
    __swig_destroy__ = _persalys.delete_FORMImportanceSamplingAnalysis

# Register FORMImportanceSamplingAnalysis in _persalys:
_persalys.FORMImportanceSamplingAnalysis_swigregister(FORMImportanceSamplingAnalysis)
class MetaModelValidationResult(openturns.common.PersistentObject):
    r"""Create the base class for the results of a metamodel validation."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MetaModelValidationResult_getClassName(self)

    def getName(self):
        r"""
        Validation method name accessor.

        Returns
        -------
        name : str
            Validation method name
        """
        return _persalys.MetaModelValidationResult_getName(self)

    def getMetaModelOutputSample(self):
        r"""
        Output sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Output sample evaluated with the metamodel
        """
        return _persalys.MetaModelValidationResult_getMetaModelOutputSample(self)

    def getResiduals(self):
        r"""
        Residuals accessor.

        Returns
        -------
        error : :py:class:`openturns.Point`
            The errors are defined as follows for each output of the model:
            :math:`\displaystyle \frac{\sqrt{\sum_{i=1}^N (y_i - \hat{y_i})^2}}{N}`
            with :math:`y_i` the :math:`N` model's values and :math:`\hat{y_i}` the
            prediction.
        """
        return _persalys.MetaModelValidationResult_getResiduals(self)

    def getQ2(self):
        r"""
        Q2 accessor.

        Returns
        -------
        q2 : :py:class:`openturns.Point`
            The predictive squared correlation coefficient Q2 is defined as follows for
            each output of the model:
            :math:`1 - \displaystyle \frac{\sum_{i=1}^N (y_i - \hat{y_i})^2}{(N-1) {\rm Var}\left[ \underline{Y} \right]}`
            with :math:`\underline{Y}` the vector of the :math:`N` model's values
            :math:`y_i` and :math:`\hat{y_i}` the prediction.
        """
        return _persalys.MetaModelValidationResult_getQ2(self)

    def __init__(self, *args):
        _persalys.MetaModelValidationResult_swiginit(self, _persalys.new_MetaModelValidationResult(*args))

    def __repr__(self, *args):
        return _persalys.MetaModelValidationResult___repr__(self, *args)
    __swig_destroy__ = _persalys.delete_MetaModelValidationResult

# Register MetaModelValidationResult in _persalys:
_persalys.MetaModelValidationResult_swigregister(MetaModelValidationResult)
class MetaModelAnalysisResult(AnalysisResult):
    r"""Create the base class for a metamodel analysis result."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MetaModelAnalysisResult_getClassName(self)

    def getMetaModel(self):
        r"""
        Metamodel accessor.

        Returns
        -------
        metamodel : :class:`~persalys.MetaModel`
            Metamodel
        """
        return _persalys.MetaModelAnalysisResult_getMetaModel(self)

    def getOutputSample(self):
        r"""
        Output sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Output sample
        """
        return _persalys.MetaModelAnalysisResult_getOutputSample(self)

    def getMetaModelOutputSample(self):
        r"""
        Output sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Output sample evaluated with the metamodel
        """
        return _persalys.MetaModelAnalysisResult_getMetaModelOutputSample(self)

    def getAnalyticalValidation(self):
        r"""
        Analytical validation result accessor.

        Returns
        -------
        validation : :class:`persalys.MetaModelValidationResult`
            Analytical validation result
        """
        return _persalys.MetaModelAnalysisResult_getAnalyticalValidation(self)

    def getTestSampleValidation(self):
        r"""
        Test sample validation result accessor.

        Returns
        -------
        validation : :class:`persalys.MetaModelValidationResult`
            Test sample validation result
        """
        return _persalys.MetaModelAnalysisResult_getTestSampleValidation(self)

    def getKFoldValidation(self):
        r"""
        K-Fold validation result accessor.

        Returns
        -------
        validation : :class:`persalys.MetaModelValidationResult`
            K-Fold validation result
        """
        return _persalys.MetaModelAnalysisResult_getKFoldValidation(self)

    def getLeaveOneOutValidation(self):
        r"""
        Leave-one-out validation result accessor.

        Returns
        -------
        validation : :class:`persalys.MetaModelValidationResult`
            Leave-one-out validation result
        """
        return _persalys.MetaModelAnalysisResult_getLeaveOneOutValidation(self)

    def getValidations(self):
        r"""
        Validation results accessor.

        Returns
        -------
        validations : sequence of :class:`persalys.MetaModelValidationResult`
            All the validation results
        """
        return _persalys.MetaModelAnalysisResult_getValidations(self)

    def __init__(self, *args):
        _persalys.MetaModelAnalysisResult_swiginit(self, _persalys.new_MetaModelAnalysisResult(*args))

    def __repr__(self, *args):
        return _persalys.MetaModelAnalysisResult___repr__(self, *args)
    __swig_destroy__ = _persalys.delete_MetaModelAnalysisResult

# Register MetaModelAnalysisResult in _persalys:
_persalys.MetaModelAnalysisResult_swigregister(MetaModelAnalysisResult)
class MetaModelAnalysis(DesignOfExperimentAnalysis):
    r"""
    Create a base class for the creation of meta models.

    Notes
    -----
    Can only be used through its derived classes.
    See :class:`~persalys.FunctionalChaosAnalysis`,
    :class:`~persalys.KrigingAnalysis`
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def analyticalValidation(self):
        r"""
        Whether an analytical validation is requested.

        Returns
        -------
        validation : bool
            Whether an analytical validation is requested.
            This method corresponds to an approximation of the Leave-one-out method result.
        """
        return _persalys.MetaModelAnalysis_analyticalValidation(self)

    def setAnalyticalValidation(self, validation):
        r"""
        Whether an analytical validation is requested.

        Parameters
        ----------
        validation : bool
            Whether an analytical validation is requested.
            This method corresponds to an approximation of the Leave-one-out method result.
        """
        return _persalys.MetaModelAnalysis_setAnalyticalValidation(self, validation)

    def testSampleValidation(self):
        r"""
        Whether a validation with a test sample is requested.

        Returns
        -------
        validation : bool
            Whether a validation with a test sample is requested.
            The data sample is dividing into two sub-samples: a training sample
            (default: 80% of the sample points) and a test sample (default:
            20% of the sample points). A new metamodel is built
            with the training sample and is validated with the test sample.
            The points are randomly picked in the data sample (by default the seed is 1).
        """
        return _persalys.MetaModelAnalysis_testSampleValidation(self)

    def setTestSampleValidation(self, validation):
        r"""
        Whether a validation with a test sample is requested.

        Parameters
        ----------
        validation : bool
            Whether a validation with a test sample is requested.
            The data sample is dividing into two sub-samples: a training sample
            (default: 80% of the sample points) and a test sample (default:
            20% of the sample points). A new metamodel is built
            with the training sample and is validated with the test sample.
            The points are randomly picked in the data sample (by default the seed is 1).
        """
        return _persalys.MetaModelAnalysis_setTestSampleValidation(self, validation)

    def kFoldValidation(self):
        r"""
        Whether a k-Fold cross-validation is requested.

        Returns
        -------
        validation : bool
            Whether a k-Fold cross-validation is requested
        """
        return _persalys.MetaModelAnalysis_kFoldValidation(self)

    def setKFoldValidation(self, validation):
        r"""
        Whether a k-Fold cross-validation is requested.

        Parameters
        ----------
        validation : bool
            Whether a k-Fold cross-validation is requested
        """
        return _persalys.MetaModelAnalysis_setKFoldValidation(self, validation)

    def leaveOneOutValidation(self):
        r"""
        Whether a validation by leave-one-out is requested.

        Returns
        -------
        validation : bool
            Whether a validation by leave-one-out is requested
        """
        return _persalys.MetaModelAnalysis_leaveOneOutValidation(self)

    def setLeaveOneOutValidation(self, validation):
        r"""
        Whether it is sparse.

        Parameters
        ----------
        validation : bool
            Whether a validation by leave-one-out is requested
        """
        return _persalys.MetaModelAnalysis_setLeaveOneOutValidation(self, validation)

    def setTestSampleValidationSeed(self, seed):
        r"""
        Seed accessor.

        Parameters
        ----------
        seed : int
            Seed value for the validation with a test sample
        """
        return _persalys.MetaModelAnalysis_setTestSampleValidationSeed(self, seed)

    def setTestSampleValidationPercentageOfPoints(self, percentage):
        r"""
        Percentage of points accessor.

        Parameters
        ----------
        percentage : int
            Percentage of points used to validate the metamodel. By default it is 20%.
        """
        return _persalys.MetaModelAnalysis_setTestSampleValidationPercentageOfPoints(self, percentage)

    def getTestSampleValidationPercentageOfPoints(self):
        r"""
        Percentage of points accessor.

        Returns
        -------
        percentage : int
            Percentage of points used to validate the metamodel. By default it is 20%.
        """
        return _persalys.MetaModelAnalysis_getTestSampleValidationPercentageOfPoints(self)

    def getTestSampleValidationSeed(self):
        r"""
        Seed accessor.

        Returns
        -------
        seed : int
            Seed value for the validation with a test sample
        """
        return _persalys.MetaModelAnalysis_getTestSampleValidationSeed(self)

    def setKFoldValidationNumberOfFolds(self, nbFolds):
        r"""
        Number of folds accessor.

        Parameters
        ----------
        folds : int
            Number of folds. By default it is 3.
        """
        return _persalys.MetaModelAnalysis_setKFoldValidationNumberOfFolds(self, nbFolds)

    def setKFoldValidationSeed(self, seed):
        r"""
        Seed accessor.

        Parameters
        ----------
        seed : int
            Seed value for k-Fold cross-validation
        """
        return _persalys.MetaModelAnalysis_setKFoldValidationSeed(self, seed)

    def getKFoldValidationNumberOfFolds(self):
        r"""
        Number of folds accessor.

        Returns
        -------
        folds : int
            Number of folds. By default it is 3.
        """
        return _persalys.MetaModelAnalysis_getKFoldValidationNumberOfFolds(self)

    def getKFoldValidationSeed(self):
        r"""
        Seed accessor.

        Returns
        -------
        seed : int
            Seed value for k-Fold cross-validation
        """
        return _persalys.MetaModelAnalysis_getKFoldValidationSeed(self)

    def getEffectiveInputSample(self):
        r"""
        Effective input sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Sample of all the input variables if all of them are deterministic.
            Otherwise, sample of the stochastic input variables.
        """
        return _persalys.MetaModelAnalysis_getEffectiveInputSample(self)

    def getEffectiveOutputSample(self):
        r"""
        Effective output sample accessor.

        Returns
        -------
        sample : :py:class:`openturns.Sample`
            Sample of the interest output variables.
        """
        return _persalys.MetaModelAnalysis_getEffectiveOutputSample(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.MetaModelAnalysis_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.MetaModelAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.MetaModelAnalysis_swiginit(self, _persalys.new_MetaModelAnalysis(*args))
    __swig_destroy__ = _persalys.delete_MetaModelAnalysis

# Register MetaModelAnalysis in _persalys:
_persalys.MetaModelAnalysis_swigregister(MetaModelAnalysis)
class FunctionalChaosAnalysisResult(MetaModelAnalysisResult):
    r"""
    Get the results for a Functional chaos analysis.

    Notes
    -----
    Structure created by the method run() of
    :class:`~persalys.FunctionalChaosAnalysis`, and obtained thanks to the method
    getResult().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FunctionalChaosAnalysisResult_getClassName(self)

    def getFunctionalChaosResult(self):
        r"""
        Functional chaos result accessor.

        Returns
        -------
        result : :py:class:`openturns.FunctionalChaosResult`
            Functional chaos result
        """
        return _persalys.FunctionalChaosAnalysisResult_getFunctionalChaosResult(self)

    def getMean(self):
        r"""
        Mean estimation accessor.

        Returns
        -------
        result : :py:class:`openturns.Point`
            Mean estimation
        """
        return _persalys.FunctionalChaosAnalysisResult_getMean(self)

    def getVariance(self):
        r"""
        Variance estimation accessor.

        Returns
        -------
        result : :py:class:`openturns.Point`
            Variance estimation
        """
        return _persalys.FunctionalChaosAnalysisResult_getVariance(self)

    def getSobolResult(self):
        r"""
        Sobol' indices result accessor.

        Returns
        -------
        result : :class:`~persalys.SobolResult`
            Object containing the first order and total Sobol' indices
        """
        return _persalys.FunctionalChaosAnalysisResult_getSobolResult(self)

    def __repr__(self):
        return _persalys.FunctionalChaosAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.FunctionalChaosAnalysisResult_swiginit(self, _persalys.new_FunctionalChaosAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_FunctionalChaosAnalysisResult

# Register FunctionalChaosAnalysisResult in _persalys:
_persalys.FunctionalChaosAnalysisResult_swigregister(FunctionalChaosAnalysisResult)
class FunctionalChaosAnalysis(MetaModelAnalysis):
    r"""
    Create a Functional chaos analysis.

    See `Functional chaos <http://openturns.github.io/openturns/latest/theory/meta_modeling/functional_chaos.html>`_

    Parameters
    ----------
    name : str
        Name
    designOfExperiment : :class:`~persalys.DesignOfExperiment`
        Design of experiments

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> from math import pi
    >>> ot.RandomGenerator.SetSeed(0)
    >>> xi1 = persalys.Input('xi1', ot.Uniform(-pi, pi))
    >>> xi2 = persalys.Input('xi2', ot.Uniform(-pi, pi))
    >>> xi3 = persalys.Input('xi3', ot.Uniform(-pi, pi))
    >>> y0 = persalys.Output('y0')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [xi1, xi2, xi3], [y0], ['sin(xi1) + 7. * (sin(xi2)) ^ 2 + 0.1 * xi3^4 * sin(xi1)'])

    Create the design of experiments:

    >>> aDesign = persalys.FixedDesignOfExperiment('aDesign', myPhysicalModel)
    >>> inputSample = ot.LHSExperiment(myPhysicalModel.getDistribution(), 250).generate()
    >>> aDesign.setOriginalInputSample(inputSample)
    >>> aDesign.run()

    Create the Functional Chaos Analysis:

    >>> chaos = persalys.FunctionalChaosAnalysis('chaos', aDesign)
    >>> chaos.setChaosDegree(6)
    >>> chaos.setSparseChaos(False)
    >>> chaos.setLeaveOneOutValidation(False)
    >>> chaos.run()

    Get the result:

    >>> chaosResult = chaos.getResult()
    >>> sobolResult = chaosResult.getSobolResult()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FunctionalChaosAnalysis_getClassName(self)

    def getChaosDegree(self):
        r"""
        Chaos degree accessor.

        Returns
        -------
        degree : int
            Chaos degree. It is set by default to 2
        """
        return _persalys.FunctionalChaosAnalysis_getChaosDegree(self)

    def setChaosDegree(self, degree):
        r"""
        Chaos degree accessor.

        Parameters
        ----------
        degree : int
            Chaos degree
        """
        return _persalys.FunctionalChaosAnalysis_setChaosDegree(self, degree)

    def getSparseChaos(self):
        r"""
        Whether it is sparse.

        Returns
        -------
        isSparse : bool
            Whether it is sparse. By default, the chaos is not sparse
        """
        return _persalys.FunctionalChaosAnalysis_getSparseChaos(self)

    def setSparseChaos(self, sparse):
        r"""
        Whether it is sparse.

        Parameters
        ----------
        isSparse : bool
            Whether it is sparse
        """
        return _persalys.FunctionalChaosAnalysis_setSparseChaos(self, sparse)

    def getDistribution(self):
        r"""
        Input distribution accessor.

        Returns
        -------
        distribution : :py:class:`openturns.JointDistribution`
            The distribution defined in the probabilistic model or a distribution composed
            of Uniform laws if there is no stochastic input variable.
        """
        return _persalys.FunctionalChaosAnalysis_getDistribution(self)

    def getResult(self):
        r"""
        Results accessor.

        Returns
        -------
        result : :class:`~persalys.FunctionalChaosAnalysisResult`
            Results
        """
        return _persalys.FunctionalChaosAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.FunctionalChaosAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.FunctionalChaosAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.FunctionalChaosAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.FunctionalChaosAnalysis_swiginit(self, _persalys.new_FunctionalChaosAnalysis(*args))
    __swig_destroy__ = _persalys.delete_FunctionalChaosAnalysis

# Register FunctionalChaosAnalysis in _persalys:
_persalys.FunctionalChaosAnalysis_swigregister(FunctionalChaosAnalysis)
class KrigingResultCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_KrigingResultCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.KrigingResultCollection_clear(self)

    def __len__(self):
        return _persalys.KrigingResultCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.KrigingResultCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.KrigingResultCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.KrigingResultCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.KrigingResultCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.KrigingResultCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.KrigingResultCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.KrigingResultCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.KrigingResultCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.KrigingResultCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.KrigingResultCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.KrigingResultCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.KrigingResultCollection_find(self, val)

    def __repr__(self):
        return _persalys.KrigingResultCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.KrigingResultCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.KrigingResultCollection_swiginit(self, _persalys.new_KrigingResultCollection(*args))

# Register KrigingResultCollection in _persalys:
_persalys.KrigingResultCollection_swigregister(KrigingResultCollection)
class KrigingAnalysisResult(MetaModelAnalysisResult):
    r"""
    Get the results of a Kriging analysis.

    Notes
    -----
    Structure created by the method run() of
    :class:`~persalys.KrigingAnalysis`, and obtained thanks to the method
    getResult().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.KrigingAnalysisResult_getClassName(self)

    def getKrigingResultCollection(self):
        r"""
        Sequence of kriging results accessor.

        Returns
        -------
        results : sequence of :class:`openturns.KrigingResult`
            The kriging results of all the outputs of interest
        """
        return _persalys.KrigingAnalysisResult_getKrigingResultCollection(self)

    def getResultForVariable(self, variableName):
        r"""
        Get the kriging result of a variable.

        Parameters
        ----------
        variable : str
            Name of the variable

        Returns
        -------
        result : py:class:`openturns.KrigingResult`
            The kriging result of the variable
        """
        return _persalys.KrigingAnalysisResult_getResultForVariable(self, variableName)

    def __repr__(self):
        return _persalys.KrigingAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.KrigingAnalysisResult_swiginit(self, _persalys.new_KrigingAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_KrigingAnalysisResult

# Register KrigingAnalysisResult in _persalys:
_persalys.KrigingAnalysisResult_swigregister(KrigingAnalysisResult)
class KrigingAnalysis(MetaModelAnalysis):
    r"""
    Create a Kriging analysis.

    See `Kriging <http://openturns.github.io/openturns/latest/theory/meta_modeling/kriging.html>`_.

    Parameters
    ----------
    name : str
        Name
    designOfExperiment : :class:`~persalys.DesignOfExperiment`
        Design of experiments

    Examples
    --------
    Create the model:

    >>> import openturns as ot
    >>> import persalys
    >>> from math import pi
    >>> ot.RandomGenerator.SetSeed(0)

    Create the model:

    >>> xi1 = persalys.Input('xi1', ot.Uniform(-pi, pi))
    >>> xi2 = persalys.Input('xi2', ot.Uniform(-pi, pi))
    >>> xi3 = persalys.Input('xi3', ot.Uniform(-pi, pi))
    >>> y0 = persalys.Output('y0')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [xi1, xi2, xi3], [y0], ['sin(xi1) + 7. * (sin(xi2)) ^ 2 + 0.1 * xi3^4 * sin(xi1)'])

    Create the design of experiments:

    >>> aDesign = persalys.ProbabilisticDesignOfExperiment('aDesign', myPhysicalModel, 100, 'LHS')
    >>> aDesign.run()

    Create the Kriging Analysis:

    >>> kriging = persalys.KrigingAnalysis('kriging', aDesign)
    >>> kriging.setBasis(ot.LinearBasisFactory(3).build())
    >>> kriging.setCovarianceModel(ot.GeneralizedExponential(3))
    >>> kriging.setLeaveOneOutValidation(False)
    >>> kriging.run()

    Get the result:

    >>> krigingResult = kriging.getResult()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.KrigingAnalysis_getClassName(self)

    def getBasis(self):
        r"""
        Trend basis accessor.

        Returns
        -------
        basis : :py:class:`openturns.Basis`
            Trend basis
        """
        return _persalys.KrigingAnalysis_getBasis(self)

    def setBasis(self, basis):
        r"""
        Trend basis accessor.

        Parameters
        ----------
        basis : :py:class:`openturns.Basis`
            Trend basis
        """
        return _persalys.KrigingAnalysis_setBasis(self, basis)

    def getCovarianceModel(self):
        r"""
        Covariance model accessor.

        Returns
        -------
        model : :py:class:`openturns.CovarianceModel`
            Covariance model
        """
        return _persalys.KrigingAnalysis_getCovarianceModel(self)

    def setCovarianceModel(self, model):
        r"""
        Covariance model accessor.

        Parameters
        ----------
        model : :py:class:`openturns.CovarianceModel`
            Covariance model
        """
        return _persalys.KrigingAnalysis_setCovarianceModel(self, model)

    def getOptimizeParameters(self):
        r"""
        Accessor to the covariance model parameters optimization flag.

        Returns
        -------
        optimize : bool
            Whether to optimize the covariance model parameters
        """
        return _persalys.KrigingAnalysis_getOptimizeParameters(self)

    def setOptimizeParameters(self, optimize):
        r"""
        Accessor to the covariance model parameters optimization flag.

        Parameters
        ----------
        optimize : bool
            Whether to optimize the covariance model parameters
        """
        return _persalys.KrigingAnalysis_setOptimizeParameters(self, optimize)

    def getResult(self):
        r"""
        Results accessor.

        Returns
        -------
        result : :class:`~persalys.KrigingAnalysisResult`
            Results
        """
        return _persalys.KrigingAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.KrigingAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.KrigingAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.KrigingAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.KrigingAnalysis_swiginit(self, _persalys.new_KrigingAnalysis(*args))
    __swig_destroy__ = _persalys.delete_KrigingAnalysis

# Register KrigingAnalysis in _persalys:
_persalys.KrigingAnalysis_swigregister(KrigingAnalysis)
class PolynomialRegressionAnalysisResult(MetaModelAnalysisResult):
    r"""
    Get the results of a Linear model analysis.

    Notes
    -----
    Structure created by the method run() of
    :class:`~persalys.PolynomialRegressionAnalysis`, and obtained thanks to the method
    getResult().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.PolynomialRegressionAnalysisResult_getClassName(self)

    def getLinearModelResultCollection(self):
        r"""
        Sequence of linear model results accessor.

        Returns
        -------
        results : Collection of :class:`openturns.LinearModelResult`
            The linear model results of all the outputs of interest
        """
        return _persalys.PolynomialRegressionAnalysisResult_getLinearModelResultCollection(self)

    def getResultForVariable(self, variableName):
        r"""
        Get the linear model result of a variable.

        Parameters
        ----------
        variable : str
            Name of the variable

        Returns
        -------
        result : py:class:`openturns.LinearModelResult`
            The linear model result of the variable
        """
        return _persalys.PolynomialRegressionAnalysisResult_getResultForVariable(self, variableName)

    def getFormulas(self):
        r"""
        Accessor to the regression formulas.

        Returns
        -------
        formulas : py:class:`openturns.Description`
            The list of formulas
        """
        return _persalys.PolynomialRegressionAnalysisResult_getFormulas(self)

    def __repr__(self):
        return _persalys.PolynomialRegressionAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.PolynomialRegressionAnalysisResult_swiginit(self, _persalys.new_PolynomialRegressionAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_PolynomialRegressionAnalysisResult

# Register PolynomialRegressionAnalysisResult in _persalys:
_persalys.PolynomialRegressionAnalysisResult_swigregister(PolynomialRegressionAnalysisResult)
class PolynomialRegressionAnalysis(MetaModelAnalysis):
    r"""
    Polynomial stepwise regression.

    Allows one to select of the most suitable polynomial (canonical) basis for a linear
    regression model with the help of the stepwise algorithm.

    See also `LinearModelStepwiseAlgorithm <https://openturns.github.io/openturns/latest/user_manual/response_surface/_generated/openturns.LinearModelStepwiseAlgorithm.html>`_.

    Parameters
    ----------
    name : str
        Name
    designOfExperiment : :class:`~persalys.DesignOfExperiment`
        Design of experiments

    Examples
    --------
    Create the model:

    >>> import openturns as ot
    >>> import persalys
    >>> from math import pi
    >>> ot.RandomGenerator.SetSeed(0)

    Create the model:

    >>> xi1 = persalys.Input('xi1', ot.Uniform(-pi, pi))
    >>> xi2 = persalys.Input('xi2', ot.Uniform(-pi, pi))
    >>> xi3 = persalys.Input('xi3', ot.Uniform(-pi, pi))
    >>> y0 = persalys.Output('y0')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [xi1, xi2, xi3], [y0], ['sin(xi1) + 7. * (sin(xi2)) ^ 2 + 0.1 * xi3^4 * sin(xi1)'])

    Create the design of experiments:

    >>> aDesign = persalys.ProbabilisticDesignOfExperiment('aDesign', myPhysicalModel, 100, 'LHS')
    >>> aDesign.run()

    Create the linear regression analysis:

    >>> lm = persalys.PolynomialRegressionAnalysis('lm', aDesign)
    >>> lm.setDegree(1)
    >>> lm.setInteraction(False)
    >>> lm.run()

    Get the result:

    >>> result = lm.getResult()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.PolynomialRegressionAnalysis_getClassName(self)

    def getDegree(self):
        r"""
        Accessor to the basis degree.

        Returns
        -------
        degres : int
            Basis degree
        """
        return _persalys.PolynomialRegressionAnalysis_getDegree(self)

    def setDegree(self, degree):
        r"""
        Accessor to the basis degree.

        Parameters
        ----------
        degres : int
            Basis degree
        """
        return _persalys.PolynomialRegressionAnalysis_setDegree(self, degree)

    def getInteraction(self):
        r"""
        Accessor to the interaction flag.

        Returns
        -------
        interaction : bool
            Whether to include interaction terms in the basis
        """
        return _persalys.PolynomialRegressionAnalysis_getInteraction(self)

    def setInteraction(self, interaction):
        r"""
        Accessor to the interaction flag.

        Parameters
        ----------
        interaction : bool
            Whether to include interaction terms in the basis
        """
        return _persalys.PolynomialRegressionAnalysis_setInteraction(self, interaction)

    def getResult(self):
        r"""
        Results accessor.

        Returns
        -------
        result : :class:`~persalys.PolynomialRegressionAnalysisResult`
            Results
        """
        return _persalys.PolynomialRegressionAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.PolynomialRegressionAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.PolynomialRegressionAnalysis_hasValidResult(self)

    def __repr__(self):
        return _persalys.PolynomialRegressionAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.PolynomialRegressionAnalysis_swiginit(self, _persalys.new_PolynomialRegressionAnalysis(*args))
    __swig_destroy__ = _persalys.delete_PolynomialRegressionAnalysis

# Register PolynomialRegressionAnalysis in _persalys:
_persalys.PolynomialRegressionAnalysis_swigregister(PolynomialRegressionAnalysis)
class FittingTestResult(openturns.common.PersistentObject):
    r"""Get the results of a fitting test."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FittingTestResult_getClassName(self)

    def getVariableName(self):
        r"""
        Variable name accessor.

        Returns
        -------
        name : str
            The name of the variable
        """
        return _persalys.FittingTestResult_getVariableName(self)

    def getValues(self):
        r"""
        Data accessor.

        Returns
        -------
        values : :py:class:`openturns.Sample`
            Values of the variable used to perform the inference analysis
        """
        return _persalys.FittingTestResult_getValues(self)

    def getTestedDistributions(self):
        r"""
        Get the sequence of tested distributions.

        Returns
        -------
        distributions : sequence of :py:class:`openturns.Distribution`
            Tested distributions
        """
        return _persalys.FittingTestResult_getTestedDistributions(self)

    def getParamConfidenceInterval(self):
        return _persalys.FittingTestResult_getParamConfidenceInterval(self)

    def getTestResults(self):
        return _persalys.FittingTestResult_getTestResults(self)

    def getBICResults(self):
        return _persalys.FittingTestResult_getBICResults(self)

    def getErrorMessages(self):
        r"""
        Get the sequence of error messages.

        Returns
        -------
        messages : sequence of :py:class:`openturns.Description`
            Error message for each tested distributions. The error message is empty
            if the distribution has been well tested
        """
        return _persalys.FittingTestResult_getErrorMessages(self)

    def getTestType(self):
        return _persalys.FittingTestResult_getTestType(self)

    def __repr__(self):
        return _persalys.FittingTestResult___repr__(self)

    def __init__(self, *args):
        _persalys.FittingTestResult_swiginit(self, _persalys.new_FittingTestResult(*args))
    __swig_destroy__ = _persalys.delete_FittingTestResult

# Register FittingTestResult in _persalys:
_persalys.FittingTestResult_swigregister(FittingTestResult)
class FittingTestResultCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_FittingTestResultCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.FittingTestResultCollection_clear(self)

    def __len__(self):
        return _persalys.FittingTestResultCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.FittingTestResultCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.FittingTestResultCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.FittingTestResultCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.FittingTestResultCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.FittingTestResultCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.FittingTestResultCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.FittingTestResultCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.FittingTestResultCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.FittingTestResultCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.FittingTestResultCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.FittingTestResultCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.FittingTestResultCollection_find(self, val)

    def __repr__(self):
        return _persalys.FittingTestResultCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.FittingTestResultCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.FittingTestResultCollection_swiginit(self, _persalys.new_FittingTestResultCollection(*args))

# Register FittingTestResultCollection in _persalys:
_persalys.FittingTestResultCollection_swigregister(FittingTestResultCollection)
class InferenceResult(AnalysisResult):
    r"""
    Get the results of an inference analysis.

    Notes
    -----
    Structure created by the method run() of
    :class:`~persalys.InferenceAnalysis`, and obtained thanks to the method
    getResult().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.InferenceResult_getClassName(self)

    def getFittingTestResultCollection(self):
        r"""
        Sequence of fitting test results accessor.

        Returns
        -------
        results : sequence of :class:`~persalys.FittingTestResult`
            The fitting test results of all the variables
        """
        return _persalys.InferenceResult_getFittingTestResultCollection(self)

    def getFittingTestResultForVariable(self, variableName):
        r"""
        Get the fitting test result of a variable.

        Parameters
        ----------
        variable : str
            Name of the variable

        Returns
        -------
        result : :class:`~persalys.FittingTestResult`
            The fitting test result of the variable
        """
        return _persalys.InferenceResult_getFittingTestResultForVariable(self, variableName)

    def __repr__(self):
        return _persalys.InferenceResult___repr__(self)

    def __init__(self, *args):
        _persalys.InferenceResult_swiginit(self, _persalys.new_InferenceResult(*args))
    __swig_destroy__ = _persalys.delete_InferenceResult

# Register InferenceResult in _persalys:
_persalys.InferenceResult_swigregister(InferenceResult)
class InferenceAnalysis(DesignOfExperimentAnalysis):
    r"""
    Perform a Kolmogorov goodness-of-fit test for 1-D continuous distributions.

    Parameters
    ----------
    name : str
        Name
    design : :class:`~persalys.DesignOfExperiment`
        Design of experiments

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys
    >>> ot.RandomGenerator.SetSeed(0)

    Create the model:

    >>> filename = 'data.csv'
    >>> sample = ot.Normal(3).getSample(100)
    >>> sample.exportToCSVFile(filename)
    >>> model = persalys.DataModel('myDataModel', 'data.csv', [0, 1, 2])

    Create the Inference Analysis:

    >>> analysis = persalys.InferenceAnalysis('analysis', model)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> resultX0 = result.getFittingTestResultForVariable('X0')
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.InferenceAnalysis_getClassName(self)
    Kolmogorov = _persalys.InferenceAnalysis_Kolmogorov
    Lilliefors = _persalys.InferenceAnalysis_Lilliefors

    def getDistributionsFactories(self, variableName):
        r"""
        Get the sequence of distributions to test for a variable.

        Parameters
        ----------
        variable : str
            Name of the variable

        Returns
        -------
        factories : sequence of :py:class:`openturns.DistributionFactory`
            Distributions to test
        """
        return _persalys.InferenceAnalysis_getDistributionsFactories(self, variableName)

    def setDistributionsFactories(self, variableName, distributionsFactories):
        r"""
        Set the sequence of distributions to test for a variable.

        Parameters
        ----------
        variable : str
            Name of the variable
        factories : sequence of :py:class:`openturns.DistributionFactory`
            Distributions to test
        """
        return _persalys.InferenceAnalysis_setDistributionsFactories(self, variableName, distributionsFactories)

    def getLevel(self):
        r"""
        Level accessor.

        Returns
        -------
        level : float, :math:`0 < {\rm level} < 1`, optional
            The risk of committing a Type I error, that is an incorrect rejection of a true
            null hypothesis
        """
        return _persalys.InferenceAnalysis_getLevel(self)

    def setLevel(self, level):
        r"""
        Level accessor.

        Parameters
        ----------
        level : float, :math:`0 < {\rm level} < 1`, optional
            The risk of committing a Type I error, that is an incorrect rejection of a true
            null hypothesis
        """
        return _persalys.InferenceAnalysis_setLevel(self, level)

    def setInterestVariables(self, variablesNames):
        r"""
        Set the variables to analyse.

        Parameters
        ----------
        variablesNames : sequence of str
            Names of the variables to analyse
        """
        return _persalys.InferenceAnalysis_setInterestVariables(self, variablesNames)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.InferenceResult`
            Result.
        """
        return _persalys.InferenceAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.InferenceAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.InferenceAnalysis_hasValidResult(self)

    def getEstimateParametersConfidenceInterval(self):
        return _persalys.InferenceAnalysis_getEstimateParametersConfidenceInterval(self)

    def setEstimateParametersConfidenceInterval(self, estimateParamCI):
        return _persalys.InferenceAnalysis_setEstimateParametersConfidenceInterval(self, estimateParamCI)

    def getParametersConfidenceIntervalLevel(self):
        return _persalys.InferenceAnalysis_getParametersConfidenceIntervalLevel(self)

    def setParametersConfidenceIntervalLevel(self, paramCILevel):
        return _persalys.InferenceAnalysis_setParametersConfidenceIntervalLevel(self, paramCILevel)

    def getTestType(self):
        return _persalys.InferenceAnalysis_getTestType(self)

    def setTestType(self, type):
        return _persalys.InferenceAnalysis_setTestType(self, type)

    def getLillieforsPrecision(self):
        return _persalys.InferenceAnalysis_getLillieforsPrecision(self)

    def setLillieforsPrecision(self, lillieforsPrecision):
        return _persalys.InferenceAnalysis_setLillieforsPrecision(self, lillieforsPrecision)

    def getLillieforsMinimumSamplingSize(self):
        return _persalys.InferenceAnalysis_getLillieforsMinimumSamplingSize(self)

    def setLillieforsMinimumSamplingSize(self, lillieforsMinimumSamplingSize):
        return _persalys.InferenceAnalysis_setLillieforsMinimumSamplingSize(self, lillieforsMinimumSamplingSize)

    def getLillieforsMaximumSamplingSize(self):
        return _persalys.InferenceAnalysis_getLillieforsMaximumSamplingSize(self)

    def setLillieforsMaximumSamplingSize(self, lillieforsMaximumSamplingSize):
        return _persalys.InferenceAnalysis_setLillieforsMaximumSamplingSize(self, lillieforsMaximumSamplingSize)

    def __repr__(self):
        return _persalys.InferenceAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.InferenceAnalysis_swiginit(self, _persalys.new_InferenceAnalysis(*args))
    __swig_destroy__ = _persalys.delete_InferenceAnalysis

# Register InferenceAnalysis in _persalys:
_persalys.InferenceAnalysis_swigregister(InferenceAnalysis)
class CopulaInferenceSetResult(openturns.common.PersistentObject):
    r"""
    Dependence inference result for a set of variables.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CopulaInferenceSetResult_getClassName(self)

    def getSetOfVariablesNames(self):
        r"""
        Set of variables names accessor.

        Returns
        -------
        names : :py:class:`openturns.Description`
            Set of variables names
        """
        return _persalys.CopulaInferenceSetResult_getSetOfVariablesNames(self)

    def getTestedDistributions(self):
        r"""
        Get the sequence of tested distributions.

        Returns
        -------
        distributions : sequence of :py:class:`openturns.Distribution`
            Tested distributions
        """
        return _persalys.CopulaInferenceSetResult_getTestedDistributions(self)

    def getBICResults(self):
        return _persalys.CopulaInferenceSetResult_getBICResults(self)

    def getKendallPlotData(self):
        r"""
        Data of the Kendall plot.

        Returns
        -------
        data : 2D sequence of :py:class:`openturns.Sample`
            Data of the Kendall plot for each tested distribution and for each pair
            of variables
        """
        return _persalys.CopulaInferenceSetResult_getKendallPlotData(self)

    def getErrorMessages(self):
        r"""
        Get the sequence of error messages.

        Returns
        -------
        messages : sequence of :py:class:`openturns.Description`
            Error message for each tested distributions. The error message is empty
            if the distribution has been well tested
        """
        return _persalys.CopulaInferenceSetResult_getErrorMessages(self)

    def __repr__(self):
        return _persalys.CopulaInferenceSetResult___repr__(self)

    def __init__(self, *args):
        _persalys.CopulaInferenceSetResult_swiginit(self, _persalys.new_CopulaInferenceSetResult(*args))
    __swig_destroy__ = _persalys.delete_CopulaInferenceSetResult

# Register CopulaInferenceSetResult in _persalys:
_persalys.CopulaInferenceSetResult_swigregister(CopulaInferenceSetResult)
class CopulaInferenceSetResultCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_CopulaInferenceSetResultCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.CopulaInferenceSetResultCollection_clear(self)

    def __len__(self):
        return _persalys.CopulaInferenceSetResultCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.CopulaInferenceSetResultCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.CopulaInferenceSetResultCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.CopulaInferenceSetResultCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.CopulaInferenceSetResultCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.CopulaInferenceSetResultCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.CopulaInferenceSetResultCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.CopulaInferenceSetResultCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.CopulaInferenceSetResultCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.CopulaInferenceSetResultCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.CopulaInferenceSetResultCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.CopulaInferenceSetResultCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.CopulaInferenceSetResultCollection_find(self, val)

    def __repr__(self):
        return _persalys.CopulaInferenceSetResultCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.CopulaInferenceSetResultCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.CopulaInferenceSetResultCollection_swiginit(self, _persalys.new_CopulaInferenceSetResultCollection(*args))

# Register CopulaInferenceSetResultCollection in _persalys:
_persalys.CopulaInferenceSetResultCollection_swigregister(CopulaInferenceSetResultCollection)
class CopulaInferenceResult(EvaluationResult):
    r"""
    Get the results of a dependence inference analysis.

    Notes
    -----
    Structure created by the method run() of
    :class:`~persalys.CopulaInferenceAnalysis`, and obtained thanks to the method
    getResult().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CopulaInferenceResult_getClassName(self)

    def getCopulaInferenceSetResultCollection(self):
        r"""
        Sequence of results accessor.

        Returns
        -------
        results : sequence of :class:`~persalys.CopulaInferenceSetResult`
            The results of each set of variables
        """
        return _persalys.CopulaInferenceResult_getCopulaInferenceSetResultCollection(self)

    def getCopulaInferenceSetResult(self, variablesNames):
        r"""
        Get the result of a set of variables.

        Parameters
        ----------
        variables : sequence of str
            Names of the variables

        Returns
        -------
        result : :class:`~persalys.CopulaInferenceSetResult`
            The result of the given set of variables
        """
        return _persalys.CopulaInferenceResult_getCopulaInferenceSetResult(self, variablesNames)

    def __repr__(self):
        return _persalys.CopulaInferenceResult___repr__(self)

    def __init__(self, *args):
        _persalys.CopulaInferenceResult_swiginit(self, _persalys.new_CopulaInferenceResult(*args))
    __swig_destroy__ = _persalys.delete_CopulaInferenceResult

# Register CopulaInferenceResult in _persalys:
_persalys.CopulaInferenceResult_swigregister(CopulaInferenceResult)
class CopulaInferenceAnalysis(DesignOfExperimentAnalysis):
    r"""
    Perform a dependence inference analysis.

    Parameters
    ----------
    name : str
        Name
    design : :class:`~persalys.DesignOfExperiment`
        Design of experiments

    Examples
    --------
    Create the model:

    >>> import openturns as ot
    >>> import persalys
    >>> filename = 'data.csv'
    >>> ot.RandomGenerator.SetSeed(0)
    >>> sample = ot.Normal(3).getSample(100)
    >>> sample.exportToCSVFile(filename)
    >>> model = persalys.DataModel('myDataModel', 'data.csv', [0, 1, 2])

    Create the dependence inference analysis:

    >>> analysis = persalys.CopulaInferenceAnalysis('analysis', model)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> resultForSet = result.getCopulaInferenceSetResultCollection()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CopulaInferenceAnalysis_getClassName(self)

    def getDistributionsFactories(self, variablesNames):
        r"""
        Get the sequence of distributions to test for a set of variables.

        Parameters
        ----------
        variables : sequence of str
            Names of the variables

        Returns
        -------
        factories : sequence of :py:class:`openturns.DistributionFactory`
            Distributions to test for the given set of variables
        """
        return _persalys.CopulaInferenceAnalysis_getDistributionsFactories(self, variablesNames)

    def setDistributionsFactories(self, variablesNames, distributionsFactories):
        r"""
        Set the sequence of distributions to test for a set of variables.

        Parameters
        ----------
        variables : sequence of str
            Names of the variables
        factories : sequence of :py:class:`openturns.DistributionFactory`
            Distributions to test
        """
        return _persalys.CopulaInferenceAnalysis_setDistributionsFactories(self, variablesNames, distributionsFactories)

    def buildDefaultVariablesGroups(self):
        return _persalys.CopulaInferenceAnalysis_buildDefaultVariablesGroups(self)

    def getVariablesGroups(self):
        return _persalys.CopulaInferenceAnalysis_getVariablesGroups(self)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.CopulaInferenceResult`
            Result.
        """
        return _persalys.CopulaInferenceAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.CopulaInferenceAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.CopulaInferenceAnalysis_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.CopulaInferenceAnalysis_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.CopulaInferenceAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.CopulaInferenceAnalysis_swiginit(self, _persalys.new_CopulaInferenceAnalysis(*args))
    __swig_destroy__ = _persalys.delete_CopulaInferenceAnalysis

# Register CopulaInferenceAnalysis in _persalys:
_persalys.CopulaInferenceAnalysis_swigregister(CopulaInferenceAnalysis)
class AlgorithmProperty(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    Local = _persalys.AlgorithmProperty_Local
    Global = _persalys.AlgorithmProperty_Global
    AnyL = _persalys.AlgorithmProperty_AnyL
    _None = _persalys.AlgorithmProperty__None
    First = _persalys.AlgorithmProperty_First
    AnyD = _persalys.AlgorithmProperty_AnyD
    Low = _persalys.AlgorithmProperty_Low
    Medium = _persalys.AlgorithmProperty_Medium
    High = _persalys.AlgorithmProperty_High

    def __init__(self, *args):
        _persalys.AlgorithmProperty_swiginit(self, _persalys.new_AlgorithmProperty(*args))

    def getLocality(self):
        return _persalys.AlgorithmProperty_getLocality(self)

    def getDerivative(self):
        return _persalys.AlgorithmProperty_getDerivative(self)

    def getDoc(self):
        return _persalys.AlgorithmProperty_getDoc(self)

    def getPriority(self):
        return _persalys.AlgorithmProperty_getPriority(self)
    __swig_destroy__ = _persalys.delete_AlgorithmProperty

# Register AlgorithmProperty in _persalys:
_persalys.AlgorithmProperty_swigregister(AlgorithmProperty)
class OptimizationAnalysis(PhysicalModelAnalysis):
    r"""
    Perform the optimization analysis of a model.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    solverName : str
        Optimization algorithm name (optional). Use :func:`GetSolverNames()` to list available names.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> R = persalys.Input('R', 0., ot.LogNormalMuSigma(300., 30., 0.).getDistribution(), 'Yield strength')
    >>> F = persalys.Input('F', 0., ot.Normal(75000., 5000.), 'Traction load')
    >>> G = persalys.Output('G', 'deviation')
    >>> myPhysicalModel = persalys.SymbolicPhysicalModel('myPhysicalModel', [R, F], [G], ['R-F/(pi_*100.0)'])

    Create the Model evaluation:

    >>> analysis = persalys.OptimizationAnalysis('anAnalysis', myPhysicalModel, 'TNC')
    >>> analysis.setInterestVariables(['G'])
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> x = result.getOptimalPoint()
    >>> y = result.getOptimalValue()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.OptimizationAnalysis_getClassName(self)

    def setInterestVariables(self, variablesNames):
        r"""
        Set the variables to analyse.

        Parameters
        ----------
        variablesNames : sequence of str
            Names of the variables to analyse
        """
        return _persalys.OptimizationAnalysis_setInterestVariables(self, variablesNames)

    @staticmethod
    def GetSolverNames(*args):
        r"""
        Accessor to the list of solver names.

        Returns
        -------
        names : :class:`~openturns.Description`
            List of available solver names.
        """
        return _persalys.OptimizationAnalysis_GetSolverNames(*args)
    AlgorithmDictionary = property(_persalys.OptimizationAnalysis_AlgorithmDictionary_get, _persalys.OptimizationAnalysis_AlgorithmDictionary_set)

    def getSolverName(self):
        r"""
        Accessor to solver name

        Returns
        -------
        solver : str
            Solver name
        """
        return _persalys.OptimizationAnalysis_getSolverName(self)

    def setSolverName(self, name):
        r"""
        Accessor to solver name

        Parameters
        ----------
        solver : str
            Solver name. Use :func:`GetSolverNames()` to list available names.
        """
        return _persalys.OptimizationAnalysis_setSolverName(self, name)

    def getStartingPoint(self):
        r"""
        Accessor to starting point.

        Returns
        -------
        startingPoint : :class:`~openturns.Point`
            Starting point.
        """
        return _persalys.OptimizationAnalysis_getStartingPoint(self)

    def setStartingPoint(self, startingPoint):
        r"""
        Accessor to starting point.

        Parameters
        ----------
        startingPoint : sequence of float
            Starting point.
        """
        return _persalys.OptimizationAnalysis_setStartingPoint(self, startingPoint)

    def defineProblem(self):
        return _persalys.OptimizationAnalysis_defineProblem(self)

    def addConstraint(self, *args):
        r"""
        Adds a constraint to the analysis

        Parameters
        ----------
        constraint : str
            Constraint equation
        """
        return _persalys.OptimizationAnalysis_addConstraint(self, *args)

    def resetConstraints(self):
        r"""Clears the current analysis constraints"""
        return _persalys.OptimizationAnalysis_resetConstraints(self)

    def getRawEquations(self):
        r"""
        Accessor to constraints equations

        Returns
        -------
        equations : sequence of str
            Constraints equations
        """
        return _persalys.OptimizationAnalysis_getRawEquations(self)

    def setMaximumCallsNumber(self, maximumCallsNumber):
        r"""
        Accessor to maximum allowed number of calls.

        Parameters
        ----------
        N : int
            Maximum allowed number of calls.
        """
        return _persalys.OptimizationAnalysis_setMaximumCallsNumber(self, maximumCallsNumber)

    def getMaximumCallsNumber(self):
        return _persalys.OptimizationAnalysis_getMaximumCallsNumber(self)

    def getMaximumAbsoluteError(self):
        r"""
        Accessor to maximum allowed absolute error.

        Returns
        -------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _persalys.OptimizationAnalysis_getMaximumAbsoluteError(self)

    def setMaximumAbsoluteError(self, maximumAbsoluteError):
        r"""
        Accessor to maximum allowed absolute error.

        Parameters
        ----------
        maximumAbsoluteError : float
            Maximum allowed absolute error.
        """
        return _persalys.OptimizationAnalysis_setMaximumAbsoluteError(self, maximumAbsoluteError)

    def getMaximumRelativeError(self):
        r"""
        Accessor to maximum allowed relative error.

        Returns
        -------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _persalys.OptimizationAnalysis_getMaximumRelativeError(self)

    def setMaximumRelativeError(self, maximumRelativeError):
        r"""
        Accessor to maximum allowed relative error.

        Parameters
        ----------
        maximumRelativeError : float
            Maximum allowed relative error.
        """
        return _persalys.OptimizationAnalysis_setMaximumRelativeError(self, maximumRelativeError)

    def getMaximumResidualError(self):
        r"""
        Accessor to maximum allowed residual error.

        Returns
        -------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _persalys.OptimizationAnalysis_getMaximumResidualError(self)

    def setMaximumResidualError(self, maximumResidualError):
        r"""
        Accessor to maximum allowed residual error.

        Parameters
        ----------
        maximumResidualError : float
            Maximum allowed residual error.
        """
        return _persalys.OptimizationAnalysis_setMaximumResidualError(self, maximumResidualError)

    def getMaximumConstraintError(self):
        r"""
        Accessor to maximum allowed constraint error.

        Returns
        -------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _persalys.OptimizationAnalysis_getMaximumConstraintError(self)

    def setMaximumConstraintError(self, maximumConstraintError):
        r"""
        Accessor to maximum allowed constraint error.

        Parameters
        ----------
        maximumConstraintError : float
            Maximum allowed constraint error.
        """
        return _persalys.OptimizationAnalysis_setMaximumConstraintError(self, maximumConstraintError)

    def getMinimization(self):
        r"""
        Test whether this is a minimization or maximization problem.

        Returns
        -------
        value : bool
            *True* if this is a minimization problem (default), *False* otherwise.
        """
        return _persalys.OptimizationAnalysis_getMinimization(self)

    def setMinimization(self, minimization):
        r"""
        Tell whether this is a minimization or maximization problem.

        Parameters
        ----------
        minimization : bool
            *True* if this is a minimization problem, *False* otherwise.
        """
        return _persalys.OptimizationAnalysis_setMinimization(self, minimization)

    def getVariablesType(self):
        return _persalys.OptimizationAnalysis_getVariablesType(self)

    def setVariablesType(self, variablesType):
        return _persalys.OptimizationAnalysis_setVariablesType(self, variablesType)

    def getBounds(self):
        r"""
        Accessor to bounds.

        Returns
        -------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _persalys.OptimizationAnalysis_getBounds(self)

    def setBounds(self, bounds):
        r"""
        Accessor to bounds.

        Parameters
        ----------
        bounds : :class:`~openturns.Interval`
            Problem bounds.
        """
        return _persalys.OptimizationAnalysis_setBounds(self, bounds)

    def getVariableInputs(self):
        r"""
        Accessor to variable input names

        Returns
        -------
        inputs : :class:`~openturns.Description`
            Variable input names. It is set by default to the list of inputs of the model.
        """
        return _persalys.OptimizationAnalysis_getVariableInputs(self)

    def setVariableInputs(self, inputs):
        r"""
        Accessor to variable input names

        Parameters
        ----------
        inputs : sequence of str
            Variable input names. It is set by default to the list of inputs of the model.
        """
        return _persalys.OptimizationAnalysis_setVariableInputs(self, inputs)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.OptimizationAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.OptimizationAnalysis_hasValidResult(self)

    def getEqualityConstraints(self):
        return _persalys.OptimizationAnalysis_getEqualityConstraints(self)

    def getInequalityConstraints(self):
        return _persalys.OptimizationAnalysis_getInequalityConstraints(self)

    def getResult(self):
        r"""
        Accessor to optimization result.

        Returns
        -------
        result : :class:`~openturns.OptimizationResult`
            Result class.
        """
        return _persalys.OptimizationAnalysis_getResult(self)

    def __repr__(self):
        return _persalys.OptimizationAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.OptimizationAnalysis_swiginit(self, _persalys.new_OptimizationAnalysis(*args))
    __swig_destroy__ = _persalys.delete_OptimizationAnalysis

# Register OptimizationAnalysis in _persalys:
_persalys.OptimizationAnalysis_swigregister(OptimizationAnalysis)
cvar = _persalys.cvar

class MultiObjectiveOptimizationAnalysisResult(openturns.common.PersistentObject):
    r"""Multi-objective optimization analysis result."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MultiObjectiveOptimizationAnalysisResult_getClassName(self)

    def __init__(self):
        _persalys.MultiObjectiveOptimizationAnalysisResult_swiginit(self, _persalys.new_MultiObjectiveOptimizationAnalysisResult())

    def getFronts(self):
        r"""
        Accessor to fronts data.

        Parameters
        ----------
        finalPop : Collection of :class:`~openturns.Sample`
            Collection of fronts sample. Each collection item contains final points (Xi). The i^{th} items contains points from front_i.
        """
        return _persalys.MultiObjectiveOptimizationAnalysisResult_getFronts(self)

    def setFronts(self, fronts):
        return _persalys.MultiObjectiveOptimizationAnalysisResult_setFronts(self, fronts)

    def getFinalPop(self):
        r"""
        Accessor to final population.

        Parameters
        ----------
        finalPop : :class:`~openturns.Sample`
            Final population sample. Final points (Xi) and values (Yi) are stacked together with an additional column containing the front index of each point.

        +----+----+---------------+
        | Xi | Yi | _front_index_ |
        +----+----+---------------+
        |    |    |               |
        """
        return _persalys.MultiObjectiveOptimizationAnalysisResult_getFinalPop(self)

    def setFinalPop(self, finalPop):
        return _persalys.MultiObjectiveOptimizationAnalysisResult_setFinalPop(self, finalPop)

    def __repr__(self):
        return _persalys.MultiObjectiveOptimizationAnalysisResult___repr__(self)
    __swig_destroy__ = _persalys.delete_MultiObjectiveOptimizationAnalysisResult

# Register MultiObjectiveOptimizationAnalysisResult in _persalys:
_persalys.MultiObjectiveOptimizationAnalysisResult_swigregister(MultiObjectiveOptimizationAnalysisResult)
class MultiObjectiveOptimizationAnalysis(OptimizationAnalysis):
    r"""
    Perform the multi-objective optimization analysis of a model.

    Parameters
    ----------
    name : str
        Name
    physicalModel : :class:`~persalys.PhysicalModel`
        Physical model
    solverName : str
        Optimization algorithm name (optional). Use :func:`GetSolverNames()` to list available names.

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the model:

    >>> X0 = persalys.Input('X0', 0)
    >>> X1 = persalys.Input('X1', 0)
    >>> Y0 = persalys.Output('Y0')
    >>> Y1 = persalys.Output('Y1')
    >>> bounds = ot.Interval([0.0, 0.0], [5.0, 5.0])
    >>> model = persalys.SymbolicPhysicalModel('aModelPhys', [X0, X1], [Y0, Y1], ['X0', 'var g := 1.0 + 9.0 * (X0 + X1); g * (1.0 - sqrt(X0 / g))'])

    Create the analysis:

    >>> analysis = persalys.MultiObjectiveOptimizationAnalysis('anAnalysis', model, 'nsga2')
    >>> analysis.setInterestVariables(['Y0', 'Y1'])
    >>> analysis.setBounds(bounds)
    >>> analysis.setPopulationSize(50)
    >>> analysis.setGenerationNumber(10)
    >>> analysis.setVariableInputs(['X0', 'X1'])
    >>> analysis.run() # doctest: +SKIP

    Get the result:

    >>> result = analysis.getResult() # doctest: +SKIP
    >>> finalPop = result.getFinalPop() # doctest: +SKIP
    >>> fronts = result.getFronts() # doctest: +SKIP
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getClassName(self)

    def setInterestVariables(self, variablesNames):
        r"""
        Set the variables to analyse.

        Parameters
        ----------
        variablesNames : sequence of str
            Names of the variables to analyse
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_setInterestVariables(self, variablesNames)

    def setSolverName(self, name):
        r"""
        Accessor to solver name

        Parameters
        ----------
        solver : str
            Solver name. Use :func:`GetSolverNames()` to list available names.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_setSolverName(self, name)

    def initialize(self):
        return _persalys.MultiObjectiveOptimizationAnalysis_initialize(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.MultiObjectiveOptimizationAnalysis_canBeLaunched(self, errorMessage)

    @staticmethod
    def GetSolverNames(*args):
        r"""
        Accessor to the list of solver names.

        Returns
        -------
        names : :class:`~openturns.Description`
            List of available solver names.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_GetSolverNames(*args)

    def setPopulationSize(self, popSize):
        r"""
        Accessor to popSize.

        Parameters
        ----------
        popSize : int
            Initial population sample size.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_setPopulationSize(self, popSize)

    def getPopulationSize(self):
        r"""
        Accessor to popSize.

        Returns
        -------
        popSize : int
            Initial population sample size.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getPopulationSize(self)

    def setGenerationNumber(self, generationNumber):
        r"""
        Accessor to the number of generations.

        Parameters
        ----------
        generationNumber : int
            number of generations for the evolving algorithm.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_setGenerationNumber(self, generationNumber)

    def getGenerationNumber(self):
        r"""
        Accessor to the number of generations.

        Returns
        -------
        generationNumber : int
            number of generations for the evolving algorithm.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getGenerationNumber(self)

    def getMinimization(self):
        r"""
        Test whether this is a minimization or maximization problem.

        Returns
        -------
        value : bool
            *True* if this is a minimization problem (default), *False* otherwise.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getMinimization(self)

    def setMinimization(self, varNames):
        r"""
        Tell whether this is a minimization or maximization problem.

        Parameters
        ----------
        minimization : bool
            *True* if this is a minimization problem, *False* otherwise.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_setMinimization(self, varNames)

    def setSeed(self, seed):
        r"""
        Accessor to random generator seed.

        Parameters
        ----------
        seed : int
            random generator seed for the evolving algorithm.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_setSeed(self, seed)

    def getSeed(self):
        r"""
        Accessor to random generator seed.

        Returns
        -------
        seed : int
            random generator seed for the evolving algorithm.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getSeed(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_hasValidResult(self)

    def getResult(self):
        r"""
        Accessor to result.

        Returns
        -------
        result : :class:`~persalys.MultiObjectiveOptimizationAnalysisResult`
            multi-objective analysis result.
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getResult(self)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.MultiObjectiveOptimizationAnalysis_getPythonScript(self)

    def __repr__(self):
        return _persalys.MultiObjectiveOptimizationAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.MultiObjectiveOptimizationAnalysis_swiginit(self, _persalys.new_MultiObjectiveOptimizationAnalysis(*args))
    __swig_destroy__ = _persalys.delete_MultiObjectiveOptimizationAnalysis

# Register MultiObjectiveOptimizationAnalysis in _persalys:
_persalys.MultiObjectiveOptimizationAnalysis_swigregister(MultiObjectiveOptimizationAnalysis)
class CalibrationAnalysisResult(openturns.common.PersistentObject):
    r"""Get the results of a calibration analysis."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CalibrationAnalysisResult_getClassName(self)

    def getCalibrationResult(self):
        r"""
        Calibration result accessor.

        Returns
        -------
        result : :py:class:`openturns.CalibrationResult`
            Calibration result
        """
        return _persalys.CalibrationAnalysisResult_getCalibrationResult(self)

    def getConfidenceInterval(self):
        r"""
        Confidence interval of the posterior distribution accessor.

        Returns
        -------
        interval : :py:class:`openturns.Interval`
            Confidence interval of the posterior distribution
        """
        return _persalys.CalibrationAnalysisResult_getConfidenceInterval(self)

    def getPriorResidualsPDF(self):
        r"""
        Prior output residuals PDF accessor.

        Returns
        -------
        samples : sequence of :py:class:`openturns.Sample`
            For each output, the Probability Distribution Function values of the difference
            between the output observations and the prior output values
        """
        return _persalys.CalibrationAnalysisResult_getPriorResidualsPDF(self)

    def getPosteriorResidualsPDF(self):
        r"""
        Posterior output residuals PDF accessor.

        Returns
        -------
        samples : sequence of :py:class:`openturns.Sample`
            For each output, the Probability Distribution Function values of the difference
            between the output observations and the posterior output values
        """
        return _persalys.CalibrationAnalysisResult_getPosteriorResidualsPDF(self)

    def __repr__(self):
        return _persalys.CalibrationAnalysisResult___repr__(self)

    def __init__(self, *args):
        _persalys.CalibrationAnalysisResult_swiginit(self, _persalys.new_CalibrationAnalysisResult(*args))
    __swig_destroy__ = _persalys.delete_CalibrationAnalysisResult

# Register CalibrationAnalysisResult in _persalys:
_persalys.CalibrationAnalysisResult_swigregister(CalibrationAnalysisResult)
class CalibrationAnalysis(PhysicalModelAnalysis):
    r"""
    Run a calibration analysis.

    Parameters
    ----------
    name : str
        Name
    observations : :class:`~persalys.Observations`
        Observations of at least one input and one output

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys

    Create the Chaboche model:

    >>> R = persalys.Input('R', 700e6, ot.LogNormalMuSigma(750e6, 11e6).getDistribution(), 'Parameter R')
    >>> C = persalys.Input('C', 2500e6, ot.Normal(2750e6, 250e6), 'Parameter C')
    >>> gamma = persalys.Input('gam', 8., ot.Normal(10, 2), 'Parameter gamma')
    >>> dist_strain = ot.Uniform(0, 0.07)
    >>> strain = persalys.Input('strain', 0., dist_strain, 'Strain')
    >>> sigma = persalys.Output('sigma', 'Stress (Pa)')

    >>> model = persalys.SymbolicPhysicalModel('model1', [R, C, gamma, strain], [sigma], ['R + C / gam * (1 - exp(-gam * strain))'])

    Generate observations:

    >>> nbObs = 100
    >>> strainObs = dist_strain.getSample(nbObs)
    >>> strainObs.setDescription(['strain'])
    >>> stressSampleNoise = ot.Normal(0., 40.e6).getSample(nbObs)
    >>> stressSample = ot.ParametricFunction(model.getFunction(), [0, 1, 2], [750e6, 2750e6, 10.])(strainObs)
    >>> stressObs = stressSample + stressSampleNoise

    >>> observations = persalys.Observations('obs1', model, strainObs, stressObs)

    Process a calibration analysis:

    >>> analysis = persalys.CalibrationAnalysis('myAnalysis', observations)
    >>> analysis.run()

    Get the result:

    >>> result = analysis.getResult()
    >>> thetaStar = result.getCalibrationResult().getParameterMAP()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CalibrationAnalysis_getClassName(self)

    def getParentObserver(self):
        return _persalys.CalibrationAnalysis_getParentObserver(self)

    def getObservations(self):
        r"""
        Accessor to the data to be fitted.

        Returns
        -------
        data : :class:`~openturns.Sample`
            The data to be fitted.
        """
        return _persalys.CalibrationAnalysis_getObservations(self)

    def getResult(self):
        r"""
        Result accessor.

        Returns
        -------
        result : :class:`~persalys.CalibrationAnalysisResult`
            Result
        """
        return _persalys.CalibrationAnalysis_getResult(self)

    @staticmethod
    def GetMethodNames():
        r"""
        Get the list of available method names.

        Returns
        -------
        names : :class:`~openturns.Description`
            List of available calibration method names.
        """
        return _persalys.CalibrationAnalysis_GetMethodNames()

    def getMethodName(self):
        r"""
        Accessor to the method name

        Returns
        -------
        method : str
            Method name. Default is 'LeastSquaresLinear'.
            Use :func:`GetMethodNames()` to list available names.
        """
        return _persalys.CalibrationAnalysis_getMethodName(self)

    def setMethodName(self, name):
        r"""
        Accessor to the method name

        Parameters
        ----------
        method : str
            Method name. Default is 'LeastSquaresLinear'.
            Use :func:`GetMethodNames()` to list available names.
        """
        return _persalys.CalibrationAnalysis_setMethodName(self, name)

    def getOptimizationAlgorithm(self):
        r"""
        Accessor to the optimization algorithm used by non linear algorithms.

        Returns
        -------
        algorithm : :py:class:`openturns.OptimizationAlgorithm`
            Optimization algorithm used by non linear algorithms.
            The optimization problem and the starting point are not taken into account.
        """
        return _persalys.CalibrationAnalysis_getOptimizationAlgorithm(self)

    def setOptimizationAlgorithm(self, solver):
        r"""
        Accessor to the optimization algorithm used by non linear algorithms.

        Parameters
        ----------
        algorithm : :py:class:`openturns.OptimizationAlgorithm`
            Optimization algorithm used by non linear algorithms.
            The optimization problem and the starting point are not taken into account.
        """
        return _persalys.CalibrationAnalysis_setOptimizationAlgorithm(self, solver)

    def getFixedInputs(self):
        r"""
        Fixed inputs accessor.

        Returns
        -------
        inputs : :py:class:`openturns.PointWithDescription`
            Fixed input names and values
        """
        return _persalys.CalibrationAnalysis_getFixedInputs(self)

    def getCalibratedInputs(self):
        r"""
        Inputs to calibrate accessor.

        Returns
        -------
        inputs : :py:class:`openturns.Description`
            Names of the input variables to calibrate
        """
        return _persalys.CalibrationAnalysis_getCalibratedInputs(self)

    def setCalibratedInputs(self, *args):
        r"""
        Accessor to the inputs to calibrate and the fixed inputs.

        Parameters
        ----------
        calibratedInput : sequence of str
            Names of the input variables to calibrate
        priorDistribution : :py:class:`openturns.Distribution`
            Prior distribution. Its dimension must equal to the number of
            variables to calibrate
        fixedInputs : sequence of str, optional
            Names of the input variables to fix
        values : sequence of float, optional
            Values of the fixed inputs
        """
        return _persalys.CalibrationAnalysis_setCalibratedInputs(self, *args)

    def getPriorDistribution(self):
        r"""
        Accessor to the prior distribution.

        Returns
        -------
        distribution : :py:class:`openturns.Distribution`
            Prior distribution
        """
        return _persalys.CalibrationAnalysis_getPriorDistribution(self)

    def getErrorCovariance(self):
        r"""
        Accessor to the output observations error covariance.

        Returns
        -------
        matrix : :py:class:`openturns.CovarianceMatrix`
            The covariance matrix of the gaussian distribution of the output observations error.
            Used by the gaussian algorithms.
        """
        return _persalys.CalibrationAnalysis_getErrorCovariance(self)

    def setErrorCovariance(self, matrix):
        r"""
        Accessor to the output observations error covariance.

        Parameters
        ----------
        matrix : :py:class:`openturns.CovarianceMatrix`
            The covariance matrix of the gaussian distribution of the output observations error.
            Used by the gaussian algorithms.
        """
        return _persalys.CalibrationAnalysis_setErrorCovariance(self, matrix)

    def getConfidenceIntervalLength(self):
        r"""
        Confidence interval length accessor.

        Returns
        -------
        length : float
            Length of the confidence interval of the posterior distribution.
            It is set by default to 0.95.
        """
        return _persalys.CalibrationAnalysis_getConfidenceIntervalLength(self)

    def setConfidenceIntervalLength(self, arg2):
        r"""
        Confidence interval length accessor.

        Parameters
        ----------
        length : float
            Length of the confidence interval of the posterior distribution.
            It is set by default to 0.95.
        """
        return _persalys.CalibrationAnalysis_setConfidenceIntervalLength(self, arg2)

    def getBootStrapSize(self):
        r"""
        Accessor to the bootstrap size used to sample the posterior distribution.

        Returns
        -------
        size : int
            Bootstrap size used to sample the posterior distribution by the non linear algorithms.
            A value of 0 means that no bootstrap has been done but a linear approximation
            has been used to get the posterior distribution, using the
            GaussianLinearCalibration or LinearLeastSquaresCalibration algorithm
            at the maximum a posteriori estimate. The value 1 is not allowed at this time.
        """
        return _persalys.CalibrationAnalysis_getBootStrapSize(self)

    def setBootStrapSize(self, arg2):
        r"""
        Accessor to the bootstrap size used to sample the posterior distribution.

        Parameters
        ----------
        size : int
            Bootstrap size used to sample the posterior distribution by the non linear algorithms.
            A value of 0 means that no bootstrap has been done but a linear approximation
            has been used to get the posterior distribution, using the
            GaussianLinearCalibration or LinearLeastSquaresCalibration algorithm
            at the maximum a posteriori estimate. The value 1 is not allowed at this time.
        """
        return _persalys.CalibrationAnalysis_setBootStrapSize(self, arg2)

    def getPythonScript(self):
        r"""
        Physical model accessor.

        Returns
        -------
        script : str
            Python script to replay the analysis
        """
        return _persalys.CalibrationAnalysis_getPythonScript(self)

    def hasValidResult(self):
        r"""
        Whether the analysis has been run.

        Returns
        -------
        hasValidResult : bool
            Whether the analysis has already been run
        """
        return _persalys.CalibrationAnalysis_hasValidResult(self)

    def canBeLaunched(self, errorMessage):
        return _persalys.CalibrationAnalysis_canBeLaunched(self, errorMessage)

    def __repr__(self):
        return _persalys.CalibrationAnalysis___repr__(self)

    def __init__(self, *args):
        _persalys.CalibrationAnalysis_swiginit(self, _persalys.new_CalibrationAnalysis(*args))
    __swig_destroy__ = _persalys.delete_CalibrationAnalysis

# Register CalibrationAnalysis in _persalys:
_persalys.CalibrationAnalysis_swigregister(CalibrationAnalysis)
class StudyImplementation(openturns.common.PersistentObject, Observable, Observer):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.StudyImplementation_getClassName(self)
    __swig_destroy__ = _persalys.delete_StudyImplementation

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.StudyImplementation_setName(self, name)

    def update(self, source, message):
        return _persalys.StudyImplementation_update(self, source, message)

    def hasBeenModified(self):
        return _persalys.StudyImplementation_hasBeenModified(self)

    def __eq__(self, other):
        return _persalys.StudyImplementation___eq__(self, other)

    def __ne__(self, other):
        return _persalys.StudyImplementation___ne__(self, other)

    def clear(self):
        return _persalys.StudyImplementation_clear(self)

    def getFileName(self):
        return _persalys.StudyImplementation_getFileName(self)

    def getDataModels(self):
        return _persalys.StudyImplementation_getDataModels(self)

    def getDataModelByName(self, dataModelName):
        return _persalys.StudyImplementation_getDataModelByName(self, dataModelName)

    def hasDataModelNamed(self, dataModelName):
        return _persalys.StudyImplementation_hasDataModelNamed(self, dataModelName)

    def getAvailableDataModelName(self, modelRootName):
        return _persalys.StudyImplementation_getAvailableDataModelName(self, modelRootName)

    def getPhysicalModels(self):
        return _persalys.StudyImplementation_getPhysicalModels(self)

    def getPhysicalModelByName(self, physicalModelName):
        return _persalys.StudyImplementation_getPhysicalModelByName(self, physicalModelName)

    def hasPhysicalModelNamed(self, physicalModelName):
        return _persalys.StudyImplementation_hasPhysicalModelNamed(self, physicalModelName)

    def getAvailablePhysicalModelName(self, physicalModelRootName):
        return _persalys.StudyImplementation_getAvailablePhysicalModelName(self, physicalModelRootName)

    def getAnalyses(self):
        return _persalys.StudyImplementation_getAnalyses(self)

    def getAnalysisByName(self, analysisName):
        return _persalys.StudyImplementation_getAnalysisByName(self, analysisName)

    def hasAnalysisNamed(self, analysisName):
        return _persalys.StudyImplementation_hasAnalysisNamed(self, analysisName)

    def getAvailableAnalysisName(self, rootName):
        return _persalys.StudyImplementation_getAvailableAnalysisName(self, rootName)

    def getLimitStates(self):
        return _persalys.StudyImplementation_getLimitStates(self)

    def hasLimitStateNamed(self, limitStateName):
        return _persalys.StudyImplementation_hasLimitStateNamed(self, limitStateName)

    def getAvailableLimitStateName(self, rootName):
        return _persalys.StudyImplementation_getAvailableLimitStateName(self, rootName)

    def add(self, *args):
        return _persalys.StudyImplementation_add(self, *args)

    def remove(self, *args):
        return _persalys.StudyImplementation_remove(self, *args)

    def getPythonScript(self):
        return _persalys.StudyImplementation_getPythonScript(self)

    def save(self, xmlFileName):
        return _persalys.StudyImplementation_save(self, xmlFileName)

    def __init__(self, *args):
        _persalys.StudyImplementation_swiginit(self, _persalys.new_StudyImplementation(*args))

# Register StudyImplementation in _persalys:
_persalys.StudyImplementation_swigregister(StudyImplementation)
class StudyImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _persalys.StudyImplementationTypedInterfaceObject_swiginit(self, _persalys.new_StudyImplementationTypedInterfaceObject(*args))

    def getImplementation(self):
        r"""
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            A copy of the underlying implementation object.
        """
        return _persalys.StudyImplementationTypedInterfaceObject_getImplementation(self)

    def setName(self, name):
        r"""
        Accessor to the object's name.

        Parameters
        ----------
        name : str
            The name of the object.
        """
        return _persalys.StudyImplementationTypedInterfaceObject_setName(self, name)

    def getName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        name : str
            The name of the object.
        """
        return _persalys.StudyImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, other):
        return _persalys.StudyImplementationTypedInterfaceObject___eq__(self, other)

    def __ne__(self, other):
        return _persalys.StudyImplementationTypedInterfaceObject___ne__(self, other)
    __swig_destroy__ = _persalys.delete_StudyImplementationTypedInterfaceObject

# Register StudyImplementationTypedInterfaceObject in _persalys:
_persalys.StudyImplementationTypedInterfaceObject_swigregister(StudyImplementationTypedInterfaceObject)
class StudyCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_StudyCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.StudyCollection_clear(self)

    def __len__(self):
        return _persalys.StudyCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.StudyCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.StudyCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.StudyCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.StudyCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.StudyCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.StudyCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.StudyCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.StudyCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.StudyCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.StudyCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.StudyCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.StudyCollection_find(self, val)

    def __repr__(self):
        return _persalys.StudyCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.StudyCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.StudyCollection_swiginit(self, _persalys.new_StudyCollection(*args))

# Register StudyCollection in _persalys:
_persalys.StudyCollection_swigregister(StudyCollection)
class Study(StudyImplementationTypedInterfaceObject):
    r"""Create the class to store a study."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    @staticmethod
    def GetClassName():
        return _persalys.Study_GetClassName()

    def getClassName(self):
        return _persalys.Study_getClassName(self)

    @staticmethod
    def GetInstances():
        r"""
        Studies accessor.

        Returns
        -------
        studies : sequence of :class:`~persalys.Study`
            Studies existing in the tree view
        """
        return _persalys.Study_GetInstances()

    @staticmethod
    def GetFileNames():
        r"""
        Files name accessor.

        Returns
        -------
        filesNames : :py:class:`openturns.Description`
            The file names of all the opened studies
        """
        return _persalys.Study_GetFileNames()

    @staticmethod
    def HasInstanceNamed(studyName):
        r"""
        Whether the tree view contains a study named with the given name.

        Parameters
        ----------
        name : str
            A study name

        Returns
        -------
        contains : bool
            Whether it contains a study named with the given name
        """
        return _persalys.Study_HasInstanceNamed(studyName)

    @staticmethod
    def GetAvailableName(rootName):
        r"""
        Available name for a study accessor.

        Returns
        -------
        name : str
            Available name for a study
        """
        return _persalys.Study_GetAvailableName(rootName)

    @staticmethod
    def Add(study):
        r"""
        Add a study in the tree view.

        Parameters
        ----------
        object : :class:`~persalys.Study`
            The study to add
        """
        return _persalys.Study_Add(study)

    @staticmethod
    def Remove(study):
        r"""
        Remove a study from the tree view.

        Parameters
        ----------
        object : :class:`~persalys.Study`
            The study to remove
        """
        return _persalys.Study_Remove(study)

    @staticmethod
    def Open(xmlFileName):
        r"""
        Open a study.

        Parameters
        ----------
        fileName : str
            The file name

        Returns
        -------
        study : :class:`~persalys.Study`
            The study saved in fileName
        """
        return _persalys.Study_Open(xmlFileName)

    def __eq__(self, other):
        return _persalys.Study___eq__(self, other)

    def __ne__(self, other):
        return _persalys.Study___ne__(self, other)

    def getFileName(self):
        r"""
        File name accessor.

        Returns
        -------
        fileName : str
            The file name
        """
        return _persalys.Study_getFileName(self)

    def getDataModels(self):
        r"""
        Data model accessor.

        Returns
        -------
        models : sequence of :class:`~persalys.DataModel`
            Data models
        """
        return _persalys.Study_getDataModels(self)

    def getDataModelByName(self, dataModelName):
        r"""
        Data model accessor.

        Parameters
        ----------
        name : str
            The data model name

        Returns
        -------
        model : :class:`~persalys.DataModel`
            Data model
        """
        return _persalys.Study_getDataModelByName(self, dataModelName)

    def getAvailableDataModelName(self, modelRootName):
        r"""
        Available name for a data model accessor.

        Returns
        -------
        name : str
            Available name for a data model
        """
        return _persalys.Study_getAvailableDataModelName(self, modelRootName)

    def getPhysicalModels(self):
        r"""
        Physical models accessor.

        Returns
        -------
        models : sequence of :class:`~persalys.PhysicalModel`
            Physical models
        """
        return _persalys.Study_getPhysicalModels(self)

    def getPhysicalModelByName(self, physicalModelName):
        r"""
        Physical model accessor.

        Parameters
        ----------
        name : str
            The model name

        Returns
        -------
        model : :class:`~persalys.PhysicalModel`
            Physical model
        """
        return _persalys.Study_getPhysicalModelByName(self, physicalModelName)

    def getAvailablePhysicalModelName(self, physicalModelRootName):
        r"""
        Available name for a physical model accessor.

        Returns
        -------
        name : str
            Available name for a physical model
        """
        return _persalys.Study_getAvailablePhysicalModelName(self, physicalModelRootName)

    def getAnalyses(self):
        r"""
        Analysis accessor.

        Returns
        -------
        analyses : sequence of :class:`~persalys.Analysis`
            Analyses
        """
        return _persalys.Study_getAnalyses(self)

    def getAnalysisByName(self, analysisName):
        r"""
        Analysis accessor.

        Parameters
        ----------
        name : str
            The analysis name

        Returns
        -------
        analysis : :class:`~persalys.Analysis`
            Analysis
        """
        return _persalys.Study_getAnalysisByName(self, analysisName)

    def getAvailableAnalysisName(self, rootName):
        r"""
        Available name for an analysis accessor.

        Returns
        -------
        name : str
            Available name for an analysis
        """
        return _persalys.Study_getAvailableAnalysisName(self, rootName)

    def getLimitStates(self):
        r"""
        Limit state accessor.

        Returns
        -------
        states : sequence of :class:`~persalys.LimitState`
            Limit states
        """
        return _persalys.Study_getLimitStates(self)

    def getAvailableLimitStateName(self, rootName):
        r"""
        Available name for a limit state accessor.

        Returns
        -------
        name : str
            Available name for a limit state
        """
        return _persalys.Study_getAvailableLimitStateName(self, rootName)

    def add(self, *args):
        r"""
        Add an object to the study.

        Parameters
        ----------
        object : :class:`~persalys.PhysicalModel`, :class:`~persalys.LimitState`, :class:`~persalys.Analysis` ...
            The object to add
        """
        val = _persalys.Study_add(self, *args)

        args[0].thisown = 0


        return val


    def remove(self, *args):
        r"""
        Remove an object from the study.

        Parameters
        ----------
        object : :class:`~persalys.PhysicalModel`, :class:`~persalys.LimitState`, :class:`~persalys.Analysis` ...
            The object to remove
        """
        val = _persalys.Study_remove(self, *args)

        args[0].thisown = 1


        return val


    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            The Python script
        """
        return _persalys.Study_getPythonScript(self)

    def save(self, xmlFileName):
        r"""
        Save it in an xml file.

        Parameters
        ----------
        fileName : str
            The file name
        """
        return _persalys.Study_save(self, xmlFileName)

    def __init__(self, *args):
        _persalys.Study_swiginit(self, _persalys.new_Study(*args))

    def __repr__(self):
        return _persalys.Study___repr__(self)
    __swig_destroy__ = _persalys.delete_Study

# Register Study in _persalys:
_persalys.Study_swigregister(Study)
class CouplingInputFile(openturns.common.PersistentObject):
    r"""
    Input file metadata for coupling.

    Parameters
    ----------
    path : str
        Path to the template file.

    Notes
    -----
    By default the configured path is the basename of the template path,
    minus the `.in` extension.

    See Also
    --------
    CouplingStep, CouplingResourceFile, CouplingOutputFile
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CouplingInputFile_getClassName(self)

    def setPath(self, templatePath):
        r"""
        Template file path accessor.

        Parameters
        ----------
        path : str
            Path to the template file.
        """
        return _persalys.CouplingInputFile_setPath(self, templatePath)

    def getPath(self):
        r"""
        Template file path accessor.

        Returns
        -------
        path : str
            Path to the template file.
        """
        return _persalys.CouplingInputFile_getPath(self)

    def setConfiguredPath(self, configuredPath):
        r"""
        Configured path accessor.

        Parameters
        ----------
        configured_path : str
            Configured file path, must be relative.
            It is interpreted as the path to the file with the actual input values
            relatively to the temporary working directory.
        """
        return _persalys.CouplingInputFile_setConfiguredPath(self, configuredPath)

    def getConfiguredPath(self):
        r"""
        Template path accessor.

        Returns
        -------
        configured_path : str
            Configured file path.
        """
        return _persalys.CouplingInputFile_getConfiguredPath(self)

    def setVariables(self, variableNames, tokens, formats):
        r"""
        Variables accessor.

        Parameters
        ----------
        names : sequence of str
            Variable names
        tokens : sequence of str
            Tokens used for replacement in the template file.
        formats : sequence of str
            Variable numerical formats
        """
        return _persalys.CouplingInputFile_setVariables(self, variableNames, tokens, formats)

    def getVariableNames(self):
        r"""
        Variable names accessor.

        Returns
        -------
        variable_names : :py:class:`openturns.Description`
            Input variable names
        """
        return _persalys.CouplingInputFile_getVariableNames(self)

    def getTokens(self):
        r"""
        Tokens accessor.

        Returns
        -------
        tokens : :py:class:`openturns.Description`
            Tokens for each variable
        """
        return _persalys.CouplingInputFile_getTokens(self)

    def getFormats(self):
        r"""
        Variables format accessor.

        Returns
        -------
        formats : :py:class:`openturns.Description`
            Input variables format
        """
        return _persalys.CouplingInputFile_getFormats(self)

    def simulateInput(self, varColl):
        return _persalys.CouplingInputFile_simulateInput(self, varColl)

    def __repr__(self):
        return _persalys.CouplingInputFile___repr__(self)

    def __init__(self, *args):
        _persalys.CouplingInputFile_swiginit(self, _persalys.new_CouplingInputFile(*args))
    __swig_destroy__ = _persalys.delete_CouplingInputFile

# Register CouplingInputFile in _persalys:
_persalys.CouplingInputFile_swigregister(CouplingInputFile)
class CouplingResourceFile(openturns.common.PersistentObject):
    r"""
    Resource file metadata for coupling.

    Parameters
    ----------
    path : str
        Path to a resource (file or directory) to copy to the temporary
        working directory in which the command of the corresponding step is run.
        Must be absolute.

    See Also
    --------
    CouplingStep, CouplingInputFile, CouplingOutputFile
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CouplingResourceFile_getClassName(self)

    def setPath(self, path):
        r"""
        Path accessor.

        Parameters
        ----------
        path : str
            Path to the input file.
        """
        return _persalys.CouplingResourceFile_setPath(self, path)

    def getPath(self):
        r"""
        Path accessor.

        Returns
        -------
        path : str
            Path
        """
        return _persalys.CouplingResourceFile_getPath(self)

    def __repr__(self):
        return _persalys.CouplingResourceFile___repr__(self)

    def __init__(self, *args):
        _persalys.CouplingResourceFile_swiginit(self, _persalys.new_CouplingResourceFile(*args))
    __swig_destroy__ = _persalys.delete_CouplingResourceFile

# Register CouplingResourceFile in _persalys:
_persalys.CouplingResourceFile_swigregister(CouplingResourceFile)
class CouplingOutputFile(openturns.common.PersistentObject):
    r"""
    Output file metadata for coupling.

    Parameters
    ----------
    path : str
        Path to the output file.
        It must be must be relative, and is joined to the temporary working directory.

    See Also
    --------
    CouplingStep, CouplingInputFile, CouplingResourceFile
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CouplingOutputFile_getClassName(self)

    def setPath(self, path):
        r"""
        Path accessor.

        Parameters
        ----------
        path : str
            Path to the output file, must be relative.
        """
        return _persalys.CouplingOutputFile_setPath(self, path)

    def getPath(self):
        r"""
        Path accessor.

        Returns
        -------
        path : str
            Path
        """
        return _persalys.CouplingOutputFile_getPath(self)

    def setVariables(self, variableNames, tokens, skipTokens, skipLines, skipColumns):
        r"""
        Variables accessor.

        Parameters
        ----------
        names : sequence of str
            Variable names
        tokens : sequence of str
            Tokens used for reading in the output file for each variable.
        skip_lines : sequence of int
            Number of lines skipped for each variable.
        skip_columns : sequence of int
            Number of columnes skipped for each variable.
        """
        return _persalys.CouplingOutputFile_setVariables(self, variableNames, tokens, skipTokens, skipLines, skipColumns)

    def getVariableNames(self):
        r"""
        Variable names accessor.

        Returns
        -------
        variable_names : :py:class:`openturns.Description`
            Output variable names
        """
        return _persalys.CouplingOutputFile_getVariableNames(self)

    def getTokens(self):
        r"""
        Tokens accessor.

        Returns
        -------
        tokens : :py:class:`openturns.Description`
            Tokens for each variable
        """
        return _persalys.CouplingOutputFile_getTokens(self)

    def getSkipLines(self):
        r"""
        Skip lines accessor.

        Returns
        -------
        skip_lines : :py:class:`openturns.Point`
            Number of lines skipped for each variable
        """
        return _persalys.CouplingOutputFile_getSkipLines(self)

    def getSkipColumns(self):
        r"""
        Skip columns accessor.

        Returns
        -------
        skip_columns : :py:class:`openturns.Point`
            Number of columns skipped for each variable
        """
        return _persalys.CouplingOutputFile_getSkipColumns(self)

    def getSkipTokens(self):
        return _persalys.CouplingOutputFile_getSkipTokens(self)

    def checkOutputFile(self, *args):
        return _persalys.CouplingOutputFile_checkOutputFile(self, *args)

    def __repr__(self):
        return _persalys.CouplingOutputFile___repr__(self)

    def __init__(self, *args):
        _persalys.CouplingOutputFile_swiginit(self, _persalys.new_CouplingOutputFile(*args))
    __swig_destroy__ = _persalys.delete_CouplingOutputFile

# Register CouplingOutputFile in _persalys:
_persalys.CouplingOutputFile_swigregister(CouplingOutputFile)
class CouplingInputFileCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_CouplingInputFileCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.CouplingInputFileCollection_clear(self)

    def __len__(self):
        return _persalys.CouplingInputFileCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.CouplingInputFileCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.CouplingInputFileCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.CouplingInputFileCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.CouplingInputFileCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.CouplingInputFileCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.CouplingInputFileCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.CouplingInputFileCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.CouplingInputFileCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.CouplingInputFileCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.CouplingInputFileCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.CouplingInputFileCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.CouplingInputFileCollection_find(self, val)

    def __repr__(self):
        return _persalys.CouplingInputFileCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.CouplingInputFileCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.CouplingInputFileCollection_swiginit(self, _persalys.new_CouplingInputFileCollection(*args))

# Register CouplingInputFileCollection in _persalys:
_persalys.CouplingInputFileCollection_swigregister(CouplingInputFileCollection)
class CouplingResourceFileCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_CouplingResourceFileCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.CouplingResourceFileCollection_clear(self)

    def __len__(self):
        return _persalys.CouplingResourceFileCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.CouplingResourceFileCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.CouplingResourceFileCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.CouplingResourceFileCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.CouplingResourceFileCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.CouplingResourceFileCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.CouplingResourceFileCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.CouplingResourceFileCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.CouplingResourceFileCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.CouplingResourceFileCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.CouplingResourceFileCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.CouplingResourceFileCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.CouplingResourceFileCollection_find(self, val)

    def __repr__(self):
        return _persalys.CouplingResourceFileCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.CouplingResourceFileCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.CouplingResourceFileCollection_swiginit(self, _persalys.new_CouplingResourceFileCollection(*args))

# Register CouplingResourceFileCollection in _persalys:
_persalys.CouplingResourceFileCollection_swigregister(CouplingResourceFileCollection)
class CouplingOutputFileCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_CouplingOutputFileCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.CouplingOutputFileCollection_clear(self)

    def __len__(self):
        return _persalys.CouplingOutputFileCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.CouplingOutputFileCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.CouplingOutputFileCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.CouplingOutputFileCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.CouplingOutputFileCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.CouplingOutputFileCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.CouplingOutputFileCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.CouplingOutputFileCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.CouplingOutputFileCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.CouplingOutputFileCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.CouplingOutputFileCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.CouplingOutputFileCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.CouplingOutputFileCollection_find(self, val)

    def __repr__(self):
        return _persalys.CouplingOutputFileCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.CouplingOutputFileCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.CouplingOutputFileCollection_swiginit(self, _persalys.new_CouplingOutputFileCollection(*args))

# Register CouplingOutputFileCollection in _persalys:
_persalys.CouplingOutputFileCollection_swigregister(CouplingOutputFileCollection)
class CouplingStep(openturns.common.PersistentObject):
    r"""
    Coupling step.

    Represents one step of the coupling with one command to execute and the
    associated input or output files.

    Parameters
    ----------
    command : str
        Command to execute
        By default it is run by the system else see :meth:`setIsShell`.
    input_files : sequence of :class:`~persalys.CouplingInputFile`
        Input file metadatas
    resource_files : sequence of :class:`~persalys.CouplingResourceFile`
        Resource file metadatas
    output_files : sequence of :class:`~persalys.CouplingOutputFile`
        Output file metadatas

    See Also
    --------
    CouplingPhysicalModel, CouplingInputFile, CouplingResourceFile, CouplingOutputFile
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CouplingStep_getClassName(self)

    def setCommand(self, command):
        r"""
        Path accessor.

        Parameters
        ----------
        path : str
            Path
        """
        return _persalys.CouplingStep_setCommand(self, command)

    def getCommand(self):
        r"""
        Path accessor.

        Returns
        -------
        path : :py:class:`openturns.Description`
            Path
        """
        return _persalys.CouplingStep_getCommand(self)

    def setEnvironment(self, keys, values):
        r"""
        Environment dictionary accessor.

        Parameters
        ----------
        keys : :py:class:`openturns.Description`
            Dictionary keys matching environment variables names
        values : :py:class:`openturns.Description`
            Dictionary values matching environment variables values
        """
        return _persalys.CouplingStep_setEnvironment(self, keys, values)

    def getEnvironmentKeys(self):
        r"""
        Environment variables names accessor.

        Returns
        -------
        keys : :py:class:`openturns.Description`
            Dictionary keys matching environment variables name
        """
        return _persalys.CouplingStep_getEnvironmentKeys(self)

    def getEnvironmentValues(self):
        r"""
        Environment variables values accessor.

        Returns
        -------
        values : :py:class:`openturns.Description`
            Dictionary valuess matching environment variables values
        """
        return _persalys.CouplingStep_getEnvironmentValues(self)

    def setIsShell(self, isShell):
        r"""
        Shell command property accessor.

        Parameters
        ----------
        is_shell : bool
            Whether the command should be interpreted by the shell
        """
        return _persalys.CouplingStep_setIsShell(self, isShell)

    def getIsShell(self):
        r"""
        Shell command property accessor.

        Returns
        -------
        is_shell : bool
            Whether the command should be interpreted by the shell
        """
        return _persalys.CouplingStep_getIsShell(self)

    def setInputFiles(self, inputFiles):
        r"""
        Tokens accessor.

        Parameters
        ----------
        input_files : sequence of :class:`~persalys.CouplingInputFile`
            Input file metadatas
        """
        return _persalys.CouplingStep_setInputFiles(self, inputFiles)

    def getInputFiles(self):
        r"""
        Template path accessor.

        Returns
        -------
        input_files : sequence of :class:`~persalys.CouplingInputFile`
            Input file metadatas
        """
        return _persalys.CouplingStep_getInputFiles(self)

    def setResourceFiles(self, inputFiles):
        r"""
        Tokens accessor.

        Parameters
        ----------
        resource_files : sequence of :class:`~persalys.CouplingResourceFile`
            Resource file metadatas
        """
        return _persalys.CouplingStep_setResourceFiles(self, inputFiles)

    def getResourceFiles(self):
        r"""
        Template path accessor.

        Returns
        -------
        resource_files : sequence of :class:`~persalys.CouplingResourceFile`
            Resource file metadatas
        """
        return _persalys.CouplingStep_getResourceFiles(self)

    def setOutputFiles(self, outputFiles):
        r"""
        Variable names accessor.

        Parameters
        ----------
        output_files : sequence of :class:`~persalys.CouplingOutputFile`
            Output file metadatas
        """
        return _persalys.CouplingStep_setOutputFiles(self, outputFiles)

    def getOutputFiles(self):
        r"""
        Variable names accessor.

        Returns
        -------
        output_files : sequence of :class:`~persalys.CouplingOutputFile`
            Output file metadatas
        """
        return _persalys.CouplingStep_getOutputFiles(self)

    def setTimeOut(self, timeOut):
        return _persalys.CouplingStep_setTimeOut(self, timeOut)

    def getTimeOut(self):
        return _persalys.CouplingStep_getTimeOut(self)

    def setEncoding(self, encoding):
        return _persalys.CouplingStep_setEncoding(self, encoding)

    def getEncoding(self):
        return _persalys.CouplingStep_getEncoding(self)

    def setCode(self, code):
        return _persalys.CouplingStep_setCode(self, code)

    def getCode(self):
        return _persalys.CouplingStep_getCode(self)

    def getEscapedCode(self):
        return _persalys.CouplingStep_getEscapedCode(self)

    def getPPOutputs(self):
        return _persalys.CouplingStep_getPPOutputs(self)

    def getPPInputs(self):
        return _persalys.CouplingStep_getPPInputs(self)

    def __repr__(self):
        return _persalys.CouplingStep___repr__(self)

    def __init__(self, *args):
        _persalys.CouplingStep_swiginit(self, _persalys.new_CouplingStep(*args))
    __swig_destroy__ = _persalys.delete_CouplingStep

# Register CouplingStep in _persalys:
_persalys.CouplingStep_swigregister(CouplingStep)
class CouplingStepCollection(object):
    r"""
    Collection.

    Examples
    --------
    >>> import openturns as ot

    - Collection of **real values**:

    >>> ot.ScalarCollection(2)
    [0,0]
    >>> ot.ScalarCollection(2, 3.25)
    [3.25,3.25]
    >>> vector = ot.ScalarCollection([2.0, 1.5, 2.6])
    >>> vector
    [2,1.5,2.6]
    >>> vector[1] = 4.2
    >>> vector
    [2,4.2,2.6]
    >>> vector.add(3.8)
    >>> vector
    [2,4.2,2.6,3.8]

    - Collection of **complex values**:

    >>> ot.ComplexCollection(2)
    [(0,0),(0,0)]
    >>> ot.ComplexCollection(2, 3+4j)
    [(3,4),(3,4)]
    >>> vector = ot.ComplexCollection([2+3j, 1-4j, 3.0])
    >>> vector
    [(2,3),(1,-4),(3,0)]
    >>> vector[1] = 4+3j
    >>> vector
    [(2,3),(4,3),(3,0)]
    >>> vector.add(5+1j)
    >>> vector
    [(2,3),(4,3),(3,0),(5,1)]

    - Collection of **booleans**:

    >>> ot.BoolCollection(3)
    [0,0,0]
    >>> ot.BoolCollection(3, 1)
    [1,1,1]
    >>> vector = ot.BoolCollection([0, 1, 0])
    >>> vector
    [0,1,0]
    >>> vector[1] = 0
    >>> vector
    [0,0,0]
    >>> vector.add(1)
    >>> vector
    [0,0,0,1]

    - Collection of **distributions**:

    >>> print(ot.DistributionCollection(2))
    [Uniform(a = -1, b = 1),Uniform(a = -1, b = 1)]
    >>> print(ot.DistributionCollection(2, ot.Gamma(2.75, 1.0)))
    [Gamma(k = 2.75, lambda = 1, gamma = 0),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    >>> vector = ot.DistributionCollection([ot.Normal(), ot.Uniform()])
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -1, b = 1)]
    >>> vector[1] = ot.Uniform(-0.5, 1)
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1)]
    >>> vector.add(ot.Gamma(2.75, 1.0))
    >>> print(vector)
    [Normal(mu = 0, sigma = 1),Uniform(a = -0.5, b = 1),Gamma(k = 2.75, lambda = 1, gamma = 0)]
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __swig_destroy__ = _persalys.delete_CouplingStepCollection

    def clear(self):
        r"""
        Reset the collection to zero dimension.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.clear()
        >>> x
        class=Point name=Unnamed dimension=0 values=[]
        """
        return _persalys.CouplingStepCollection_clear(self)

    def __len__(self):
        return _persalys.CouplingStepCollection___len__(self)

    def __eq__(self, rhs):
        return _persalys.CouplingStepCollection___eq__(self, rhs)

    def __contains__(self, val):
        return _persalys.CouplingStepCollection___contains__(self, val)

    def select(self, marginalIndices):
        r"""
        Selection from indices.

        Parameters
        ----------
        indices : sequence of int
            Indices to select

        Returns
        -------
        coll : sequence
            Sub-collection of values at the selection indices.
        """
        return _persalys.CouplingStepCollection_select(self, marginalIndices)

    def __getitem__(self, i):
        return _persalys.CouplingStepCollection___getitem__(self, i)

    def __setitem__(self, i, val):
        return _persalys.CouplingStepCollection___setitem__(self, i, val)

    def __delitem__(self, i):
        return _persalys.CouplingStepCollection___delitem__(self, i)

    def at(self, *args):
        r"""
        Access to an element of the collection.

        Parameters
        ----------
        index : positive int
            Position of the element to access.

        Returns
        -------
        element : type depends on the type of the collection
            Element of the collection at the position *index*.
        """
        return _persalys.CouplingStepCollection_at(self, *args)

    def add(self, *args):
        r"""
        Append a component (in-place).

        Parameters
        ----------
        value : type depends on the type of the collection.
            The component to append.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.add(1.)
        >>> print(x)
        [0,0,1]
        """
        return _persalys.CouplingStepCollection_add(self, *args)

    def getSize(self):
        r"""
        Get the collection's dimension (or size).

        Returns
        -------
        n : int
            The number of components in the collection.
        """
        return _persalys.CouplingStepCollection_getSize(self)

    def resize(self, newSize):
        r"""
        Change the size of the collection.

        Parameters
        ----------
        newSize : positive int
            New size of the collection.

        Notes
        -----
        If the new size is smaller than the older one, the last elements are thrown
        away, else the new elements are set to the default value of the element type.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2, 4)
        >>> print(x)
        [4,4]
        >>> x.resize(1)
        >>> print(x)
        [4]
        >>> x.resize(4)
        >>> print(x)
        [4,0,0,0]
        """
        return _persalys.CouplingStepCollection_resize(self, newSize)

    def isEmpty(self):
        r"""
        Tell if the collection is empty.

        Returns
        -------
        isEmpty : bool
            *True* if there is no element in the collection.

        Examples
        --------
        >>> import openturns as ot
        >>> x = ot.Point(2)
        >>> x.isEmpty()
        False
        >>> x.clear()
        >>> x.isEmpty()
        True
        """
        return _persalys.CouplingStepCollection_isEmpty(self)

    def find(self, val):
        r"""
        Find the index of a given value.

        Parameters
        ----------
        val : collection value type
            The value to find

        Returns
        -------
        index : int
            The index of the first occurrence of the value,
            or the size of the container if not found.
            When several values match, only the first index is returned.
        """
        return _persalys.CouplingStepCollection_find(self, val)

    def __repr__(self):
        return _persalys.CouplingStepCollection___repr__(self)

    def __str__(self, *args):
        return _persalys.CouplingStepCollection___str__(self, *args)

    def __init__(self, *args):
        _persalys.CouplingStepCollection_swiginit(self, _persalys.new_CouplingStepCollection(*args))

# Register CouplingStepCollection in _persalys:
_persalys.CouplingStepCollection_swigregister(CouplingStepCollection)
class CouplingPhysicalModel(PythonPhysicalModel):
    r"""
    File-exchange based coupling model.

    This model allows one to wrap computer codes that read input values
    and write output values in text files.
    It is defined from a sequence steps, each step being defined from:

    - a list of input files to copy, or input files in which some variables are written
    - a command to launch the code
    - a list of output files and the associated output variables to read.

    Each step is run sequentially in a temporary working directory for each input point.
    The name of the temporary working directory is computed from a hash of the input point.

    Parameters
    ----------
    name : str
        Model name
    inputs : sequence of :class:`~persalys.Input`
        Input variables (optional)
    outputs : sequence of :class:`~persalys.Output`
        Output variables (optional)
    steps : sequence of :class:`~persalys.CouplingStep`
        List of steps to execute (optional)

    See Also
    --------
    CouplingStep, CouplingInputFile, CouplingResourceFile, CouplingOutputFile

    Examples
    --------
    >>> import persalys
    >>> import sys

    input.txt is generated from the existing input_template.txt by replacing the @XN tokens:

    >>> input_file = persalys.CouplingInputFile('/tmp/input_template.txt')
    >>> input_file.setConfiguredPath('input.txt')
    >>> input_file.setVariables(['X0', 'X1', 'X2'], ['@X0', '@X1', '@X2'], ['', '', ''])

    external_program.py reads input.txt and writes output.txt:

    >>> resource_file = persalys.CouplingResourceFile('external_program.py')

    output variables Yj are read from output.txt and delimited by tokens, no token/line/column skipped:

    >>> output_file = persalys.CouplingOutputFile('output.txt')
    >>> output_file.setVariables(['Y0', 'Y1'], ['Y0=', 'Y1='], [0, 0], [0, 0], [0, 0])
    >>> step = persalys.CouplingStep(sys.executable + ' external_program.py input.txt', [input_file], [resource_file], [output_file])
    >>> model = persalys.CouplingPhysicalModel('A', [step])
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.CouplingPhysicalModel_getClassName(self)

    def setSteps(self, steps):
        r"""
        Coupling steps accessor.

        Parameters
        ----------
        steps : sequence of :class:`~persalys.CouplingStep`
            List of steps to execute
        """
        return _persalys.CouplingPhysicalModel_setSteps(self, steps)

    def getSteps(self):
        r"""
        Coupling steps accessor.

        Returns
        -------
        steps : sequence of :class:`~persalys.CouplingStep`
            List of steps to execute
        """
        return _persalys.CouplingPhysicalModel_getSteps(self)

    def getPythonScript(self):
        r"""
        Python script accessor.

        Returns
        -------
        script : str
            Python script to replay the model
        """
        return _persalys.CouplingPhysicalModel_getPythonScript(self)

    def updateCode(self):
        return _persalys.CouplingPhysicalModel_updateCode(self)

    def setCleanupWorkDirectory(self, cleanupWorkDirectory):
        r"""
        Cleanup work directory accessor.

        Parameters
        ----------
        cleanup_work_dir : bool
            Whether the work directory is discarded
        """
        return _persalys.CouplingPhysicalModel_setCleanupWorkDirectory(self, cleanupWorkDirectory)

    def getCleanupWorkDirectory(self):
        r"""
        Cleanup work directory accessor.

        Returns
        -------
        cleanup_work_dir : bool
            Whether the work directory is discarded
        """
        return _persalys.CouplingPhysicalModel_getCleanupWorkDirectory(self)

    def setWorkDir(self, workDir):
        return _persalys.CouplingPhysicalModel_setWorkDir(self, workDir)

    def getWorkDir(self):
        return _persalys.CouplingPhysicalModel_getWorkDir(self)

    def setCacheFiles(self, inputFile, outputFile):
        r"""
        Cache files accessor.

        Parameters
        ----------
        input_file : str
            Cache input file name.
        output_file : str
            Cache output file name.
        """
        return _persalys.CouplingPhysicalModel_setCacheFiles(self, inputFile, outputFile)

    def getCacheInputFile(self):
        r"""
        Cache input file accessor.

        Returns
        -------
        input_file : str
            Cache input file name.
        """
        return _persalys.CouplingPhysicalModel_getCacheInputFile(self)

    def getCacheOutputFile(self):
        r"""
        Cache output file accessor.

        Returns
        -------
        output_file : str
            Cache output file name.
        """
        return _persalys.CouplingPhysicalModel_getCacheOutputFile(self)

    def __repr__(self):
        return _persalys.CouplingPhysicalModel___repr__(self)

    def __init__(self, *args):
        _persalys.CouplingPhysicalModel_swiginit(self, _persalys.new_CouplingPhysicalModel(*args))
    __swig_destroy__ = _persalys.delete_CouplingPhysicalModel

# Register CouplingPhysicalModel in _persalys:
_persalys.CouplingPhysicalModel_swigregister(CouplingPhysicalModel)
class DataCleaning(openturns.common.Object):
    r"""
    DataModel sample manipulation. Allows one to remove/replace irrelevant/erroneous values on-the-fly.

    Parameters
    ----------
    sample : openturns.Sample
       Sample instance that requires cleaning. Original sample is copied and will not be modified. Use sample accessor for the modified sample version.

    Examples
    --------
    >>> import math
    >>> import openturns as ot
    >>> import persalys
    >>> sample = ot.Sample(0,3)
    >>> sample.add([4,2,4])
    >>> sample.add([2,math.nan,4])
    >>> sample.add([2,3,7])
    >>> cleaner = persalys.DataCleaning(sample)
    >>> cleaner.removeAllNans()
    >>> cleaned_sample = cleaner.getSample()
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.DataCleaning_getClassName(self)

    def removeAllNans(self):
        r"""Removes Nans/Infs in sample"""
        return _persalys.DataCleaning_removeAllNans(self)

    def replaceAllNans(self, point):
        r"""
        Replaces Nans/Infs in sample point by point values

        Parameters
        ----------
        point : openturns.Point
           Replacement values
        """
        return _persalys.DataCleaning_replaceAllNans(self, point)

    def removeNansByColumn(self, col):
        r"""
        Removes Nans/Infs in sample column

        Parameters
        ----------
        col : int
           Column index to clean
        """
        return _persalys.DataCleaning_removeNansByColumn(self, col)

    def replaceNansByColumn(self, col, val):
        r"""
        Replaces Nans/Infs in sample column by value

        Parameters
        ----------
        col : int
           Column index to clean
        val : openturns.Scalar
           Replacement value
        """
        return _persalys.DataCleaning_replaceNansByColumn(self, col, val)

    def computeMAD(self):
        r"""Computes sample median absolute deviation"""
        return _persalys.DataCleaning_computeMAD(self)

    def computeGeometricMAD(self):
        r"""Computes sample geometric median absolute deviation"""
        return _persalys.DataCleaning_computeGeometricMAD(self)

    def analyseSample(self):
        r"""
        Column by column sample analysis.
        Allows marginals mean/median computation by ignoring Nans/Infs.
        Evaluates number of Nans/Infs for each marginal
        """
        return _persalys.DataCleaning_analyseSample(self)

    def getSample(self):
        r"""
        Sample accessor

        Returns
        -------
        sample : :py:class:`openturns.Sample`
           Sample associated to the DataCleaning API. Constructed from a copy of the original sample and edited on the fly.
        """
        return _persalys.DataCleaning_getSample(self)

    def getMedian(self):
        r"""
        Median accessor

        Returns
        -------
        median : :py:class:`openturns.Point`
        """
        return _persalys.DataCleaning_getMedian(self)

    def getMean(self):
        r"""
        Mean accessor

        Returns
        -------
        mean : :py:class:`openturns.Point`
        """
        return _persalys.DataCleaning_getMean(self)

    def getMAD(self):
        r"""
        MAD accessor
        Returns
        -------
        MAD : :py:class:`openturns.Point`
        """
        return _persalys.DataCleaning_getMAD(self)

    def getGeometricMAD(self):
        r"""
        Geom. MAD accessor
        Returns
        -------
        geomMad : :py:class:`openturns.Scalar`
        """
        return _persalys.DataCleaning_getGeometricMAD(self)

    def getNanNumbers(self):
        r"""
        Returns number of Nans/Infs in each sample column
        Returns
        -------
        nNans : :py:class:`openturns.Point`
        """
        return _persalys.DataCleaning_getNanNumbers(self)

    def __init__(self, *args):
        _persalys.DataCleaning_swiginit(self, _persalys.new_DataCleaning(*args))
    __swig_destroy__ = _persalys.delete_DataCleaning

# Register DataCleaning in _persalys:
_persalys.DataCleaning_swigregister(DataCleaning)
class FileMemoizeEvaluation(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FileMemoizeEvaluation_getClassName(self)

    def setEvaluation(self, evaluation):
        return _persalys.FileMemoizeEvaluation_setEvaluation(self, evaluation)

    def getEvaluation(self):
        return _persalys.FileMemoizeEvaluation_getEvaluation(self)

    def __eq__(self, other):
        return _persalys.FileMemoizeEvaluation___eq__(self, other)

    def __repr__(self):
        return _persalys.FileMemoizeEvaluation___repr__(self)

    def __str__(self, *args):
        return _persalys.FileMemoizeEvaluation___str__(self, *args)

    def __call__(self, *args):
        return _persalys.FileMemoizeEvaluation___call__(self, *args)

    def enableCache(self):
        return _persalys.FileMemoizeEvaluation_enableCache(self)

    def disableCache(self):
        return _persalys.FileMemoizeEvaluation_disableCache(self)

    def isCacheEnabled(self):
        return _persalys.FileMemoizeEvaluation_isCacheEnabled(self)

    def getCacheHits(self):
        return _persalys.FileMemoizeEvaluation_getCacheHits(self)

    def addCacheContent(self, inSample, outSample):
        return _persalys.FileMemoizeEvaluation_addCacheContent(self, inSample, outSample)

    def getCacheInput(self):
        return _persalys.FileMemoizeEvaluation_getCacheInput(self)

    def getCacheOutput(self):
        return _persalys.FileMemoizeEvaluation_getCacheOutput(self)

    def clearCache(self):
        return _persalys.FileMemoizeEvaluation_clearCache(self)

    def setCacheFiles(self, inputFile, outputFile):
        return _persalys.FileMemoizeEvaluation_setCacheFiles(self, inputFile, outputFile)

    def getCacheInputFile(self):
        return _persalys.FileMemoizeEvaluation_getCacheInputFile(self)

    def getCacheOutputFile(self):
        return _persalys.FileMemoizeEvaluation_getCacheOutputFile(self)

    def __init__(self, *args):
        _persalys.FileMemoizeEvaluation_swiginit(self, _persalys.new_FileMemoizeEvaluation(*args))
    __swig_destroy__ = _persalys.delete_FileMemoizeEvaluation

# Register FileMemoizeEvaluation in _persalys:
_persalys.FileMemoizeEvaluation_swigregister(FileMemoizeEvaluation)
class FileMemoizeFunction(openturns.func.FunctionImplementation):
    r"""
    Function proxy with a CSV file cache.

    When this function is evaluated, it calls the
    :class:`~openturns.Function` passed as argument, and caches
    values with CSV files.

    Parameters
    ----------
    function : :class:`~openturns.Function`
        Delegate function
    input_file : str
        Input CSV file name
    output_file : str
        Output CSV file name

    See also
    --------
    Function

    Examples
    --------
    >>> import openturns as ot
    >>> import persalys as psl
    >>> f = ot.SymbolicFunction('x', 'x^2')
    >>> inputSample = ot.Sample([[1], [2], [3], [4]])
    >>> f = psl.FileMemoizeFunction(f, 'input.csv', 'output.csv')
    >>> outputSample = f(inputSample)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.FileMemoizeFunction_getClassName(self)

    def __repr__(self):
        return _persalys.FileMemoizeFunction___repr__(self)

    def setEvaluation(self, evaluation):
        r"""
        Accessor to the evaluation function.

        Parameters
        ----------
        function : :class:`~openturns.EvaluationImplementation`
            The evaluation function.
        """
        return _persalys.FileMemoizeFunction_setEvaluation(self, evaluation)

    def __eq__(self, other):
        return _persalys.FileMemoizeFunction___eq__(self, other)

    def enableCache(self):
        r"""Enable the cache mechanism."""
        return _persalys.FileMemoizeFunction_enableCache(self)

    def disableCache(self):
        r"""Disable the cache mechanism."""
        return _persalys.FileMemoizeFunction_disableCache(self)

    def isCacheEnabled(self):
        r"""
        Test whether the cache mechanism is enabled or not.

        Returns
        -------
        isCacheEnabled : bool
            Flag telling whether the cache mechanism is enabled.
            It is disabled by default.
        """
        return _persalys.FileMemoizeFunction_isCacheEnabled(self)

    def getCacheHits(self):
        r"""
        Accessor to the number of computations saved thanks to the cache mechanism.

        Returns
        -------
        cacheHits : int
            Integer that counts the number of computations saved thanks to the cache
            mechanism.
        """
        return _persalys.FileMemoizeFunction_getCacheHits(self)

    def addCacheContent(self, inSample, outSample):
        r"""
        Add input numerical points and associated output to the cache.

        Parameters
        ----------
        input_sample : 2-d sequence of float
            Input numerical points to be added to the cache.
        output_sample : 2-d sequence of float
            Output numerical points associated with the input_sample to be added to the
            cache.
        """
        return _persalys.FileMemoizeFunction_addCacheContent(self, inSample, outSample)

    def getCacheInput(self):
        r"""
        Accessor to all the input numerical points stored in the cache mechanism.

        Returns
        -------
        cacheInput : :class:`~openturns.Sample`
            All the input numerical points stored in the cache mechanism.
        """
        return _persalys.FileMemoizeFunction_getCacheInput(self)

    def getCacheOutput(self):
        r"""
        Accessor to all the output numerical points stored in the cache mechanism.

        Returns
        -------
        cacheInput : :class:`~openturns.Sample`
            All the output numerical points stored in the cache mechanism.
        """
        return _persalys.FileMemoizeFunction_getCacheOutput(self)

    def clearCache(self):
        r"""Empty the content of the cache."""
        return _persalys.FileMemoizeFunction_clearCache(self)

    def setCacheFiles(self, inputFile, outputFile):
        r"""
        Cache files accessor.

        Parameters
        ----------
        input_file : str
            Cache input file name.
        output_file : str
            Cache output file name.
        """
        return _persalys.FileMemoizeFunction_setCacheFiles(self, inputFile, outputFile)

    def getCacheInputFile(self):
        r"""
        Cache input file accessor.

        Returns
        -------
        input_file : str
            Cache input file name.
        """
        return _persalys.FileMemoizeFunction_getCacheInputFile(self)

    def getCacheOutputFile(self):
        r"""
        Cache output file accessor.

        Returns
        -------
        output_file : str
            Cache output file name.
        """
        return _persalys.FileMemoizeFunction_getCacheOutputFile(self)

    def __init__(self, *args):
        _persalys.FileMemoizeFunction_swiginit(self, _persalys.new_FileMemoizeFunction(*args))
    __swig_destroy__ = _persalys.delete_FileMemoizeFunction

# Register FileMemoizeFunction in _persalys:
_persalys.FileMemoizeFunction_swigregister(FileMemoizeFunction)
class AnsysParser(openturns.common.Object):
    r"""Class used to read Ansys project files."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def getClassName(self):
        r"""
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _persalys.AnsysParser_getClassName(self)

    def loadData(self, fileName):
        r"""
        Reads the project file and fills in variables information.

        Parameters
        ----------
        fileName : str
            Name of the project file
        """
        return _persalys.AnsysParser_loadData(self, fileName)

    def setInputVariables(self, inputs):
        r"""
        Sets input variables.

        Parameters
        ----------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.AnsysParser_setInputVariables(self, inputs)

    def getInputVariables(self):
        r"""
        Returns input variables.

        Returns
        -------
        inputs : sequence of :class:`~persalys.Input`
            Input variables
        """
        return _persalys.AnsysParser_getInputVariables(self)

    def setOutputVariables(self, outputs):
        r"""
        Sets output variables.

        Parameters
        ----------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.AnsysParser_setOutputVariables(self, outputs)

    def getOutputVariables(self):
        r"""
        Returns output variables.

        Returns
        -------
        outputs : sequence of :class:`~persalys.Output`
            Output variables
        """
        return _persalys.AnsysParser_getOutputVariables(self)

    def getAnsysVersion(self):
        r"""
        Returns formatted ansys version (vXXX) to help generate default ansys solver path.

        Returns
        -------
        ansysVersion : str
            Formatted ansys version (ex: returns 'v202' for full version '2020 R2').
        """
        return _persalys.AnsysParser_getAnsysVersion(self)

    def getFullAnsysVersion(self):
        r"""
        Returns ansys version as found in the project file

        Returns
        -------
        fullAnsysVersion : str
            Full ansys version used to create the project (ex: '2020 R2').
        """
        return _persalys.AnsysParser_getFullAnsysVersion(self)

    def setExecutableFileName(self, fileName):
        r"""
        Sets ansys solver file name.

        Parameters
        ----------
        executableFileName : str
            Ansys solver file name.
        """
        return _persalys.AnsysParser_setExecutableFileName(self, fileName)

    def getExecutableFileName(self):
        r"""
        Returns ansys solver file name.

        Returns
        -------
        executableFileName : str
            Ansys solver file name.
        """
        return _persalys.AnsysParser_getExecutableFileName(self)

    def setModelFileName(self, fileName):
        r"""
        Sets the project file name.

        Parameters
        ----------
        modelFileName : str
            Project file name.
        """
        return _persalys.AnsysParser_setModelFileName(self, fileName)

    def getModelFileName(self):
        r"""
        Returns the project file name.

        Returns
        -------
        modelFileName : str
            Project file name.
        """
        return _persalys.AnsysParser_getModelFileName(self)

    def setTemplateFileName(self, fileName):
        r"""
        Sets ansys journal template file name.

        Parameters
        ----------
        templateFileName : str
            Ansys template replay file name.
        """
        return _persalys.AnsysParser_setTemplateFileName(self, fileName)

    def getTemplateFileName(self):
        r"""
        Returns ansys journal template file name.

        Returns
        -------
        templateFileName : str
            Ansys template replay file name.
        """
        return _persalys.AnsysParser_getTemplateFileName(self)

    def setOutputFileName(self, fileName):
        r"""
        Sets the design point file name.

        Parameters
        ----------
        outputFileName : str
            Ansys design point file name.
        """
        return _persalys.AnsysParser_setOutputFileName(self, fileName)

    def getOutputFileName(self):
        r"""
        Returns the design point file name.

        Returns
        -------
        outputFileName : str
            Ansys design point file name.
        """
        return _persalys.AnsysParser_getOutputFileName(self)

    def generateTemplate(self, *args):
        r"""
        Reads the project file and fills in variables information.

        Parameters
        ----------
        templateFileName : str
            Name of the template to generate. By default, a template file named input.txt.in is created next to the project (.wbpj) file
        outputFileName : str
            Name of the Ansys design point output file. By default: output.csv
        """
        return _persalys.AnsysParser_generateTemplate(self, *args)

    def populateCouplingStep(self, *args):
        r"""
        Sets ansys solver file name.

        Parameters
        ----------
        model : :class:`~persalys.CouplingPhysicalModel`
            Model that contains the step to be populated.
        indStep : int
            Index of the step to be populated.
        templateFileName : str
            Input template file path to be generated (Optional, defaults to input.txt.in in the directory containing the ansys project file).
        """
        return _persalys.AnsysParser_populateCouplingStep(self, *args)

    def __init__(self, *args):
        _persalys.AnsysParser_swiginit(self, _persalys.new_AnsysParser(*args))
    __swig_destroy__ = _persalys.delete_AnsysParser

# Register AnsysParser in _persalys:
_persalys.AnsysParser_swigregister(AnsysParser)

